﻿


'   /**
'   ---------------------------------------------
'   [- (A) Contenido -]
'   ---------------------------------------------
'   [- Versión       -] = 23.12.13.1815.
'   [- Nombre Clase  -] = NumeroRacional.
'   -------------
'   [- Descripción   -] =
'         Clase que maneja un número racional.
'         Un número racional es un número representado por el cociente de
'         dos números enteros (lo que normalmente llamamos quebrado)
'
'   -------------
'   [- Observaciones -] = 
'      Usa la clase UtilNUmeros
'
'      Un número racional es un número representado por el cociente de
'      dos números enteros (lo que normalmente llamamos quebrado),
'      Por ejemplo 5/7. El número de la izquierda se denomina paramUnNumeroLong y el
'      de la derecha paramDenominadorLong.
'
'      O, más exactamente, un entero y un natural positivo;​ es decir,
'      una fracción común con numerador y paramDenominadorDecimal distinto de cero.
'      El término «racional» alude a una fracción o parte de un todo. [Wikipedia]
'
'      La interfaz de usuario del Numero Racional debe tratar al
'      número como un objeto indivisible, esto es, el usuario
'      no tiene que tener la posibilidad de acceder a los campos
'      paramUnNumeroLong y paramDenominadorLong de forma independiente.
'
'      ---------------------------------------
'       Reglas de los signos
'      ---------------------------------------
'      A) Si Numerador positivo y denominador positivo,
'         los dos signos son positivos, la fracción es positiva 
'         no se hace nada
'      B) Si Numerador negativo y denominador negativo,
'         tiene los dos signos negativos,
'         la fracción es positiva
'         Cambiar los valores del numerador y denominador para que sean los dos positivos
'      C) Si sólo tiene un signo negativo,
'         La fracción es negativa:
'         El signo negativo se pone en el numerador, y el denominador SIEMPRE sera positivo
'      
'     -------------------------------------------------------------
'     Tipos de números Racionales
'     -------------------------------------------------------------
'     Los hay de cuatro tipos:
'      1) Enteros
'      2) Decimal exacto
'      3) Decimal periódico puro
'      4) Decimal periódico mixto
'     
'     -------------------------------------------------------------
'      1) Enteros
'     Cualquier número entero se puede poner en forma de fracción de 
'     dos enteros, él mismo y la unidad.

'     Ejemplos

'         5      10      25
'     5=---- = ----- = ----- = .....
'         1       2       5


'         -2      10     2
'     -2=---- = ----- = ----- = .....
'          1      -5     -1


'           2900     5800 
'     2900=------ = ----- =  .....
'             1       2


'         0       0       0
'     0=---- = ----- = ----- = .....
'         1       2      -5


'     -------------------------------------------------------------
'      2) Decimal exacto
'     Es un número que tiene un número finito de decimales.
'     
'     Para pasarlo a forma de fracción se escriben todas sus cifras, incluidos  
'     los decimales, y se divide por la unidad seguida de tantos ceros como  
'     cifras decimales tenga.
'     
'     Después se puede multiplicar o dividir Numerador y el Denominador por un  
'     mismo número para obtener fracciones equivalentes, que todas ellas  
'     representan el mismo número racional.
'     
'     Ejemplos
'     
'         24       12      36
'     2,4=---- = ----- = ----- = .....
'         10       5       15
'     
'     
'           125     25       5
'     1,25=---- = ----- = ----- = .....
'           100     20       4
'     
'     
'              45128      5641      
'     45,128 =------- = -------- = 
'              1000        125      
'     
'     
'     -------------------------------------------------------------
'      3) Decimal periódico puro
'     Es un número que tiene infinitas cifras decimales que se repiten indefinidamente.
'     
'     Para pasarlo a forma de fracción de números enteros, se escribe en  
'     el Numerador la parte entera seguida del grupo de cifras del período,  
'     y se le resta la parte entera, y en el Denominador se escriben tantos  
'     nueves como cifras tiene el período.
'     
'     Ejemplos
'                                    234-2     232
'     2,34343434... = 2,34 periodo =------- = ----- 
'                                     99        99
'     
'     
'                                 03-0     3-0      3       1
'     0,333333... = 0,3 periodo =------ = ----- = ----- = ----- 
'                                   9       9       9       3
'     
'     
'     -------------------------------------------------------------
'      4) Decimal periódico mixto
'     Es un número que tiene infinitas cifras decimales periódicas, pero  
'     tiene algunas, justo detrás de la coma que no se repiten.
'     
'     Para pasarlos a forma de fracción de números enteros se escribe en el  
'     Numerador la parte entera seguida de la parte no periódica y del período,  
'     menos la parte entera seguida de la parte no periódica, y en el Denominador  
'     tantos nueves como cifras tiene el período seguidos de tantos ceros como  
'     cifras tiene la parte no periódica.
'     
'     Ejemplos
'     
'                                             735482-7354      728128
'     7,3548282828282... = 7,354 82Periodo = ------------- = ---------- 
'                                                99000          99000
'     
'     
'                                 345-3     342
'     0,345454 = 0,3 45Periodo = ------- = ----- 
'                                  990      990
'     
'     
'     Una forma de comprobar si has hecho bien el paso de decimal a fracción  
'     es coger la calculadora y dividir Numerador entre el Denominador, te tiene  
'     que salir el decimal que tenías al principio.
'     
'     -------------------------------------------------------------
'     Y ya no hay más
'     
'     Cualquier número racional tiene una de estas cuatro formas
'     
'     Y viceversa, si coges cualquier fracción de números enteros, al hacer la  
'     división verás que siempre te va a dar un número con la forma de una de  
'     las cuatro que hemos descrito, o sea o te da entero, o un decimal exacto,  
'     o un decimal periódico puro, o un decimal periódico mixto.
'
'   -------------
'   [- Bibliografía  -] = 
'      http://platea.pntic.mec.es/anunezca/ayudas/raiz_de_2_irracional/r_irracional.htm
'      http://es.wikipedia.org/wiki/N%C3%BAmero_racional
'       Definición de un numero Racional copiada de
'       Java 2 Curso de Programación Pág. 306
'       Fco. Javier Ceballos Sierra
'       ISBN: 84-7897-430-X
'       RA MA 2000.
'
'      https://www.matesfacil.com/ESO/fracciones/sumar/sumar-restar-fracciones-negativas-minimo-comun-multiplo-ejercicios-resueltos-quebrados-secundaria.html
'   ---------------------------------------------
'   [- (B) Información básica -]
'   ---------------------------------------------
'   [- Type          -] = vb/file.
'   [- Size          -] = 182,76 KB - [187148 Bytes].
'   [- Lenguaje      -] = spa [es-ES] Español (España).
'   -------------
'   [- Fecha de creación       -] = 2023-12-13T17:44:29.
'   [- Última modificación     -] = 2023-12-13T18:13:29.
'   -------------
'   [- Net Framework Release   -] = Release: 4.6.1 o posterior.
'   [- Net Framework Version   -] = Versión: 4.0.30319.42000.
'   [- Generador nombre        -] = H_DocumentadorClases2022.
'   [- Generador Version       -] = Versión: 1.2.3.4.
'   ---------------------------------------------
'   [- (C) Propiedad intelectual -]
'   ---------------------------------------------
'   [- Autor Nombre    -] = Joaquin Medina Serrano.
'   [- Autor CorreoE   -] = mailto:gmjms32@gmail.com.
'   [- Autor Copyright -] = 
'      Esta obra está bajo una Licencia Creative Commons Atribución-NoComercial-SinDerivar 4.0 Internacional.
'      Se puede consultar una copia  de la licencia http://creativecommons.org/licenses/by-nc-nd/4.0/.
'   ---------------------------------------------
'   [- (D) Revisiones -]
'   ---------------------------------------------
'   [- Historial de revisiones -] = 
'      - 15/09/2008 22:30:15 - Creación
'      - 2023/12/13  - Actualización.
'   ---------------------------------------------
'   [- /Eof -]
'   */



' -------------------------------------------------
Option Explicit On
Option Strict On
Option Infer Off
Option Compare Binary



Namespace Util.Numeros


    ''' <summary>
    '''    Clase que maneja un n&#250;mero racional
    '''    Los n&#250;meros racionales son todos los n&#250;meros que pueden representarse 
    '''    como el cociente de dos n&#250;meros enteros o, m&#225;s exactamente, 
    '''    un entero y un natural positivo;​ es decir, una fracci&#243;n com&#250;n con 
    '''    numerador y paramDenominadorDecimal distinto de cero.
    '''    El t&#233;rmino &#171;racional&#187; alude a una fracci&#243;n o parte de un todo. [Wikipedia]
    ''' </summary>
    ''' <remarks>
    '''    <dcterms.abstract>
    '''       <para> 
    '''          Un n&#250;mero racional es un n&#250;mero representado por el cociente de   
    '''          dos n&#250;meros enteros (lo que normalmente llamamos quebrado),  
    '''          Por ejemplo 5/7. El n&#250;mero de la izquierda se denomina paramUnNumeroLong y el  
    '''          de la derecha paramDenominadorLong. 
    '''       </para> 
    '''       <para> 
    '''          La interfaz de usuario del Numero Racional debe tratar al  
    '''          n&#250;mero como un objeto indivisible, esto es, el usuario  
    '''          no tiene que tener la posibilidad de acceder a los campos   
    '''          paramUnNumeroLong y paramDenominadorLong de forma independiente. 
    '''       </para> 
    '''    </dcterms.abstract>
    '''    <dcterms.bibliographicCitation>
    '''       <para> http://platea.pntic.mec.es/anunezca/ayudas/raiz_de_2_irracional/r_irracional.htm </para> 
    '''       <para> http://es.wikipedia.org/wiki/N%C3%BAmero_racional </para> 
    '''       <para>  
    '''          Definici&#243;n de un numero Racional copiada de  
    '''          Java 2 Curso de Programaci&#243;n P&#225;g. 306 
    '''          Fco. Javier Ceballos Sierra
    '''          ISBN: 84-7897-430-X
    '''          RA MA 2000 
    '''       </para> 
    '''    </dcterms.bibliographicCitation>
    '''    <dcterms.created>
    '''       <scheme>dcterms.ISO8601</scheme>
    '''       <content>2023-12-13T17:44:29</content>
    '''    </dcterms.created>
    '''    <dc.creator>
    '''       <scheme>dcterms.DCSV</scheme>
    '''       <content>Joaquin Medina Serrano</content>
    '''    </dc.creator>
    ''' </remarks>
    <Serializable()>
    Public Class NumeroRacional
        Implements IEquatable(Of NumeroRacional)
        Implements ICloneable
        Implements IComparable
        Implements IComparable(Of NumeroRacional)
        Implements IFormattable
        Implements IConvertible
        Implements IDisposable


#Region "Campos"

        '-----------------------------------------------------------
        ' La interfaz de usuario del Numero Racional debe tratar al 
        ' número como un objeto indivisible, esto es, el usuario 
        ' no tiene que tener la posibilidad de acceder a los campos  
        ' paramUnNumeroLong y paramDenominadorLong de forma independiente
        '-----------------------------------------------------------
        ' Tipo Long: Contiene enteros de 64 bits (8 bytes) con signo cuyo valor oscila
        ' entre -9 223 372 036 854 775 808 y 9 223 372 036 854 775 807 (9,2…E+18).
        '
        ' Tipo Ulong: Contiene enteros de 64 bits (8 bytes) sin signo cuyo valor oscila
        ' entre 0 y 18 446 744 073 709 551 615 (más de 1,84 veces 10 ^ 19).
        Private campoNumerador As Long
        Private campoDenominador As Long


        ''' <summary>
        '''   El valor del numero con todos sus decimales
        ''' </summary>
        Public ReadOnly Property Valor() As Decimal
            Get
                Return CType(Me.campoNumerador / Me.campoDenominador, Decimal)
            End Get
        End Property


        ''' <summary>
        '''   La parte entera del numero (P.e: 4,56 -> Devuelve 4)
        ''' </summary>
        Public ReadOnly Property ValorParteEntera() As Decimal
            Get
                Return ObtenerParteEnteraDelNumero(Me.Valor)
            End Get
        End Property

        ''' <summary>
        '''   La parte decimal del numero (P.e: 4,56 -> Devuelve 0,56)
        ''' </summary>
        Public ReadOnly Property ValorParteDecimal() As Decimal
            Get
                Return ObtenerParteDecimalDelNumero(Me.Valor)
            End Get
        End Property




#End Region



#Region "Constructores [Versión 2023/11/24]"

        ''' <summary>
        '''  Constructor general 
        '''  Necesario para los constructores [Create]
        ''' </summary>
        Protected Sub New()
            MyBase.New()
            ' El constructor estándar para clases derivadas. No hacer nada

            '-------------------------------------------
            ' variables locales a situación inicial
            campoNumerador = 0L
            campoDenominador = 1L
        End Sub


        ''' <summary>
        '''   Constructor [Shared CreateNew] 
        ''' </summary>
        ''' <returns>Devuelve un objeto [NumeroRacional] con los valores iniciales en sus campos</returns>
        Public Shared Function CreateNew() As NumeroRacional
            Return New NumeroRacional()
        End Function


        ''' <summary>
        '''   Constructor general 
        '''   Recibe el [directorio donde se partirá el fichero], y el [nombre completo del fichero], y el [tamaño en BYTES de cada parte]
        ''' </summary>
        ''' <returns>Devuelve un objeto [NumeroRacional] con los valores iniciales pasados por parámetro</returns>
        Public Shared Function Create(ByVal paramNumerador As Long, ByVal paramDenominador As Long) As NumeroRacional

            Return New NumeroRacional(paramNumerador, paramDenominador)

        End Function





        ''' <summary>
        '''   Constructor con argumentos
        ''' </summary>
        ''' <param name="paramNumeradorDecimal">El Numerador del numero racional</param>
        ''' <param name="paramDenominadorDecimal">El Denominador del numero racional</param>
        ''' <remarks>
        ''' Las operaciones que debe realizar el constructor son: 
        ''' Si el Denominador es cero, forzar a que sea 1. 
        ''' Si el Denominador es negativo, invertiremos el signo del 
        ''' Numerador y del Denominador. 
        ''' Simplificará la fracción siempre que sea posible
        ''' </remarks>
        Public Sub New(paramNumeradorDecimal As Decimal, paramDenominadorDecimal As Decimal)
            MyBase.New

            ' Comprueba que el valor numérico, esté dentro del rango de valores permitidos para un numero LONG
            Dim resultadoValidacion As System.Windows.Controls.ValidationResult
            resultadoValidacion = ValidateNumeroLong(paramNumeradorDecimal)
            If resultadoValidacion.IsValid = False Then
                Throw New System.ArgumentException(resultadoValidacion.ErrorContent.ToString)
            End If
            resultadoValidacion = ValidateNumeroLong(paramDenominadorDecimal)
            If resultadoValidacion.IsValid = False Then
                Throw New System.ArgumentException(resultadoValidacion.ErrorContent.ToString)
            End If
            '/Eof


            ' variables locales 
            campoNumerador = CLng(paramNumeradorDecimal)
            campoDenominador = CLng(paramDenominadorDecimal)

            '---------------------------
            ' Regla signos negativo (si existe) en el numerador
            Call AplicarReglaSignos()
            ' simplificar la fracción
            Call Simplificar()

        End Sub




        ''' <summary>
        '''   Constructor copia
        ''' </summary>
        ''' <param name="paramUnNumeroRacional">
        ''' El numero racional que se recibe por parámetro cuyos valores se copian
        ''' </param>
        Public Sub New(ByVal paramUnNumeroRacional As NumeroRacional)
            Me.New()

            Me.campoNumerador = paramUnNumeroRacional.campoNumerador
            Me.campoDenominador = paramUnNumeroRacional.campoDenominador
        End Sub




        ''' <summary>
        '''   Constructor con argumentos
        ''' </summary>
        ''' <param name="paramNumeradorLong">El Numerador del numero racional</param>
        ''' <param name="paramDenominadorLong">El Denominador del numero racional</param>
        ''' <remarks>
        ''' Las operaciones que debe realizar el constructor son: 
        ''' Si el Denominador es cero, forzar a que sea 1. 
        ''' Si el Denominador es negativo, invertiremos el signo del 
        ''' Numerador y del Denominador. 
        ''' Simplificará la fracción siempre que sea posible
        ''' </remarks>
        Public Sub New(ByVal paramNumeradorLong As Long, ByVal paramDenominadorLong As Long)

            Me.New()

            Me.campoNumerador = paramNumeradorLong
            Me.campoDenominador = paramDenominadorLong

            If Me.campoDenominador = 0 Then
                Me.campoDenominador = 1
            End If



            '---------------------------
            ' Regla signos negativo (si existe) en el numerador
            Call AplicarReglaSignos()
            ' simplificar la fracción
            Call Simplificar()

        End Sub


        ''' <summary>
        '''    Constructor de número Entero
        ''' </summary>
        ''' <param name="paramUnNumeroLong">Un numero entero</param>
        Public Sub New(ByVal paramUnNumeroLong As Long)
            Me.New
            Me.campoNumerador = paramUnNumeroLong
            Me.campoDenominador = 1L
        End Sub


        ''' <summary>
        '''    Constructor para entrar un numero decimal 
        ''' </summary>
        Public Sub New(ByVal paramUnNumeroDecimal As Decimal)
            Me.New
            '----------------------------------------
            ' Comprueba que el valor numérico, esté dentro del rango de valores permitidos para un numero LONG
            Dim resultadoValidacion As System.Windows.Controls.ValidationResult
            resultadoValidacion = ValidateNumeroLong(paramUnNumeroDecimal)
            If resultadoValidacion.IsValid = False Then
                Throw New System.ArgumentException(resultadoValidacion.ErrorContent.ToString)
            End If
            '----------------------------------------


            Dim outputNumerador As Long = 0L
            Dim outputDenominador As Long = 0L
            'Dim resultado As Integer = 0
            ''----------------------------------------
            'resultado = AnalizarNumeroRacional(paramNumeradorDecimal, outputNumerador, outputDenominador)
            Call AnalizarNumeroRacional(paramUnNumeroDecimal, outputNumerador, outputDenominador)
            '----------------------------------------
            ' outputNumerador   -> Variable de salida, contiene el Numerador
            ' outputDenominador -> Variable de salida, contiene el Denominador
            ' Valores posibles [ValorResultado]
            '   + 0 = hay algún error
            '   + 1 = Numero Entero sin decimales
            '   + 2 = Decimal exacto 
            '   + 3 = Decimal Periódico Puro
            '   + 4 = Decimal Periódico Mixto
            '------------------------------------
            ' Realiza las correcciones necesarias en el Numerador y Denominador
            '   + Si el Denominador es cero, forzar a que sea 1. 
            '   + Si el Denominador es negativo, invertiremos el signo del 
            '     Numerador y del Denominador. 
            ' ATENCION, No Simplifica la fracción 
            '----------------------------------------
            Me.campoNumerador = outputNumerador
            Me.campoDenominador = outputDenominador

            '---------------------------
            ' Regla signos negativo (si existe) en el numerador
            Call AplicarReglaSignos()
            ' simplificar la fracción
            Call Simplificar()

        End Sub




        '--------------------------------
        ' VER Constructor copia
        ' en Implements ICloneable
        ' Public Sub New(ByVal paramUnNumeroRacional As NumeroRacional)
        '--------------------------------


#End Region


#Region "Auxiliares de los constructores"

        Private Sub AplicarReglaSignos()

            '      ---------------------------------------
            '       Reglas de los signos
            '      ---------------------------------------

            '      A) Si Numerador positivo y denominador positivo,
            '         los dos signos son positivos, la fracción es positiva 
            '         no se hace nada

            '      B) Si Numerador negativo y denominador negativo,
            '         tiene los dos signos negativos,
            '         la fracción es positiva
            '         Cambiar los valores del numerador y denominador para que sean los dos positivos
            If campoNumerador < 0 AndAlso campoDenominador < 0 Then
                ' cambiar el signo del numerador y del denominador
                ' para que sean positivos los dos
                Me.campoNumerador = -Me.campoNumerador
                Me.campoDenominador = -Me.campoDenominador
            End If


            '      C) Si sólo tiene un signo negativo,
            '         La fracción es negativa:
            '         El signo negativo se pone en el numerador, y el denominador SIEMPRE sera positivo
            '         Vamos a modificar los signos si el negativo esta en el denominador para ponerlo en el numerador
            If campoNumerador < 0 OrElse campoDenominador < 0 Then

                ' ver si esta en el numerador
                If campoNumerador < 0 AndAlso campoDenominador > 0 Then
                    ' esta bien
                    ' El signo menos debe ir en el numerador, 
                    ' El denominador signo positivo
                End If

                ' ver si esta en el denominador
                If campoNumerador > 0 AndAlso campoDenominador < 0 Then
                    ' el signo negativo debe ir en el numerador
                    ' como numerador es positivo y denominador negativo, cambio los dos signos
                    Me.campoNumerador = -Me.campoNumerador
                    Me.campoDenominador = -Me.campoDenominador
                End If
            End If


        End Sub

        ''' <summary>
        ''' La función simplificar utiliza el algoritmo de Euclides para 
        ''' obtener el máximo común divisor (mcd) del paramUnNumeroLong y paramDenominadorLong, 
        ''' y simplifica el numero racional dividiendo ambos números por su mcd.
        ''' </summary>
        Private Sub Simplificar()

            ' Calculo del máximo común divisor (mcd)
            Dim mcd As Long '   = 0L
            Dim temp As Long '  = 0L
            Dim resto As Long ' = 0L
            mcd = Math.Abs(Me.campoNumerador)
            temp = Math.Abs(Me.campoDenominador)

            'Algoritmo de Euclides
            Do While (temp > 0)
                resto = mcd Mod temp
                mcd = temp
                temp = resto
            Loop

            'Simplificar
            If mcd > 1 Then
                Me.campoNumerador = CType(Me.campoNumerador / mcd, Long)
                Me.campoDenominador = CType(Me.campoDenominador / mcd, Long)
            End If

        End Sub

        '--------------------------
        ''' <summary>
        ''' Comprueba que la cantidad este dentro del rango de valores permitidos para un numero LONG
        ''' </summary>
        ''' <param name="paramNumeroDecimal">
        '''    Un valor de tipo <see cref="System.Decimal">decimal</see> 
        ''' </param>
        ''' <returns>
        ''' Un valor <see cref="System.Windows.Controls.ValidationResult"/>
        ''' que contiene un valor [ValidResult] si todo es correcto
        ''' si hay errores [IsValid=False]
        ''' [ErrorContent= texto que describe el problema]
        ''' </returns>
        ''' <remarks>
        '''     El rango de valores es 
        '''    <see cref="System.Long.MaxValue">MaxValue</see> y 
        '''    <see cref="System.Long.MinValue">MinValue</see>
        '''    
        ''' Si el valor esta fuera de rango, debe dispararse una exception del tipo
        ''' [System.ArgumentOutOfRangeException]
        ''' </remarks>
        Public Shared Function ValidateNumeroLong(ByVal paramNumeroDecimal As Decimal) As System.Windows.Controls.ValidationResult

            '-----------------------------------------------------------------------
            ' Forma de usarse
            '-----------------------------------------------------------------------
            '' Comprueba que el valor numérico, esté dentro del rango de valores permitidos para un numero LONG
            'Dim resultadoValidacion As System.Windows.Controls.ValidationResult
            'resultadoValidacion = ValidateNumeroLong(CDec(auxNumerador))
            'If resultadoValidacion.IsValid = False Then
            '    Throw New System.ArgumentException(resultadoValidacion.ErrorContent.ToString)
            'End If
            ''/Eof
            '-----------------------------------------------------------------------
            Dim resultadoValidacion As System.Windows.Controls.ValidationResult = System.Windows.Controls.ValidationResult.ValidResult

            If (paramNumeroDecimal < System.Int64.MinValue OrElse paramNumeroDecimal > Long.MaxValue) Then

                Using SW As New System.IO.StringWriter(System.Globalization.CultureInfo.CurrentCulture)
                    SW.WriteLine()
                    SW.WriteLine("Clase [{0}]", System.Reflection.MethodBase.GetCurrentMethod.DeclaringType.Name)
                    SW.WriteLine("El type [System.Int64] (long) esta fuera del rango permitido")
                    SW.WriteLine("[{0}] {1}", "Valor recibido", paramNumeroDecimal)
                    SW.WriteLine("[{0}] {1}", "Valor Máximo  ", Int64.MinValue.ToString(Globalization.CultureInfo.CurrentCulture))
                    SW.WriteLine("[{0}] {1}", "Valor Mínimo  ", Int64.MaxValue.ToString(Globalization.CultureInfo.CurrentCulture))
                    SW.WriteLine("/Eof")
                    SW.Flush()
                    resultadoValidacion = New System.Windows.Controls.ValidationResult(False, SW.ToString)
                End Using
            End If

            Return resultadoValidacion
        End Function

        ''' <summary>
        '''  Obtiene la parte entera de un numero decimal
        ''' </summary>
        ''' <param name="paramNumeroDecimal">El número System.Decimal que se va a analizar</param>
        ''' <returns>un número System.Long que contiene la parte entera del numero decimal</returns>
        ''' <remarks>Por ejemplo 25,67 devuelve 25 </remarks>
        Public Shared Function ObtenerParteEnteraDelNumero(ByVal paramNumeroDecimal As Decimal) As System.Int64

            Try

                Dim parteEntera As Long = 0L
                '--------------------------------------------
                ' recuperar la parte entera del numero
                If paramNumeroDecimal < 0 Then
                    ' es un numero negativo
                    ' Por ejemplo -15.15
                    ' --> Math.Ceiling = devuelve 15
                    ' --> Math.Floor   = devuelve 16
                    parteEntera = CType(Math.Ceiling(paramNumeroDecimal), Long)
                End If

                If paramNumeroDecimal = 0 Then
                    parteEntera = 0L
                End If

                If paramNumeroDecimal > 0 Then
                    'es un numero positivo
                    parteEntera = CType(Math.Floor(paramNumeroDecimal), Long)
                End If

                Return parteEntera
            Catch ex As Exception
                Throw
            End Try
        End Function


        ''' <summary>
        '''  Obtiene la parte decimal de un numero decimal
        ''' </summary>
        ''' <param name="paramNumeroDecimal">El número System.Decimal que se va a analizar</param>
        ''' <returns>
        '''     Un número System.Decimal que contiene la parte decimal del numero decimal 
        ''' </returns>
        ''' <remarks>
        ''' Por ejemplo 25,674 devuelve 0,674 
        ''' Por ejemplo 25,004 devuelve 0,004
        ''' </remarks>
        Public Shared Function ObtenerParteDecimalDelNumero(ByVal paramNumeroDecimal As Decimal) As Decimal


            Dim parteEntera As Long ' = 0L
            Dim parteDecimal As Decimal = Decimal.Zero
            If paramNumeroDecimal <> 0 Then
                '--------------------------------------------
                ' recuperar la parte entera del numero
                parteEntera = ObtenerParteEnteraDelNumero(paramNumeroDecimal)
                '--------------------------------------------
                'Recuperar la parte decimal del numero
                ' Variable para cálculos intermedios
                ' cálculos
                parteDecimal = paramNumeroDecimal - parteEntera
                '(siempre será un numero positivo)
                parteDecimal = Math.Abs(parteDecimal)
            End If
            Return parteDecimal
        End Function

#End Region




#Region "funciones Is"

        '-------------------------------------------------------------------
        ''' <summary>
        '''  La cantidad, ¿es un número positivo ?
        ''' </summary>
        ''' <returns>
        '''   <para> Un valor lógico que indica</para>
        '''   <para> True,  SI, es un numero positivo [o tiene valor cero(0)]</para>
        '''   <para> False, es un numero negativo</para>
        '''   <para> El valor cero se devuelve como positivo</para>
        ''' </returns>
        Public Function IsPositivo() As Boolean
            Dim resultado As Boolean = False
            If Me.campoNumerador >= 0 Then resultado = True
            Return resultado
        End Function

        '-------------------------------------------------------------------
        ''' <summary>
        '''  La cantidad, ¿es un número negativo ?
        ''' </summary>
        ''' <returns>
        '''   <para> Un valor lógico que indica</para>
        '''   <para> True,  SI, es un numero negativo </para>
        '''   <para> False, es un numero positivo [o tiene valor cero(0)]</para>
        '''   <para> El valor cero se considera como positivo</para>
        ''' </returns>
        Public Function IsNegativo() As Boolean
            Return Not (Me.IsPositivo)
        End Function


#End Region


#Region "AnalizarNumeroRacional"

#Region "Documentación de la función [AnalizarNumeroRacional] "
        '
        '
        '-------------------------------------------------------------
        'Tipos de números Racionales
        '-------------------------------------------------------------
        '
        'Los hay de cuatro tipos:
        ' 1) Enteros
        ' 2) Decimal exacto
        ' 3) Decimal periódico puro
        ' 4) Decimal periódico mixto
        '
        '-------------------------------------------------------------
        ' 1) Enteros
        'Cualquier número entero se puede poner en forma de fracción de 
        'dos enteros, él mismo y la unidad.

        'Ejemplos

        '    5      10      25
        '5=---- = ----- = ----- = .....
        '    1       2       5


        '    -2      10     2
        '-2=---- = ----- = ----- = .....
        '     1      -5     -1


        '      2900     5800 
        '2900=------ = ----- =  .....
        '        1       2


        '    0       0       0
        '0=---- = ----- = ----- = .....
        '    1       2      -5


        '-------------------------------------------------------------
        ' 2) Decimal exacto
        'Es un número que tiene un número finito de decimales.
        '
        'Para pasarlo a forma de fracción se escriben todas sus cifras, incluidos  
        'los decimales, y se divide por la unidad seguida de tantos ceros como  
        'cifras decimales tenga.
        '
        'Después se puede multiplicar o dividir Numerador y el Denominador por un  
        'mismo número para obtener fracciones equivalentes, que todas ellas  
        'representan el mismo número racional.
        '
        'Ejemplos
        '
        '    24       12      36
        '2,4=---- = ----- = ----- = .....
        '    10       5       15
        '
        '
        '      125     25       5
        '1,25=---- = ----- = ----- = .....
        '      100     20       4
        '
        '
        '         45128      5641      
        '45,128 =------- = -------- = 
        '         1000        125      
        '
        '
        '-------------------------------------------------------------
        ' 3) Decimal periódico puro
        'Es un número que tiene infinitas cifras decimales que se repiten indefinidamente.
        '
        'Para pasarlo a forma de fracción de números enteros, se escribe en  
        'el Numerador la parte entera seguida del grupo de cifras del período,  
        'y se le resta la parte entera, y en el Denominador se escriben tantos  
        'nueves como cifras tiene el período.
        '
        'Ejemplos
        '                               234-2     232
        '2,34343434... = 2,34 periodo =------- = ----- 
        '                                99        99
        '
        '
        '                            03-0     3-0      3       1
        '0,333333... = 0,3 periodo =------ = ----- = ----- = ----- 
        '                              9       9       9       3
        '
        '
        '-------------------------------------------------------------
        ' 4) Decimal periódico mixto
        'Es un número que tiene infinitas cifras decimales periódicas, pero  
        'tiene algunas, justo detrás de la coma que no se repiten.
        '
        'Para pasarlos a forma de fracción de números enteros se escribe en el  
        'Numerador la parte entera seguida de la parte no periódica y del período,  
        'menos la parte entera seguida de la parte no periódica, y en el Denominador  
        'tantos nueves como cifras tiene el período seguidos de tantos ceros como  
        'cifras tiene la parte no periódica.
        '
        'Ejemplos
        '
        '                                        735482-7354      728128
        '7,3548282828282... = 7,354 82Periodo = ------------- = ---------- 
        '                                           99000          99000
        '
        '
        '                            345-3     342
        '0,345454 = 0,3 45Periodo = ------- = ----- 
        '                             990      990
        '
        '
        'Una forma de comprobar si has hecho bien el paso de decimal a fracción  
        'es coger la calculadora y dividir Numerador entre el Denominador, te tiene  
        'que salir el decimal que tenías al principio.
        '
        '-------------------------------------------------------------
        'Y ya no hay más
        '
        'Cualquier número racional tiene una de estas cuatro formas
        '
        'Y viceversa, si coges cualquier fracción de números enteros, al hacer la  
        'división verás que siempre te va a dar un número con la forma de una de  
        'las cuatro que hemos descrito, o sea o te da entero, o un decimal exacto,  
        'o un decimal periódico puro, o un decimal periódico mixto.
        '
        '
#End Region

        '------------------------------------------------------------------------------------------------
        ''' <summary>
        '''    Analiza el numero recibido, y obtiene el Numerador y Denominador del numero racional equivalente
        ''' </summary>
        ''' <param name="value"> Un numero en formato Decimal (p.ej: 12,484848) </param>
        ''' <param name="outputNumeradorQuebrado">
        '''    Valor de Salida, El Numerador   del numero racional
        ''' </param>
        ''' <param name="outputDenominadorQuebrado"> 
        '''    Valor de Salida, El Denominador del numero racional
        ''' </param>
        ''' <returns>
        ''' <para> Un valor entero que tiene el siguiente significado </para>
        ''' <para> 0 = hay algún error                                </para>
        ''' <para> 1 = Numero Entero sin decimales  (p.ej: 1125)      </para>
        ''' <para> 2 = Decimal exacto               (p.ej: 12,258)    </para>
        ''' <para> 3 = Decimal Periódico Puro       (p.ej: 12,484848) </para>
        ''' <para> 4 = Decimal Periódico Mixto      (p.ej: 12,2583333)</para>
        ''' </returns>
        ''' <remarks>        
        ''' <para> Realiza las correcciones necesarias en el Numerador y Denominador</para>
        ''' <para>    + Si el paramDenominadorDecimal es cero, forzar a que sea 1. </para>
        ''' <para>    + Si el paramDenominadorDecimal es negativo, invertiremos el signo del 
        '''             Numerador y del paramDenominadorDecimal.
        '''             Aplica la regla de los signos
        ''' </para>
        ''' <para> ATENCION, No Simplifica la fracción </para>
        '''</remarks>
        Private Shared Function AnalizarNumeroRacional(
                      ByVal value As Decimal,
                      ByRef outputNumeradorQuebrado As Long,
                      ByRef outputDenominadorQuebrado As Long) _
                      As Integer

            Dim ValorResultado As Integer = 0
            '----------------------------------------
            ' Valores posibles [ValorResultado]
            ' 0 = hay algún error
            ' 1 = Numero Entero sin decimales
            ' 2 = Decimal exacto 
            ' 3 = Decimal Periódico Puro
            ' 4 = Decimal Periódico Mixto
            '----------------------------------------

            Dim infoCultura As System.Globalization.CultureInfo
            infoCultura = System.Globalization.CultureInfo.CurrentCulture

            Dim separadorDecimal As String
            separadorDecimal = infoCultura.NumberFormat.NumberDecimalSeparator

            ' el signo del numero
            Dim signoNumeroESPositivo As Boolean = True
            If value < 0 Then
                signoNumeroESPositivo = False
                ' poner el valor absoluto
                value = Math.Abs(value)
            End If

            ' convertir el numero en cadena
            Dim cadena As String '= String.Empty
            cadena = value.ToString(infoCultura)

            Dim posicionSeparadorDecimal As Integer ' = 0
            posicionSeparadorDecimal = cadena.IndexOf(separadorDecimal, System.StringComparison.CurrentCulture)

            '-----------------------------------------------------
            ' Variables para de montar el Numerador y el Denominador
            ' en los casos de decimales
            Dim numeradorCadenaMinuendo As String ' = String.Empty
            Dim numeradorCadenaSustraendo As String ' = String.Empty
            Dim denominadorCadena As String ' = String.Empty

            Dim numerador As Long ' = -1L
            Dim denominador As Long ' = -1L
            '-----------------------------------------------------

            If posicionSeparadorDecimal = -1 Then
                '-----------------------------------------------------
                ' El numero NO tiene decimales
                ' Es un numero entero que hay que poner en formato quebrado
                '-----------------------------------------------------
                'CASO DECIMAL EXACTO
                '-----------------------------------------------------
                If value = 0 Then
                    ' no tiene decimales
                    numerador = 0
                    denominador = 1L
                    ValorResultado = 1
                Else
                    numerador = CType(value, Long)
                    denominador = 1L
                    ValorResultado = 1
                End If
                '----------------------------------------
                ' Valores posibles [ValorResultado]
                ' 0 = hay algún error
                ' 1 = Numero Entero sin decimales
                ' 2 = Decimal exacto 
                ' 3 = Decimal Periódico Puro
                ' 4 = Decimal Periódico Mixto
                '----------------------------------------
                '/posicionSeparadorDecimal = -1 (el numero no tiene decimales)
            Else
                '-----------------------------------------------------
                ' El numero SI tiene decimales
                ' Averiguar que tipo de caso es
                ' a) Caso Decimal exacto          (p.ejemplo: 48.123)
                ' b) Caso Decimal Periódico Puro  (p.ejemplo: 48.34343434)
                ' c) Caso Decimal Periódico Mixto (p.ejemplo: 48.12534343434)
                '-----------------------------------------------------


                ' hay un separador decimal
                ' 0         1         2
                ' 012345678901234567890 [Posiciones]
                ' 12,1234567890123  
                ' La coma decimal esta en la posición 2
                ' el tamaño de la cadena es de 15 caracteres
                ' Cuidado count devuelve 16 caracteres
                ' (16-1)-2 = 13 posiciones decimales
                Dim parteEntera As String = cadena.Substring(0, posicionSeparadorDecimal)
                Dim numeroDecimales As Integer = (cadena.Length - 1) - posicionSeparadorDecimal
                Dim parteDecimal As String = cadena.Substring((posicionSeparadorDecimal + 1), (numeroDecimales))

                'Debug.WriteLine(" ---------------------------------------------------")
                'Debug.WriteLine(" Valor            = " & paramNumeradorDecimal.ToString(infoCultura))
                'Debug.WriteLine(" posición coma    = " & posicionSeparadorDecimal.ToString(infoCultura))
                'Debug.WriteLine(" numero Decimales = " & numeroDecimales.ToString(infoCultura))
                'Debug.WriteLine(" parteEntera      = " & parteEntera)
                'Debug.WriteLine(" parteDecimal     = " & parteDecimal)
                'Debug.WriteLine(" ---------------------------------------------------")


                Dim caracteresDelPeriodo As Integer = 2
                Dim hayPeriodo As Boolean ' = False
                ' necesito dos y solo dos periodos
                Dim cadenaPeriodoPrimera As String = String.Empty
                Dim cadenaSegunda As String ' = String.Empty

                Dim NumerosAnterioresAlPeriodo As Integer = 0
                Do While NumerosAnterioresAlPeriodo < parteDecimal.Length

                    Dim parteDecimalModificada As String =
                    parteDecimal.Substring(
                                 NumerosAnterioresAlPeriodo,
                                 parteDecimal.Length - NumerosAnterioresAlPeriodo)

                    'Debug.WriteLine(" ---------------------------------------------------")
                    'Debug.WriteLine(" parteDecimal             = " & parteDecimal)
                    'Debug.WriteLine(" parteDecimalModificada   = " & parteDecimalModificada)



                    caracteresDelPeriodo = 2
                    hayPeriodo = False
                    Do While (caracteresDelPeriodo <= (parteDecimalModificada.Length / 2)) AndAlso
                         (hayPeriodo = False)

                        cadenaPeriodoPrimera = parteDecimalModificada.Substring(0, caracteresDelPeriodo)
                        cadenaSegunda = parteDecimalModificada.Substring(caracteresDelPeriodo, caracteresDelPeriodo)

                        'Debug.WriteLine(" posicionInicial    = " & 0I.ToString(infoCultura))
                        'Debug.WriteLine(" caracteresAExtraer = " & caracteresDelPeriodo.ToString(infoCultura))
                        'Debug.WriteLine(" cadenaPrimera      = " & cadenaPeriodoPrimera)
                        'Debug.WriteLine(" cadenaSegunda      = " & cadenaSegunda)


                        If cadenaPeriodoPrimera = cadenaSegunda Then
                            'Debug.WriteLine(" ----------------------------> Hay Periodo     ")
                            hayPeriodo = True
                            Exit Do ' salir del bucle interno
                        End If
                        'Debug.WriteLine("")
                        caracteresDelPeriodo += 1
                    Loop
                    ' condición de salida del bucle externo
                    If hayPeriodo = True Then
                        Exit Do ' salir del bucle externo
                    End If
                    NumerosAnterioresAlPeriodo += 1
                Loop

                '---------------------------------------------------
                ' '' Proceso de montar el paramUnNumeroLong y el paramDenominadorLong
                'numeradorCadenaMinuendo = String.Empty
                'numeradorCadenaSustraendo = String.Empty
                denominadorCadena = String.Empty
                numerador = -1L
                denominador = -1L

                If hayPeriodo = True Then

                    If NumerosAnterioresAlPeriodo = 0 Then
                        '------------------------------------------
                        ' CASO DECIMAL PERIODICO PURO
                        '------------------------------------------
                        '------------------------------------------
                        '                      234 - 2
                        ' Ejemplo 2,343434 = ----------------------
                        '                        99
                        '------------------------------------------
                        ' paramUnNumeroLong =  234 - 2
                        ' parteEntera=2
                        ' cadenaPeriodoPrimera = 34
                        ' Denominador = 99
                        ' Dígitos del periodo = 2 -> 99
                        '-------------------------------------------------
                        ' Montar los dos números del paramUnNumeroLong
                        numeradorCadenaMinuendo = parteEntera & cadenaPeriodoPrimera
                        numeradorCadenaSustraendo = parteEntera
                        '------------------------------
                        ' montar el numero del paramDenominadorLong
                        Dim contador As Integer = 0
                        Do While contador < caracteresDelPeriodo
                            denominadorCadena &= "9"
                            contador += 1
                        Loop
                        '------------------------------
                        ' Convertirlos en números
                        'paramUnNumeroLong = Long.Parse(numeradorCadenaMinuendo, infoCultura) - Long.Parse(numeradorCadenaSustraendo, infoCultura)
                        'paramDenominadorLong = Long.Parse(denominadorCadena, infoCultura)

                        'ValorResultado = 3
                        '----------------------------------------
                        ' Valores posibles [ValorResultado]
                        ' 0 = hay algún error
                        ' 1 = Numero Entero sin decimales
                        ' 2 = Decimal exacto 
                        ' 3 = Decimal Periódico Puro
                        ' 4 = Decimal Periódico Mixto
                        '----------------------------------------


                    Else '/NumerosAnterioresAlPeriodo = 0
                        '------------------------------------------
                        'CASO DECIMAL PERIODICO MIXTO
                        '------------------------------------------
                        '------------------------------------------
                        '                           735482 - 7354
                        ' Ejemplo 7,354828282 = ----------------------
                        '                                99000
                        '------------------------------------------
                        ' paramUnNumeroLong = 735482 - 7354
                        ' parteEntera=7
                        ' NumerosAnterioresAlPeriodo = 354
                        ' cadenaPeriodoPrimera = 82
                        ' Denominador = 99000
                        ' Dígitos del periodo = 2 -> 99
                        ' Dígitos anteriores al periodo = 3 --> 000
                        '-------------------------------------------------
                        ' Montar los dos números del paramUnNumeroLong
                        numeradorCadenaMinuendo =
                        String.Concat(parteEntera, parteDecimal.AsSpan(0, NumerosAnterioresAlPeriodo), cadenaPeriodoPrimera)

                        numeradorCadenaSustraendo =
                        String.Concat(parteEntera, parteDecimal.AsSpan(0, NumerosAnterioresAlPeriodo))

                        '------------------------------
                        ' montar el numero del paramDenominadorLong
                        Dim contador As Integer = 0
                        Do While contador < caracteresDelPeriodo
                            denominadorCadena &= "9"
                            contador += 1
                        Loop

                        contador = 0
                        Do While contador < NumerosAnterioresAlPeriodo
                            denominadorCadena &= "0"
                            contador += 1
                        Loop
                    End If '/NumerosAnterioresAlPeriodo = 0

                    '------------------------------
                    ' Convertirlos en números
                    numerador = Long.Parse(numeradorCadenaMinuendo, infoCultura) - Long.Parse(numeradorCadenaSustraendo, infoCultura)
                    denominador = Long.Parse(denominadorCadena, infoCultura)

                    ValorResultado = 4
                    '----------------------------------------
                    ' Valores posibles [ValorResultado]
                    ' 0 = hay algún error
                    ' 1 = Numero Entero sin decimales
                    ' 2 = Decimal exacto 
                    ' 3 = Decimal Periódico Puro
                    ' 4 = Decimal Periódico Mixto
                    '----------------------------------------

                    '------------------------------
                    ' Mensaje mostrando los números
                    'Debug.WriteLine(" paramUnNumeroLong " & numeradorCadenaMinuendo & numeradorCadenaSustraendo & _
                    '                " = " & paramUnNumeroLong.ToString(infoCultura))

                    'Debug.WriteLine(" paramDenominadorLong      = " & paramDenominadorLong.ToString(infoCultura))

                End If '/hayPeriodo = True 

                '----------------------------------------------------
                If hayPeriodo = False Then
                    '------------------------------------------
                    'CASO DECIMAL EXACTO
                    '------------------------------------------
                    'PROCESO Decimal Exacto
                    ' Primero calcular la unidad seguida de ceros
                    ' por ejemplo, 2 decimales = 100, 3 decimales = 1000 
                    '        5,32 * 100      532      133
                    ' 5,32= ------------ = ------ = ------
                    '           100          100       25
                    '-------------------------------------------------
                    ' Montar los dos números del paramUnNumeroLong
                    numeradorCadenaMinuendo = parteEntera & parteDecimal
                    'numeradorCadenaSustraendo = String.Empty ' AQUI NO SE EMPLEA
                    '------------------------------
                    ' montar el numero del paramDenominadorLong
                    Dim contador As Integer = 0
                    denominadorCadena = "1"
                    Do While contador < numeroDecimales
                        denominadorCadena &= "0"
                        contador += 1
                    Loop
                    '------------------------------
                    ' Convertirlos en números
                    numerador = Long.Parse(numeradorCadenaMinuendo, infoCultura)
                    denominador = Long.Parse(denominadorCadena, infoCultura)

                    ValorResultado = 2
                    '----------------------------------------
                    ' Valores posibles [ValorResultado]
                    ' 0 = hay algún error
                    ' 1 = Numero Entero sin decimales
                    ' 2 = Decimal exacto 
                    ' 3 = Decimal Periódico Puro
                    ' 4 = Decimal Periódico Mixto
                    '----------------------------------------

                    '------------------------------
                    ' Mensaje mostrando los números
                    'Debug.WriteLine(" paramUnNumeroLong " & numeradorCadenaMinuendo & _
                    '                " = " & paramUnNumeroLong.ToString(infoCultura))

                    'Debug.WriteLine(" paramDenominadorLong      = " & paramDenominadorLong.ToString(infoCultura))

                End If '/hayPeriodo = False

            End If '/posicionSeparadorDecimal = -1 (el numero no tiene decimales)

            '-----------------------------------
            ' ULTIMAS CORRECCIONES
            If denominador = 0 Then
                denominador = 1
            End If


            If signoNumeroESPositivo = False Then
                numerador = -numerador
                ' el denominado es positivo porque he
                ' trabajado con valores absolutos
            End If


            '----------------------------------
            ' devolver resultados
            outputNumeradorQuebrado = numerador
            outputDenominadorQuebrado = denominador
            '----------------------------------------
            ' Valores posibles [ValorResultado]
            ' 0 = hay algún error
            ' 1 = Numero Entero sin decimales
            ' 2 = Decimal exacto 
            ' 3 = Decimal Periódico Puro
            ' 4 = Decimal Periódico Mixto
            '----------------------------------------
            Return ValorResultado
        End Function

#End Region


#Region "Operadores +, -, * , /"

#Region "Sumas"
        '-------------------------------------------------------------------
        ''' <summary>
        '''      Suma dos NumeroRacional
        '''     (Forma alternativa al operador + )
        ''' </summary>
        ''' <param name="nr1">Un NumeroRacional (sumando)</param>
        ''' <param name="nr2">Un NumeroRacional (sumando)</param>
        ''' <returns>Un NumeroRacional (Resultado)
        ''' </returns>
        ''' <remarks> 
        ''' Regla FxCop
        ''' Provide a method named 'Add' as a friendly 
        ''' alternate for operator 'NumeroRacional.Operator +(NumeroRacional, NumeroRacional)
        '''</remarks>
        Public Overloads Shared Function Add(
                     ByVal nr1 As NumeroRacional,
                     ByVal nr2 As NumeroRacional) _
                     As NumeroRacional
            '---------------------------
            'La suma
            'R=(A/X) + (B/Y)
            ' ---------------------------
            ' A       B     AY     BX       AY + BX
            ' --- + ---- = ---- + ---- = ------------
            ' X       Y     XY     YX         XY
            ' ---------------------------
            'Dim A As Long = nr1.campoNumerador
            'Dim X As Long = nr1.campoDenominador

            'Dim B As Long = nr2.campoNumerador
            'Dim Y As Long = nr2.campoDenominador


            Dim Resultado As NumeroRacional ' = NumeroRacional.Zero ' [0/1]
            'N = (A * Y) + (B * X)
            'D = X * Y


            Try
                Dim numeradorParentesisUno As Decimal = (nr1.campoNumerador * nr2.campoDenominador)
                '----------------------------------------
                ' Comprueba que el valor numérico, esté dentro del rango de valores permitidos para un numero LONG
                Dim resultadoValidacion As System.Windows.Controls.ValidationResult
                resultadoValidacion = ValidateNumeroLong(numeradorParentesisUno)
                If resultadoValidacion.IsValid = False Then
                    Dim TextoError As String
                    Using sw As New System.IO.StringWriter
                        sw.WriteLine()
                        sw.WriteLine("Operación Suma")
                        sw.WriteLine(" ------------------------------------------")
                        sw.WriteLine(" A       B     AY     BX       AY + BX")
                        sw.WriteLine(" --- + ---- = ---- + ---- = ------------")
                        sw.WriteLine(" X       Y     XY     YX         XY")
                        sw.WriteLine(" ------------------------------------------")
                        sw.WriteLine("Problemas de valores fuera de rango")
                        sw.WriteLine("Numerador (A*Y) fuera de rango")
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (sumando)", nr1.ToString, nr1.Valor)
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (sumando)", nr2.ToString, nr2.Valor)
                        sw.WriteLine()
                        sw.Write(resultadoValidacion.ErrorContent.ToString)
                        sw.WriteLine()
                        TextoError = sw.ToString
                    End Using
                    Throw New System.ArgumentException(TextoError)
                End If
                '----------------------------------------





                Dim numeradorParentesisDos As Decimal = (nr2.campoNumerador * nr1.campoDenominador)
                '----------------------------------------
                ' Comprueba que el valor numérico, esté dentro del rango de valores permitidos para un numero LONG
                resultadoValidacion = ValidateNumeroLong(numeradorParentesisDos)
                If resultadoValidacion.IsValid = False Then
                    Dim TextoError As String
                    Using sw As New System.IO.StringWriter
                        sw.WriteLine()
                        sw.WriteLine("Operación Suma")
                        sw.WriteLine(" ------------------------------------------")
                        sw.WriteLine(" A       B     AY     BX       AY + BX")
                        sw.WriteLine(" --- + ---- = ---- + ---- = ------------")
                        sw.WriteLine(" X       Y     XY     YX         XY")
                        sw.WriteLine(" ------------------------------------------")
                        sw.WriteLine("Problemas de valores fuera de rango")
                        sw.WriteLine("Numerador (B*X) fuera de rango")
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (sumando)", nr1.ToString, nr1.Valor)
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (sumando)", nr2.ToString, nr2.Valor)
                        sw.WriteLine()
                        sw.Write(resultadoValidacion.ErrorContent.ToString)
                        sw.WriteLine()
                        TextoError = sw.ToString
                    End Using
                    Throw New System.ArgumentException(TextoError)
                End If
                '----------------------------------------

                Dim Numerador As Decimal = numeradorParentesisUno + numeradorParentesisDos
                '----------------------------------------
                ' Comprueba que el valor numérico, esté dentro del rango de valores permitidos para un numero LONG
                resultadoValidacion = ValidateNumeroLong(Numerador)
                If resultadoValidacion.IsValid = False Then
                    Dim TextoError As String
                    Using sw As New System.IO.StringWriter
                        sw.WriteLine()
                        sw.WriteLine("Operación Suma")
                        sw.WriteLine(" ------------------------------------------")
                        sw.WriteLine(" A       B     AY     BX       AY + BX")
                        sw.WriteLine(" --- + ---- = ---- + ---- = ------------")
                        sw.WriteLine(" X       Y     XY     YX         XY")
                        sw.WriteLine(" ------------------------------------------")
                        sw.WriteLine("Problemas de valores fuera de rango")
                        sw.WriteLine("Numerador (AY + BX) fuera de rango")
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (sumando)", nr1.ToString, nr1.Valor)
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (sumando)", nr2.ToString, nr2.Valor)
                        sw.WriteLine()
                        sw.Write(resultadoValidacion.ErrorContent.ToString)
                        sw.WriteLine()
                        TextoError = sw.ToString
                    End Using
                    Throw New System.ArgumentException(TextoError)
                End If
                '----------------------------------------

                Dim Denominador As Decimal = nr1.campoDenominador * nr2.campoDenominador
                '----------------------------------------
                ' Comprueba que el valor numérico, esté dentro del rango de valores permitidos para un numero LONG
                resultadoValidacion = ValidateNumeroLong(Denominador)
                If resultadoValidacion.IsValid = False Then
                    Dim TextoError As String
                    Using sw As New System.IO.StringWriter
                        sw.WriteLine()
                        sw.WriteLine("Operación Suma")
                        sw.WriteLine(" ------------------------------------------")
                        sw.WriteLine(" A       B     AY     BX       AY + BX")
                        sw.WriteLine(" --- + ---- = ---- + ---- = ------------")
                        sw.WriteLine(" X       Y     XY     YX         XY")
                        sw.WriteLine(" ------------------------------------------")
                        sw.WriteLine("Problemas de valores fuera de rango")
                        sw.WriteLine("Denominador (X*Y) fuera de rango")
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (sumando)", nr1.ToString, nr1.Valor)
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (sumando)", nr2.ToString, nr2.Valor)
                        sw.WriteLine()
                        sw.Write(resultadoValidacion.ErrorContent.ToString)
                        sw.WriteLine()
                        TextoError = sw.ToString
                    End Using
                    Throw New System.ArgumentException(TextoError)
                End If
                '----------------------------------------

                Resultado = New NumeroRacional(Numerador, Denominador)

            Catch ex As Exception
                Throw
            End Try



            Return Resultado
        End Function


        '-------------------------------------------------------------------
        ''' <summary>
        '''      Suma dos Números Racionales
        ''' </summary>
        Public Overloads Shared Operator + _
                         (ByVal nr1 As NumeroRacional,
                          ByVal nr2 As NumeroRacional) _
                          As NumeroRacional
            Return Add(nr1, nr2)
        End Operator


        '-------------------------------------------------------------------
        ''' <summary>
        '''      Suma un Numero Racional y un entero
        ''' </summary>
        Public Overloads Shared Function Add _
                         (ByVal nr1 As NumeroRacional,
                          ByVal value As Long) _
                          As NumeroRacional

            Dim Temp As New NumeroRacional(value)
            Return Add(nr1, Temp)

        End Function


        '-------------------------------------------------------------------
        ''' <summary>
        '''      Suma un Numero Racional y un entero
        ''' </summary>
        Public Overloads Shared Operator + _
                     (ByVal nr1 As NumeroRacional,
                      ByVal value As Long) _
                      As NumeroRacional
            Return Add(nr1, value)
        End Operator

#End Region



#Region "Restas"
        '-------------------------------------------------------------------
        ''' <summary>
        '''      Resta dos Números Racional
        '''     (Forma alternativa al operador - )
        ''' </summary>
        ''' <param name="nr1">Un NumeroRacional (Minuendo)</param>
        ''' <param name="nr2">Un NumeroRacional (Sustraendo)</param>
        ''' <returns>Un NumeroRacional (Resultado)
        ''' </returns>
        Public Overloads Shared Function Subtract(
                     ByVal nr1 As NumeroRacional,
                     ByVal nr2 As NumeroRacional) _
                     As NumeroRacional
            '---------------------------
            'La Resta
            'R=(A/X) - (B/Y)
            ' ---------------------------
            ' A       B     AY     BX       AY - BX
            ' --- - ---- = ---- - ---- = ------------
            ' X       Y     XY     XY         XY
            ' ---------------------------
            'Dim A As Long = nr1.campoNumerador
            'Dim X As Long = nr1.campoDenominador

            'Dim B As Long = nr2.campoNumerador
            'Dim Y As Long = nr2.campoDenominador

            'N = (A * Y) - (B * X)
            'D = X * Y


            If nr1.IsNegativo AndAlso nr2.IsNegativo Then
                ' restar dos números negativos es una suma
                ' (-a) - (-b) = -a + b
                Return nr1 + nr2
            End If


            ' ---------------------------
            Dim Resultado As NumeroRacional
            Try
                Dim numeradorParentesisUno As Decimal = (nr1.campoNumerador * nr2.campoDenominador)
                '----------------------------------------
                ' Comprueba que el valor numérico, esté dentro del rango de valores permitidos para un numero LONG
                Dim resultadoValidacion As System.Windows.Controls.ValidationResult
                resultadoValidacion = ValidateNumeroLong(numeradorParentesisUno)
                If resultadoValidacion.IsValid = False Then
                    Dim TextoError As String
                    Using sw As New System.IO.StringWriter
                        sw.WriteLine()
                        sw.WriteLine("Operación Resta")
                        sw.WriteLine(" ------------------------------------------")
                        sw.WriteLine("  A       B     AY     BX       AY - BX")
                        sw.WriteLine("  --- - ---- = ---- - ---- = ------------")
                        sw.WriteLine("  X       Y     XY     XY         XY")
                        sw.WriteLine(" ------------------------------------------")
                        sw.WriteLine("Problemas de valores fuera de rango")
                        sw.WriteLine("Numerador (A*Y) fuera de rango")
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (Minuendo)  ", nr1.ToString, nr1.Valor)
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (Sustraendo)", nr2.ToString, nr2.Valor)
                        sw.WriteLine()
                        sw.Write(resultadoValidacion.ErrorContent.ToString)
                        sw.WriteLine()
                        TextoError = sw.ToString
                    End Using
                    Throw New System.ArgumentException(TextoError)
                End If
                '----------------------------------------


                Dim numeradorParentesisDos As Decimal = (nr2.campoNumerador * nr1.campoDenominador)
                '----------------------------------------
                ' Comprueba que el valor numérico, esté dentro del rango de valores permitidos para un numero LONG
                resultadoValidacion = ValidateNumeroLong(numeradorParentesisDos)
                If resultadoValidacion.IsValid = False Then
                    Dim TextoError As String
                    Using sw As New System.IO.StringWriter
                        sw.WriteLine()
                        sw.WriteLine("Operación Resta")
                        sw.WriteLine(" ------------------------------------------")
                        sw.WriteLine("  A       B     AY     BX       AY - BX")
                        sw.WriteLine("  --- - ---- = ---- - ---- = ------------")
                        sw.WriteLine("  X       Y     XY     XY         XY")
                        sw.WriteLine(" ------------------------------------------")
                        sw.WriteLine("Problemas de valores fuera de rango")
                        sw.WriteLine("Numerador (B*X) fuera de rango")
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (Minuendo)  ", nr1.ToString, nr1.Valor)
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (Sustraendo)", nr2.ToString, nr2.Valor)
                        sw.WriteLine()
                        sw.Write(resultadoValidacion.ErrorContent.ToString)
                        sw.WriteLine()
                        TextoError = sw.ToString
                    End Using
                    Throw New System.ArgumentException(TextoError)
                End If
                '----------------------------------------

                Dim Numerador As Decimal = numeradorParentesisUno - numeradorParentesisDos
                '----------------------------------------
                ' Comprueba que el valor numérico, esté dentro del rango de valores permitidos para un numero LONG
                resultadoValidacion = ValidateNumeroLong(Numerador)
                If resultadoValidacion.IsValid = False Then
                    Dim TextoError As String
                    Using sw As New System.IO.StringWriter
                        sw.WriteLine()
                        sw.WriteLine("Operación Resta")
                        sw.WriteLine(" ------------------------------------------")
                        sw.WriteLine("  A       B     AY     BX       AY - BX")
                        sw.WriteLine("  --- - ---- = ---- - ---- = ------------")
                        sw.WriteLine("  X       Y     XY     XY         XY")
                        sw.WriteLine(" ------------------------------------------")
                        sw.WriteLine("Problemas de valores fuera de rango")
                        sw.WriteLine("Numerador (A*Y - B*X) fuera de rango")
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (Minuendo)  ", nr1.ToString, nr1.Valor)
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (Sustraendo)", nr2.ToString, nr2.Valor)
                        sw.WriteLine()
                        sw.Write(resultadoValidacion.ErrorContent.ToString)
                        sw.WriteLine()
                        TextoError = sw.ToString
                    End Using
                    Throw New System.ArgumentException(TextoError)
                End If
                '----------------------------------------

                Dim Denominador As Decimal = nr1.campoDenominador * nr2.campoDenominador
                '----------------------------------------
                ' Comprueba que el valor numérico, esté dentro del rango de valores permitidos para un numero LONG
                resultadoValidacion = ValidateNumeroLong(Denominador)
                If resultadoValidacion.IsValid = False Then
                    Dim TextoError As String
                    Using sw As New System.IO.StringWriter
                        sw.WriteLine()
                        sw.WriteLine("Operación Resta")
                        sw.WriteLine(" ------------------------------------------")
                        sw.WriteLine("  A       B     AY     BX       AY - BX")
                        sw.WriteLine("  --- - ---- = ---- - ---- = ------------")
                        sw.WriteLine("  X       Y     XY     XY         XY")
                        sw.WriteLine(" ------------------------------------------")
                        sw.WriteLine("Problemas de valores fuera de rango")
                        sw.WriteLine("Numerador (A*Y - B*X) fuera de rango")
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (Minuendo)  ", nr1.ToString, nr1.Valor)
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (Sustraendo)", nr2.ToString, nr2.Valor)
                        sw.WriteLine()
                        sw.Write(resultadoValidacion.ErrorContent.ToString)
                        sw.WriteLine()
                        TextoError = sw.ToString
                    End Using
                    Throw New System.ArgumentException(TextoError)
                End If
                '----------------------------------------

                Resultado = New NumeroRacional(Numerador, Denominador)

            Catch ex As Exception
                Throw
            End Try

            Return Resultado
        End Function

        '-------------------------------------------------------------------
        ''' <summary>
        '''      Resta dos Números Racional
        ''' </summary>
        Public Overloads Shared Operator - _
                         (ByVal nr1 As NumeroRacional,
                          ByVal nr2 As NumeroRacional) _
                          As NumeroRacional
            Return Subtract(nr1, nr2)
        End Operator


        '-------------------------------------------------------------------
        ''' <summary>
        '''      Resta un Numero Racional(minuendo) y un entero(Sustraendo)
        ''' </summary>
        Public Overloads Shared Function Subtract _
                          (ByVal nr1 As NumeroRacional,
                           ByVal paramNumeroEntero As Long) _
                           As NumeroRacional

            Dim Temp As New NumeroRacional(paramNumeroEntero)
            Return Subtract(nr1, Temp)

        End Function


        '-------------------------------------------------------------------
        ''' <summary>
        '''      Resta un Numero Racional(minuendo) y un entero(Sustraendo)
        ''' </summary>
        Public Overloads Shared Operator -(ByVal nr1 As NumeroRacional, ByVal paramNumeroEntero As Long) As NumeroRacional
            Return Subtract(nr1, paramNumeroEntero)
        End Operator

#End Region


#Region "Multiplicaciones"
        '-------------------------------------------------------------------
        ''' <summary>
        '''      Multiplica dos Números Racional
        '''     (Forma alternativa al operador * )
        ''' </summary>
        ''' <param name="nr1">Un NumeroRacional (Multiplicando)</param>
        ''' <param name="nr2">Un NumeroRacional (Multiplicador)</param>
        ''' <returns>Un NumeroRacional (Resultado)
        ''' </returns>
        ''' <remarks> 
        ''' Regla FxCop
        ''' Provide a method named 'Multiply' as a friendly 
        ''' alternate for operator 'NumeroRacional.Operator *(NumeroRacional, NumeroRacional)
        '''</remarks>
        Public Overloads Shared Function Multiply(
                     ByVal nr1 As NumeroRacional,
                     ByVal nr2 As NumeroRacional) _
                     As NumeroRacional
            '---------------------------
            'La multiplicación
            'R=(A/X) * (B/Y)
            ' ---------------------------
            ' A       B      AB
            ' --- * ----  ---------
            ' X       Y      XY
            ' ---------------------------
            'Dim A As Long = nr1.campoNumerador
            'Dim X As Long = nr1.campoDenominador

            'Dim B As Long = nr2.campoNumerador
            'Dim Y As Long = nr2.campoDenominador

            'N = A * B
            'D = X * Y

            ' ---------------------------
            Dim Resultado As NumeroRacional
            Try
                Dim Numerador As Decimal = nr1.campoNumerador * nr2.campoNumerador
                '----------------------------------------
                ' Comprueba que el valor numérico, esté dentro del rango de valores permitidos para un numero LONG
                Dim resultadoValidacion As System.Windows.Controls.ValidationResult
                resultadoValidacion = ValidateNumeroLong(Numerador)
                If resultadoValidacion.IsValid = False Then
                    Dim TextoError As String
                    Using sw As New System.IO.StringWriter
                        sw.WriteLine()
                        sw.WriteLine("Operación Multiplicación")
                        sw.WriteLine("' ---------------------------")
                        sw.WriteLine("   A       B      AB")
                        sw.WriteLine("   --- * ----  ---------")
                        sw.WriteLine("   X       Y      XY")
                        sw.WriteLine("' ---------------------------")
                        sw.WriteLine("Problemas de valores fuera de rango")
                        sw.WriteLine("Numerador (A*B) fuera de rango")
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (Multiplicando)", nr1.ToString, nr1.Valor)
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (Multiplicador)", nr2.ToString, nr2.Valor)
                        sw.WriteLine()
                        sw.Write(resultadoValidacion.ErrorContent.ToString)
                        sw.WriteLine()
                        TextoError = sw.ToString
                    End Using
                    Throw New System.ArgumentException(TextoError)
                End If
                '----------------------------------------

                Dim Denominador As Decimal = nr1.campoDenominador * nr2.campoDenominador
                '----------------------------------------
                ' Comprueba que el valor numérico, esté dentro del rango de valores permitidos para un numero LONG
                resultadoValidacion = ValidateNumeroLong(Denominador)
                If resultadoValidacion.IsValid = False Then
                    Dim TextoError As String
                    Using sw As New System.IO.StringWriter
                        sw.WriteLine()
                        sw.WriteLine("Operación Multiplicación")
                        sw.WriteLine("' ---------------------------")
                        sw.WriteLine("   A       B      AB")
                        sw.WriteLine("   --- * ----  ---------")
                        sw.WriteLine("   X       Y      XY")
                        sw.WriteLine("' ---------------------------")
                        sw.WriteLine("Problemas de valores fuera de rango")
                        sw.WriteLine("Denominador (X*Y) fuera de rango")
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (Multiplicando)", nr1.ToString, nr1.Valor)
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (Multiplicador)", nr2.ToString, nr2.Valor)
                        sw.WriteLine()
                        sw.Write(resultadoValidacion.ErrorContent.ToString)
                        sw.WriteLine()
                        TextoError = sw.ToString
                    End Using
                    Throw New System.ArgumentException(TextoError)
                End If

                Resultado = New NumeroRacional(Numerador, Denominador)

            Catch ex As Exception
                Throw
            End Try

            Return Resultado

        End Function


        '-------------------------------------------------------------------
        ''' <summary>
        '''      Multiplica dos Números Racional
        ''' </summary>
        Public Overloads Shared Operator *(ByVal nr1 As NumeroRacional, ByVal nr2 As NumeroRacional) As NumeroRacional
            Return Multiply(nr1, nr2)
        End Operator


        '-------------------------------------------------------------------
        ''' <summary>
        '''      Multiplica un Numero Racional(Multiplicando) y un entero(Multiplicador)
        ''' </summary>
        Public Overloads Shared Function Multiply _
                          (ByVal nr1 As NumeroRacional,
                           ByVal paramNumeroEntero As Long) _
                           As NumeroRacional

            Dim Temp As New NumeroRacional(paramNumeroEntero)
            Return Multiply(nr1, Temp)
        End Function


        '-------------------------------------------------------------------
        ''' <summary>
        '''      Multiplica un Numero Racional(Multiplicando) y un entero(Multiplicador)
        ''' </summary>
        Public Overloads Shared Operator *(ByVal nr1 As NumeroRacional, ByVal paramNumeroEntero As Long) As NumeroRacional
            Return Multiply(nr1, paramNumeroEntero)
        End Operator
#End Region


#Region "Divisiones"
        '-------------------------------------------------------------------
        ''' <summary>
        '''      Multiplica dos Números Racional
        '''     (Forma alternativa al operador / )
        ''' </summary>
        ''' <param name="nr1">Un NumeroRacional (Dividendo)</param>
        ''' <param name="nr2">Un NumeroRacional (Divisor)</param>
        ''' <returns>Un NumeroRacional (Resultado)
        ''' </returns>
        ''' <remarks> 
        ''' Regla FxCop
        ''' Provide a method named 'Divide' as a friendly 
        ''' alternate for operator 'NumeroRacional.Operator /(NumeroRacional, NumeroRacional)
        '''</remarks>
        Public Overloads Shared Function Divide(
                     ByVal nr1 As NumeroRacional,
                     ByVal nr2 As NumeroRacional) _
                     As NumeroRacional
            '---------------------------
            'La división
            'R=(A/X) / (B/Y)
            ' ---------------------------
            ' A   
            ' --- 
            ' X           AY
            '------- = --------
            ' B           XB
            '-----
            ' Y
            ' ---------------------------
            'Dim A As Long = nr1.campoNumerador
            'Dim X As Long = nr1.campoDenominador

            'Dim B As Long = nr2.campoNumerador
            'Dim Y As Long = nr2.campoDenominador

            'N = A * Y 
            'D = X * B

            ' ---------------------------
            Dim Resultado As NumeroRacional
            Try

                Dim Numerador As Decimal = nr1.campoNumerador * nr2.campoDenominador
                '----------------------------------------
                ' Comprueba que el valor numérico, esté dentro del rango de valores permitidos para un numero LONG
                Dim resultadoValidacion As System.Windows.Controls.ValidationResult
                resultadoValidacion = ValidateNumeroLong(Numerador)
                If resultadoValidacion.IsValid = False Then
                    Dim TextoError As String
                    Using sw As New System.IO.StringWriter
                        sw.WriteLine()
                        sw.WriteLine("Operación División")
                        sw.WriteLine("' ---------------------------")
                        sw.WriteLine("     A   ")
                        sw.WriteLine("   ----- ")
                        sw.WriteLine("     X           AY ")
                        sw.WriteLine("  -------- =  --------")
                        sw.WriteLine("     B           XB")
                        sw.WriteLine("   -----")
                        sw.WriteLine("     Y")
                        sw.WriteLine("' ---------------------------")
                        sw.WriteLine("' ---------------------------")
                        sw.WriteLine("Problemas de valores fuera de rango")
                        sw.WriteLine("Numerador (A*Y) fuera de rango")
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (Dividendo)", nr1.ToString, nr1.Valor)
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (Divisor)  ", nr2.ToString, nr2.Valor)
                        sw.WriteLine()
                        sw.Write(resultadoValidacion.ErrorContent.ToString)
                        sw.WriteLine()
                        TextoError = sw.ToString
                    End Using
                    Throw New System.ArgumentException(TextoError)
                End If
                '----------------------------------------

                Dim Denominador As Decimal = nr1.campoDenominador * nr2.campoNumerador
                '----------------------------------------
                ' Comprueba que el valor numérico, esté dentro del rango de valores permitidos para un numero LONG
                resultadoValidacion = ValidateNumeroLong(Denominador)
                If resultadoValidacion.IsValid = False Then
                    Dim TextoError As String
                    Using sw As New System.IO.StringWriter
                        sw.WriteLine()
                        sw.WriteLine("Operación División")
                        sw.WriteLine("' ---------------------------")
                        sw.WriteLine("     A   ")
                        sw.WriteLine("   ----- ")
                        sw.WriteLine("     X           AY ")
                        sw.WriteLine("  -------- =  --------")
                        sw.WriteLine("     B           XB")
                        sw.WriteLine("   -----")
                        sw.WriteLine("     Y")
                        sw.WriteLine("' ---------------------------")
                        sw.WriteLine("' ---------------------------")
                        sw.WriteLine("Problemas de valores fuera de rango")
                        sw.WriteLine("Denominador  (X*B) fuera de rango")
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (Dividendo)", nr1.ToString, nr1.Valor)
                        sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (Divisor)  ", nr2.ToString, nr2.Valor)
                        sw.WriteLine()
                        sw.Write(resultadoValidacion.ErrorContent.ToString)
                        sw.WriteLine()
                        TextoError = sw.ToString
                    End Using
                    Throw New System.ArgumentException(TextoError)
                End If
                '----------------------------------------
                Resultado = New NumeroRacional(Numerador, Denominador)

            Catch ex As Exception
                Throw
            End Try

            Return Resultado

        End Function

        '-------------------------------------------------------------------
        ''' <summary>
        '''      Multiplica dos Números Racional
        ''' </summary>
        Public Overloads Shared Operator /(ByVal nr1 As NumeroRacional, ByVal nr2 As NumeroRacional) As NumeroRacional
            Return Divide(nr1, nr2)
        End Operator


        '-------------------------------------------------------------------
        ''' <summary>
        '''      Divide un Numero Racional(Dividendo) y un entero(Divisor)
        ''' </summary>
        Public Overloads Shared Function Divide _
                          (ByVal nr1 As NumeroRacional,
                           ByVal paramNumeroEntero As Long) _
                           As NumeroRacional

            Dim Temp As New NumeroRacional(paramNumeroEntero)
            Return Divide(nr1, Temp)
        End Function


        '-------------------------------------------------------------------
        ''' <summary>
        '''      Divide un Numero Racional(Dividendo) y un entero(Divisor)
        ''' </summary>
        Public Overloads Shared Operator /(ByVal nr1 As NumeroRacional, ByVal paramNumeroEntero As Long) As NumeroRacional
            Return Divide(nr1, paramNumeroEntero)
        End Operator
#End Region

#End Region


#Region "    Implements IEquatable(Of NumeroRacional)"

        '-------------------------------------------------------------------
        'Interfaz IEquatable(Of T)
        'http://msdn.microsoft.com/es-es/library/ms131187.aspx
        'Determinar si dos objetos tienen el mismo VALOR.
        '-------------------------------------------------------------------
        'Para determinar si tienen la misma REFERENCIA utilizar la función
        'Object.ReferenceEquals (Método) 
        'http://msdn.microsoft.com/es-es/library/system.object.referenceequals.aspx
        '-------------------------------------------------------------------

        '-------------------------------------------------------------------
        'La interfaz IEquatable
        'http://msdn.microsoft.com/es-es/library/ms131190.aspx
        '-------------------------------------------------------------------
        ''' <summary>
        '''    Determina si dos objetos tienen el mismo valor
        ''' </summary>
        ''' <returns>
        '''    <para>Un valor <see cref="System.Boolean">lógico</see> que indica:</para>
        '''    <para>True:  Si son Iguales</para>
        '''    <para>False: en caso contrario</para>
        ''' </returns>
        Public Overloads Function Equals(ByVal other As NumeroRacional) As Boolean _
                 Implements System.IEquatable(Of NumeroRacional).Equals
            Return Equals(Me, other)
        End Function


        '-------------------------------------------------------------------
        '  Sombreado Object.Equals
        '  http://msdn.microsoft.com/es-es/library/system.object.equals.aspx
        '-------------------------------------------------------------------
        ''' <summary>
        '''    Determina si dos objetos tienen el mismo valor
        ''' </summary>
        ''' <returns>
        '''    <para>Un valor <see cref="System.Boolean">lógico</see> que indica:</para>
        '''    <para>True:  Si son Iguales</para>
        '''    <para>False: en caso contrario</para>
        ''' </returns>
        Public Overloads Overrides Function Equals(ByVal obj As Object) As Boolean

            '-------------------------------------------------------------
            ' El parámetro, obj, debe ser del mismo tipo que la clase o el 
            ' tipo de valor que implementa esta interfaz
            '-------------------------------------------------------------
            If Not (obj.GetType Is Me.GetType) Then
                Return False
                '"Los objetos a comparar no son del mismo tipo")
            End If

            '-------------------------------------------------------------
            'convertirlo a clase NumeroRacional
            Dim unNumeroRacional As NumeroRacional
            unNumeroRacional = CType(obj, NumeroRacional)

            'realizar la comparación
            Return Equals(Me, unNumeroRacional)
        End Function


        '-------------------------------------------------------------------
        '  Sombreado Object.Equals
        '  http://msdn.microsoft.com/es-es/library/system.object.equals.aspx
        '-------------------------------------------------------------------
        ''' <summary>
        '''    Determina si dos objetos tienen el mismo valor
        ''' </summary>
        ''' <returns>
        '''    <para>Un valor <see cref="System.Boolean">lógico</see> que indica:</para>
        '''    <para>True:  Si son Iguales</para>
        '''    <para>False: en caso contrario</para>
        ''' </returns>
        Public Overloads Shared Function Equals(
                     ByVal nr1 As NumeroRacional,
                     ByVal nr2 As NumeroRacional) _
                     As Boolean
            '-------------------------------------------------------
            ' Aquí es donde se hace TODO el trabajo de comparación
            '-------------------------------------------------------
            Dim resultado As Boolean = False ' (Son diferentes)
            If nr1.campoNumerador = nr2.campoNumerador AndAlso
           nr1.campoDenominador = nr2.campoDenominador Then
                resultado = True
            End If
            Return resultado
        End Function

        '-------------------------------------------------------------------
        'Instrucciones para implementar Equals y el operador de igualdad (==)
        'http://msdn.microsoft.com/es-es/library/7h9bszxx.aspx
        '-------------------------------------------------------------------
        ''' <summary>
        '''   Devuelve un valor que indica si un objeto NumeroRacional 
        '''   especificado es igual que otro objeto NumeroRacional especificado. 
        ''' </summary>
        ''' <returns>
        '''    <para>Un valor <see cref="System.Boolean">lógico</see> que indica:</para>
        '''    <para>True:  Si son Iguales</para>
        '''    <para>False: en caso contrario</para>
        ''' </returns>
        Public Overloads Shared Operator =(
                                   ByVal nr1 As NumeroRacional,
                                   ByVal nr2 As NumeroRacional) _
                                   As Boolean
            Return Equals(nr1, nr2)
        End Operator


        '-------------------------------------------------------------------
        'Instrucciones para implementar Equals y el operador de igualdad (==)
        'http://msdn.microsoft.com/es-es/library/7h9bszxx.aspx
        '-------------------------------------------------------------------
        ''' <summary>
        '''   Devuelve un valor que indica si un objeto NumeroRacional 
        '''   especificado es distinto que otro objeto NumeroRacional especificado. 
        ''' </summary>
        ''' <returns>
        '''    <para>Un valor  <see cref="System.Boolean">lógico</see> que indica:</para>
        '''    <para>True:  Si son DIFERENTES</para>
        '''    <para>False: en caso contrario</para>
        ''' </returns>
        Public Overloads Shared Operator <>(
                             ByVal nr1 As NumeroRacional,
                             ByVal nr2 As NumeroRacional) _
                             As Boolean
            Return Not (Equals(nr1, nr2))
        End Operator


        '-------------------------------------------------------------------
        'Sombreado Object.GetHashCode
        'http://msdn.microsoft.com/es-es/library/system.object.gethashcode.aspx
        '-------------------------------------------------------------------
        ''' <summary>
        '''  Devuelve el código hash de esta instancia. 
        ''' </summary>
        Public Overrides Function GetHashCode() As Integer
            'http://msdn.microsoft.com/es-es/library/system.object.gethashcode.aspx
            'http://msdn.microsoft.com/es-es/library/7h9bszxx.aspx
            Dim cociente As Double
            cociente = Me.campoNumerador / Me.campoDenominador
            Return cociente.GetHashCode
        End Function


#End Region


#Region "   Las Funciones ToString "

        ' -------------------------------------------------------------------------
        ' Funciones que proporcionan un formato de salida 
        ' de Cadena para nuestra Clase
        ' Son cuatro funciones las que debes implementar
        ' -------------------------------------------------------------------------


        ' -------------------------------------------------------------------------
        ' 1) Sombrear System.Object.ToString
        ' -------------------------------------------------------------------------
        ''' <summary>
        '''  Salida en formato de cadena para los valores de nuestra  clase
        ''' </summary>
        ''' <returns>Una cadena con los datos de la clase</returns>
        ''' <remarks>
        '''   Esta función se declara 'overrides' porque sustituye un método que tiene el  
        '''   mismo nombre de la clase base, en este caso la clase base es 'Object'
        '''</remarks>
        Public Overloads Overrides Function ToString() As String
            ''--------------------------------------------------------
            '' Forma elemental de obtener la información
            'Return "(" & Me.campoNumerador & ", " & Me.campoDenominador & ")"
            ''--------------------------------------------------------
            Dim formatProvider As System.Globalization.CultureInfo
            formatProvider = System.Globalization.CultureInfo.CurrentCulture
            'Return String.Format(formatProvider, _CADENA_FORMATO, Me.campoNumerador, Me.campoDenominador)
            '-------------------
            Dim cadenaDeFormato As String = String.Empty
            ' -------------------------------------------------------------------------
            ' llamar a (3) La función que realmente hace el trabajo
            Return Me.ToString(cadenaDeFormato, formatProvider)

        End Function


        ' -------------------------------------------------------------------------
        ' 2) Function ToString(cadenaFormato)As String
        ' -------------------------------------------------------------------------
        Public Overloads Function ToString(ByVal cadenaFormato As String) As String
            ' -------------------------------------------------------------------------
            ' refactorizado
            '    CA1305 Especificación de IFormatProvider 
            '    Help         : http://msdn2.microsoft.com/ms182190(VS.90).aspx  (String)
            'If String.IsNullOrEmpty(cadenaFormato) = True Then
            '    cadenaFormato = _CADENA_FORMATO
            'End If
            '  Return String.Format(formatProvider, cadenaFormato, Me.campoNumerador, Me.campoDenominador)
            ' -------------------------------------------------------------------------
            Dim formatProvider As System.Globalization.CultureInfo
            formatProvider = System.Globalization.CultureInfo.CurrentCulture
            ' -------------------------------------------------------------------------
            ' llamar a (3) La función que realmente hace el trabajo
            Return Me.ToString(cadenaFormato, formatProvider)

        End Function




        ' -------------------------------------------------------------------------
        ' El Formato De la cadena que se va a mostrar
        ' -------------------------------------------------------------------------
        '  MÁS INFORMACIÓN SOBRE FORMATOS NUMÉRICOS
        '  Manual del programador de .NET Framework
        '    [http://msdn.microsoft.com/es-es/library/k1s94fta.aspx]
        '
        ' + Información general sobre formatos. 
        '	  [http://msdn.microsoft.com/es-es/library/26etazsy.aspx]
        '
        ' + Cadenas de formato numérico
        '	  [http://msdn.microsoft.com/es-es/library/427bttx3.aspx]
        '
        ' + Cadenas con formato numérico estándar
        '	  [http://msdn.microsoft.com/es-es/library/dwhawy9k.aspx]
        '
        ' + Cadenas con formato numérico personalizado
        '	  [http://msdn.microsoft.com/es-es/library/0c899ak8.aspx]
        '
        ' + Formatos compuestos
        '	  [http://msdn.microsoft.com/es-es/library/txafckwd.aspx]
        ' Private Const _CADENA_FORMATO As String = "({0},{1})"




        '-------------------------------------------------------------------------
        ' Esta es la que realmente hace SIEMPRE el trabajo
        ' -------------------------------------------------------------------------
        ' 3) Función que será llamada por la Interfaz IFormattable (Si se Implementa)
        ' -------------------------------------------------------------------------
        Public Overloads Function ToString(
                     ByVal cadenaFormato As String,
                     ByVal formatProvider As System.IFormatProvider) As String

            If String.IsNullOrEmpty(cadenaFormato) = True Then
                cadenaFormato = "{0:N0}/{1:N0}"
            End If
            If formatProvider Is Nothing Then
                formatProvider = System.Globalization.CultureInfo.CurrentCulture
            End If

            Return String.Format(formatProvider, cadenaFormato, Me.campoNumerador, Me.campoDenominador)

        End Function


        ' -------------------------------------------------------------------------
        ' 4) Función que será llamada por la Interfaz IConvertible (Si se Implementa)
        '    Esta función tiene que intentar usar la clase [Convert] siempre que sea posible
        ' -------------------------------------------------------------------------
        Public Overloads Function ToString(
                     ByVal formatProvider As System.IFormatProvider) _
                     As String
            '-------------------
            Dim cadenaDeFormato As String = String.Empty
            ' -------------------------------------------------------------------------
            ' llamar a (3) La función que realmente hace el trabajo
            Return Me.ToString(cadenaDeFormato, formatProvider)

            ' Return String.Format(formatProvider, _CADENA_FORMATO, Me.campoNumerador, Me.campoDenominador)
        End Function

#End Region


#Region "    Implements IFormattable"



        '**************************************************************************

        ' -------------------------------------------------------------------------
        ' Interfaz System.IFormattable.ToString
        ' -------------------------------------------------------------------------
        ' Esta función lo que hace es llamar a la función que realmente hace el trabajo 
        ' Observa que se utiliza un truco que consiste en declararla como privada y 
        ' apuntar a la función ToString que hace el trabajo.
        ' De esta forma esta función sólo se ve desde la interfaz (que es lo que queremos)
        ' El nombre no puede ser ToString, porque ya hay una función con la misma firma y 
        ' con el mismo nombre, por eso le cambio el nombre y le pongo [ToStringIFormattable] 
        ' que considero que es un nombre representativo
        ' -------------------------------------------------------------------------
        Private Overloads Function ToStringIFormattable(
                                 ByVal format As String,
                                 ByVal formatProvider As System.IFormatProvider) As String _
                                 Implements System.IFormattable.ToString
            ' -------------------------------------------------------------------------
            ' llamar a (3) La función que realmente hace el trabajo de esta interfaz
            Return Me.ToString(format, formatProvider)
        End Function



        '' -------------------------------------------------------------------------
        '' Interfaz System.IConvertible.ToString
        '' -------------------------------------------------------------------------
        '' Esta función lo que hace es llamar a la función que realmente hace el trabajo 
        '' Observa que se utiliza un truco que consiste en declararla como privada y 
        '' apuntar a la función ToString que hace el trabajo.
        '' De esta forma esta función sólo se ve desde la interfaz (que es lo que queremos)
        '' El nombre no puede ser ToString, porque ya hay una función con la misma firma y 
        '' con el mismo nombre, por eso le cambio el nombre y le pongo [ToStringIConvertible] 
        '' que considero que es un nombre representativo
        '' -------------------------------------------------------------------------
        'Private Overloads Function ToStringIConvertible(
        '                 ByVal provider As IFormatProvider) As String _
        '                 Implements IConvertible.ToString

        '    '  -------------------------------------------------------------------------
        '    '  llamar a (4) La función que realmente hace el trabajo de esta interfaz
        '    Return ToString(provider)
        'End Function



#End Region


#Region "    Implements ICloneable"


        '''-----------------------------------------------
        ''' <summary>
        '''       Copia los valores del objeto en las variables de la clase
        ''' </summary>
        Public Sub FormVO(ByVal objNuevo As NumeroRacional)
            If Not (objNuevo = Nothing) Then
                '----------------------------------------------------
                ' copiar los valores de las variables miembro 
                ' del 'objeto nuevo' recibido por parámetro
                ' en las variables de la clase
                '----------------------------------------------------
                Me.campoNumerador = objNuevo.campoNumerador
                Me.campoDenominador = objNuevo.campoDenominador
            Else
                ' es un valor nothing
                ' Coloco los valores por defecto
                Me.campoNumerador = 0
                Me.campoDenominador = 1
            End If
        End Sub


        '---------------------------------------------------------------
        '    (OJO ES PRIVADO)
        '''-------------------------------------------------------------
        ''' <summary>
        '''   Único método de la interfaz ICloneable 
        ''' </summary>
        Private Function ClonaMe() As System.Object Implements ICloneable.Clone
            Return Me.Clone '  Apuntar al método Clone
        End Function


        '---------------------------------------------------------------
        '    (OJO ES PUBLICO)
        '''-------------------------------------------------------------
        ''' <summary>
        '''     Obtener una copia completa del objeto
        ''' </summary>
        Public Function Clone() As NumeroRacional
            Dim nuevo As New NumeroRacional(0, 1) With {
            .campoNumerador = Me.campoNumerador,
            .campoDenominador = Me.campoDenominador
        }
            Return nuevo
        End Function

#End Region


#Region "    Implements IComparable - IComparable(Of NumeroRacional)"


        '-------------------------------------------------------------------
        'Instrucciones para implementar Equals y el operador de igualdad (==)
        'http://msdn.microsoft.com/es-es/library/7h9bszxx.aspx
        '-------------------------------------------------------------------
        Public Overloads Shared Operator <(
                     ByVal nr1 As NumeroRacional,
                     ByVal nr2 As NumeroRacional) _
                     As Boolean

            '-------------------------------------------------------------
            ' Para comparar dos fracciones tienen que tener el mismo paramDenominadorLong
            ' ejemplo
            '---------------------------------------------------
            ' me y other
            ' 1      4      1*9        4*2       9         8
            '--- Y ---- >> ------ y ------- >> -----  y  ------
            ' 2      9      2*9        9*2      18        18
            ' A continuación se comparan los numeradores, la que tiene el 
            ' paramUnNumeroLong mayor es una fracción mas grande (que contiene el numero mas grande)
            ' en el ejemplo  9/18 = 0.5
            '                8/18 = 0.444444...
            '  0.5 es un numero mas grande que 0.444444.
            '---------------------------------------------
            Dim numeradorIzda As Long ' = 0
            Dim numeradorDcha As Long ' = 0
            numeradorIzda = nr1.campoNumerador * nr2.campoDenominador
            numeradorDcha = nr2.campoNumerador * nr1.campoDenominador

            Dim resultado As Boolean = False
            If numeradorIzda < numeradorDcha Then
                resultado = True
            End If
            ' devolver el resultado
            Return resultado
        End Operator


        '-------------------------------------------------------------------
        'Instrucciones para implementar Equals y el operador de igualdad (==)
        'http://msdn.microsoft.com/es-es/library/7h9bszxx.aspx
        '-------------------------------------------------------------------
        Public Overloads Shared Operator >(
                    ByVal nr1 As NumeroRacional,
                    ByVal nr2 As NumeroRacional) _
                    As Boolean

            '-------------------------------------------------------------
            ' Para comparar dos fracciones tienen que tener el mismo paramDenominadorLong
            ' ejemplo
            '---------------------------------------------------
            ' me y other
            ' 1      4      1*9        4*2       9         8
            '--- Y ---- >> ------ y ------- >> -----  y  ------
            ' 2      9      2*9        9*2      18        18
            ' A continuación se comparan los numeradores, la que tiene el 
            ' paramUnNumeroLong mayor es una fracción mas grande (que contiene el numero mas grande)
            ' en el ejemplo  9/18 = 0.5
            '                8/18 = 0.444444...
            '  0.5 es un numero mas grande que 0.444444.
            '---------------------------------------------
            Dim numeradorIzda As Long ' = 0
            Dim numeradorDcha As Long ' = 0
            numeradorIzda = nr1.campoNumerador * nr2.campoDenominador
            numeradorDcha = nr2.campoNumerador * nr1.campoDenominador

            Dim resultado As Boolean = False
            If numeradorIzda > numeradorDcha Then
                resultado = True
            End If
            ' devolver el resultado
            Return resultado
        End Operator




        '-------------------------------------------------------------------
        'La interfaz IComparable
        'http://msdn.microsoft.com/es-es/library/system.icomparable.compareto.aspx
        '-------------------------------------------------------------------
        Public Overloads Function CompareTo(ByVal obj As Object) As Integer _
              Implements System.IComparable.CompareTo

            '-------------------------------------------------------------
            ' El parámetro, obj, debe ser del mismo tipo que la clase o el 
            ' tipo de valor que implementa esta interfaz; en caso contrario, 
            ' se produce la excepción ArgumentException.
            '-------------------------------------------------------------
            If Not (obj.GetType Is Me.GetType) Then
                Throw New ArgumentException(
            "Los objetos a comparar no son del mismo tipo")
            End If

            '-------------------------------------------------------------
            ' Por definición, cualquier objeto es mayor que una referencia de 
            ' objeto null (Nothing en Visual Basic) y dos 
            ' referencias nulas son iguales entre sí.
            If obj Is Nothing Then
                ' Mayor que cero  -  ME instancia es mayor que paramNumeradorDecimal.
                Return 1
            End If

            '-------------------------------------------------------------
            ' si llega aquí, quiere decir que los dos objetos son del mismo tipo
            ' los dos son objetos NumeroRacional
            '-------------------------------------------------------------
            Dim unNumeroRacional As NumeroRacional
            unNumeroRacional = CType(obj, NumeroRacional)

            '-------------------------------------------------------------
            ' realizar la comparación
            '-------------------------------------------------------------
            ' utilizar la función GENERICA para hacer la comparación
            Return Me.CompareTo(unNumeroRacional)

        End Function


        '-------------------------------------------------------------------
        'La interfaz IComparable(Of Persona)
        'http://msdn.microsoft.com/es-es/library/43hc6wht.aspx
        '-------------------------------------------------------------------
        Public Overloads Function CompareTo(ByVal other As NumeroRacional) As Integer _
             Implements System.IComparable(Of NumeroRacional).CompareTo

            ' Realizo la misma operación de comparación pero utilizando una función genérica, 
            ' se elimina la necesidad de una conversión de tipos para usarla

            '-------------------------------------------------------------
            ' realizar la comparación
            '-------------------------------------------------------------
            ' Menor que cero  -  ME instancia es menor que paramNumeradorDecimal. 
            ' Cero            -  ME instancia es igual a paramNumeradorDecimal. 
            ' Mayor que cero  -  ME instancia es mayor que paramNumeradorDecimal.
            '-------------------------------------------------------------
            ' Por definición, cualquier objeto es mayor que una referencia de 
            ' objeto null (Nothing en Visual Basic) y dos 
            ' referencias nulas son iguales entre sí.
            If other = Nothing Then
                ' Mayor que cero  -  ME instancia es mayor que paramNumeradorDecimal.
                Return 1
            End If

            '-------------------------------------------------------------
            ' Código sustituido
            '-------------------------------------------------------------
            ' El código funciona
            ' Se sustituye porque se han reemplazado los operadores [=, < y >] 
            ' para números racionales y los empleo para comparar cual es mayor 
            ' que otro en lugar de utilizar sus valores
            ' El código marcado como comentario funciona pero lo sustituyo par 
            ' a hacer cada cosa en un único lugar de la clase y no  
            ' duplicar código ni funcionalidad

            '-------------------------------------------------------------
            ' Para comparar dos fracciones tienen que tener el mismo paramDenominadorLong
            ' ejemplo
            '---------------------------------------------------
            ' me y other
            ' 1      4      1*9        4*2       9         8
            '--- Y ---- >> ------ y ------- >> -----  y  ------
            ' 2      9      2*9        9*2      18        18
            ' A continuación se comparan los numeradores, la que tiene el 
            ' paramUnNumeroLong mayor es una fracción mas grande (que contiene el numero mas grande)
            ' en el ejemplo  9/18 = 0.5
            '                8/18 = 0.444444...
            '  0.5 es un numero mas grande que 0.444444.
            '---------------------------------------------
            'Dim numeradorME As Long = 0
            'Dim numeradorOther As Long = 0
            'numeradorME = Me.campoNumerador * other.campoDenominador
            'numeradorOther = other.campoNumerador * Me.campoDenominador

            'Dim resultado As Integer = 0
            'If numeradorME > numeradorOther Then resultado = +1
            'If numeradorME = numeradorOther Then resultado = +0
            'If numeradorME < numeradorOther Then resultado = -1
            '' devolver el resultado
            'Return resultado
            '-------------------------------------------------------------
            ' FIN Código sustituido
            '-------------------------------------------------------------

            ' operando con los operadores sobrecargados > = < de numero racional
            Dim resultado As Integer = 0
            If Me > other Then resultado = +1
            If Me = other Then resultado = +0
            If Me < other Then resultado = -1
            ' devolver el resultado
            Return resultado


        End Function

#End Region


#Region "Operadores >, <, = , <>, >=, <="

        '-------------------------------------------------------------------
        ' El operador >  esta definido en IComparable
        ' El operador <  esta definido en IComparable
        ' El operador =  esta definido en IEquatable(Of NumeroRacional)
        ' El operador <> esta definido en IEquatable(Of NumeroRacional)
        '-------------------------------------------------------------------


        '-------------------------------------------------------------------
        'Instrucciones para implementar Equals y el operador de igualdad (==)
        'http://msdn.microsoft.com/es-es/library/7h9bszxx.aspx
        '-------------------------------------------------------------------
        Public Overloads Shared Operator >=(
                    ByVal nr1 As NumeroRacional,
                    ByVal nr2 As NumeroRacional) _
                    As Boolean

            ' defino este valor en función del operador [<] [MenorQue]
            ' si a<b = true,  entonces a>=b es false
            ' si a<b = False, entonces a>=b es cierto
            Return Not (nr1 < nr2)
        End Operator

        '-------------------------------------------------------------------
        'Instrucciones para implementar Equals y el operador de igualdad (==)
        'http://msdn.microsoft.com/es-es/library/7h9bszxx.aspx
        '-------------------------------------------------------------------
        Public Overloads Shared Operator <=(
                    ByVal nr1 As NumeroRacional,
                    ByVal nr2 As NumeroRacional) _
                    As Boolean

            ' defino este valor en función del operador [>] [MayorQue]
            ' si a>b = true,  entonces a<=b es false
            ' si a>b = False, entonces a<=b es cierto
            Return Not (nr1 > nr2)
        End Operator

#End Region


#Region " MaxValue, MinValue, MinusOne, Zero, One, Floor, Ceiling, GetBits, NumeroInverso, Pow, Negate, plus "

        ''' <summary>
        '''    Representa el mayor valor posible de NumeroRacional,
        '''    este campo es constante y de solo lectura
        ''' </summary>
        ''' <remarks>
        '''  El valor de esta constante es + 9.223.372.036.854.775.807, 
        '''  es decir, el hexadecimal 0x7FFFFFFFFFFFFFFF.
        '''</remarks>
        Public Shared ReadOnly Property MaxValue() As NumeroRacional
            Get
                Return New NumeroRacional(System.Int64.MaxValue)
            End Get
        End Property



        ''' <summary>
        '''    Representa el menor valor posible de  NumeroRacional
        '''    este campo es constante y de solo lectura
        ''' </summary>
        ''' <remarks>
        ''' El valor de esta constante es - 9.223.372.036.854.775.808 negativo,
        '''  es decir, el hexadecimal 0x8000000000000000.
        '''</remarks>
        Public Shared ReadOnly Property MinValue() As NumeroRacional
            Get
                Return New NumeroRacional(System.Int64.MinValue)
            End Get
        End Property




        ''' <summary>
        '''    Representa el valor menos uno (-1), este campo es constante y de solo lectura
        ''' </summary>
        Public Shared ReadOnly Property MinusOne() As NumeroRacional
            Get
                Return New NumeroRacional(-1, 1)
            End Get
        End Property

        ''' <summary>
        '''    Representa el valor cero (0), este campo es constante y de solo lectura
        ''' </summary>
        Public Shared ReadOnly Property Zero() As NumeroRacional
            Get
                Return New NumeroRacional(0, 1)
            End Get
        End Property

        ''' <summary>
        '''  ¿¿ El valor es cero (0) ??
        ''' </summary>
        ''' <returns>
        '''    <para>Un valor  <see cref="System.Boolean">lógico</see> que indica:</para>
        '''    <para>True: el valor de NumeroRacional es la cantidad Cero (0/1)</para>
        '''    <para>False: el cualquier otro valor</para>
        ''' </returns>
        ''' <remarks></remarks>
        Public Function IsZero() As Boolean
            Dim resultado As Boolean = False
            If Me.campoNumerador = 0 AndAlso Me.campoDenominador = 1 Then
                resultado = True
            End If
            Return resultado
        End Function

        ''' <summary>
        '''    Representa el valor uno (1), este campo es constante y de solo lectura
        ''' </summary>
        Public Shared ReadOnly Property One() As NumeroRacional
            Get
                Return New NumeroRacional(+1, 1)
            End Get
        End Property


        ''' <summary>
        '''  ¿¿ El valor es la unidad (1) ??
        ''' </summary>
        ''' <returns>
        '''    <para>Un valor  <see cref="System.Boolean">lógico</see> que indica:</para>
        '''    <para>True: el valor de NumeroRacional es la cantidad Uno (1,00)</para>
        '''    <para>False: el cualquier otro valor</para>
        ''' </returns>
        ''' <remarks></remarks>
        Public Function IsOne() As Boolean
            Dim resultado As Boolean = False
            If Me.campoNumerador = 1 AndAlso Me.campoDenominador = 1 Then
                resultado = True
            End If
            Return resultado
        End Function



        ''' <summary>
        '''  Devuelve el número entero más pequeño mayor o igual que el valor de especificado.
        ''' </summary>
        ''' <param name="nr">Una cantidad </param>
        ''' <returns>Una cantidad que contiene el resultado de la operación
        '''          Ejemplo Ceiling(-15,15) = -15,00
        '''          Ejemplo Ceiling(+15,15) = +16,00
        ''' </returns>
        ''' <remarks>
        ''' El comportamiento de este método sigue el estándar IEEE 754, sección 4. 
        ''' A este tipo de redondeo a veces se le denomina redondeo hacia el infinito positivo.
        ''' </remarks>
        ''' <example>
        ''' <para>Ceiling(-15,15) = -15,00</para>
        ''' <para>Ceiling(-15,85) = -15,00</para>
        ''' <para>Ceiling(+15,15) = +16,00</para>
        ''' <para>Ceiling(+15,85) = +16,00</para>
        '''</example>
        Public Shared Function Ceiling(ByVal nr As NumeroRacional) As NumeroRacional

            Dim numeroCeiling As Long
            numeroCeiling = CType(Math.Ceiling(nr.Valor), Long)

            Return New NumeroRacional(numeroCeiling)

        End Function


        ''' <summary>
        '''  Devuelve el número entero más grande menor o igual que el valor especificado.
        ''' </summary>
        ''' <param name="nr">Una cantidad </param>
        ''' <returns>Una cantidad de contiene el resultado de la operación
        '''          Ejemplo Floor(-15,15) = -16,00
        '''          Ejemplo Floor(+15,85) = +15,00
        ''' </returns>
        ''' <remarks>
        ''' El comportamiento de este método sigue el estándar IEEE 754, sección 4. 
        ''' A este tipo de redondeo a veces se le denomina redondeo hacia el infinito negativo
        ''' </remarks>
        ''' <example>
        ''' <para>Floor(-15,15) = -16,00</para>
        ''' <para>Floor(-15,85) = -16,00</para>
        ''' <para>Floor(+15,15) = +15,00</para>
        ''' <para>Floor(+15,85) = +15,00</para>
        '''</example>
        Public Shared Function Floor(ByVal nr As NumeroRacional) As NumeroRacional
            'Dim numeroFloor As Long
            'numeroFloor = CType(Math.Floor(d.Valor), Long)
            Return New NumeroRacional(CType(Math.Floor(nr.Valor), Long))
        End Function




        ''' <summary>
        '''  Convierte el valor recibido por parámetro 
        '''  en la representación binaria equivalente.
        ''' </summary>
        ''' <param name="nr">Valor recibido por parámetro </param>
        ''' <returns>
        '''     Matriz de enteros de 32 bits con signo con cuatro elementos que  
        '''     contiene la representación binaria de
        '''     <paramref name="nr">nr</paramref>
        ''' </returns>
        ''' <remarks>
        '''  <para>
        '''       La representación binaria de un número Decimal se compone de un signo de 1 bit, 
        '''       un número entero de 96 bits y un factor de escala que se utiliza para dividir  
        '''       el número entero y especificar la parte del mismo que es una fracción decimal.  
        '''       El factor de escala es implícitamente el número 10, elevado a un exponente  
        '''       comprendido entre el 0 y el 28.
        ''' </para> 
        ''' <para>
        '''       El valor devuelto es una matriz de enteros de 32 bits 
        '''       con signo de cuatro elementos.
        ''' </para> 
        ''' <para> 
        '''       El primer, segundo y tercer elementos de la matriz devuelta contienen los 32  
        '''       bits inferiores, intermedios y superiores del número entero de 96 bits.
        ''' </para> 
        ''' <para>
        '''       El cuarto elemento de la matriz devuelta contiene el factor de escala y  
        '''       el signo. Consta de las siguientes partes: 
        ''' </para> 
        ''' <para>
        '''       Los bits del 0 al 15, la palabra inferior, no se utilizan y deben ser cero.
        ''' </para> 
        ''' <para>
        '''       Los bits del 16 al 23 deben contener un exponente comprendido entre el 
        '''       0 y el 28, que indica la potencia de 10 para con la que se divide 
        '''       el número entero.
        ''' </para> 
        ''' <para>
        '''       Los bits del 24 al 30 no se utilizan y deben ser cero.
        ''' </para> 
        ''' <para>
        '''       El bit 31 contiene el signo; 0 significa positivo y 1 significa negativo.
        ''' </para> 
        ''' <para>
        '''       Tenga en cuenta que en la representación de bits se hace una distinción   
        '''       entre el cero negativo y el positivo. 
        '''       Estos valores se consideran iguales en todas las operaciones.
        ''' </para> 
        ''' <para>
        ''' http://msdn.microsoft.com/es-es/library/system.decimal.getbits(VS.80).aspx
        ''' </para>
        ''' </remarks>
        Public Shared Function GetBits(ByVal nr As NumeroRacional) As Integer()
            Dim numDecimal As Decimal = nr.Valor
            Return Decimal.GetBits(numDecimal)
        End Function



        ''' <summary>
        '''     Un numero inverso es el resultado de hacer la operación 1/x
        ''' </summary>
        ''' <param name="nr">Una cantidad</param>
        Public Shared Function NumeroInverso(ByVal nr As NumeroRacional) As NumeroRacional
            '---------------------------------
            ' un numero inverso es 1/x
            ' el inverso de 5/4 es 4/5
            '---------------------------------
            If nr.campoNumerador = 0 Then
                nr.campoDenominador = 1
            End If
            Dim salida As New NumeroRacional(nr.campoDenominador, nr.campoNumerador)
            Return salida
        End Function



        ''' <summary>
        '''     Un numero inverso es el resultado de hacer la operación 1/x
        ''' </summary>
        Public Function NumeroInverso() As NumeroRacional
            '---------------------------------
            ' un numero inverso es 1/x
            ' el inverso de 5/4 es 4/5
            '---------------------------------
            Return NumeroInverso(Me)
        End Function




        ''' <summary>
        ''' Devuelve una cantidad elevado a la potencia especificada.
        '''  (Forma alternativa al operador ^ )
        ''' </summary>
        ''' <param name="nr1">nr1 - Una clase NumeroRacional (Base)</param>
        ''' <param name="paramExponente">nr2 - Una numero decimal (Exponente)</param>
        ''' <returns>Una clase NumeroRacional 
        '''          que contiene el resultado de la operación
        ''' </returns>
        Public Shared Function Pow(
                       ByVal nr1 As NumeroRacional,
                       ByVal paramExponente As Long) _
                       As NumeroRacional

            '-------------------------------------------------------------------
            ' Caso general
            '|     | n         n       |     | 4        4
            '|  a  |         a         |  2  |         2          16
            '| --- |   =  -------      | --- |    =  -----   = -------
            '|  b  |           n       |  3  |          4         81
            '|     |         b         |     |         3
            '-------------------------------------------------------------------
            ' Casos particulares
            ' POtencia de -1
            ' |     | - 1        
            ' |  2  |         5    
            ' | --- |    =  -----  
            ' |  5  |         2    
            ' |     |       
            '-----------------------
            ' POtencia de 0
            ' |     | 0        
            ' |  2  |           
            ' | --- |    = 1
            ' |  5  |          
            ' |     |       
            '-----------------------
            ' POtencia de 1
            ' |     | + 1        
            ' |  2  |         2    
            ' | --- |    =  -----  
            ' |  5  |         5    
            ' |     |       
            '-----------------------
            ' Potencia de un exponente negativo
            ' |     | - 4        4
            ' |  2  |         5          625
            ' | --- |    =  -----   = -------
            ' |  5  |          4          16
            ' |     |         2
            '-----------------------
            Dim auxNumerador As Double
            Dim auxDenominador As Double
            Dim resultado As NumeroRacional

            If paramExponente = -1 Then
                ' se devuelve el numero inverso
                'resultado = New NumeroRacional(nr1.campoDenominador, nr1.campoNumerador)
                resultado = NumeroRacional.NumeroInverso(nr1)
                Return resultado
            End If

            If paramExponente = 0 Then
                'Se devuelve el valor uno (1)
                resultado = NumeroRacional.One
                Return resultado
            End If

            If paramExponente = 1 Then
                ' se devuelve el mismo valor
                Return nr1
            End If

            If paramExponente < 0 Then
                'invertir la fracción y elevarla a la potencia
                nr1 = NumeroRacional.NumeroInverso(nr1)
                'auxNumerador = Math.Pow(nr1.campoDenominador, paramExponente)
                'auxDenominador = Math.Pow(nr1.campoNumerador, paramExponente)
            End If

            ' elevar numerado y denominador a la potencia
            auxNumerador = Math.Pow(nr1.campoNumerador, paramExponente)
            '----------------------------------------
            ' Comprueba que el valor numérico, esté dentro del rango de valores permitidos para un numero LONG
            Dim resultadoValidacion As System.Windows.Controls.ValidationResult
            resultadoValidacion = ValidateNumeroLong(CDec(auxNumerador))
            If resultadoValidacion.IsValid = False Then
                Dim TextoError As String
                Using sw As New System.IO.StringWriter
                    sw.WriteLine()
                    sw.WriteLine("Operación Exponenciación")
                    sw.WriteLine("-------------------------------------------------------------------")
                    sw.WriteLine(" Caso general")
                    sw.WriteLine("|     | n         n       |     | 4         4")
                    sw.WriteLine("|  a  |         a         |  2  |          2           16")
                    sw.WriteLine("| --- |   =  -------      | --- |    =   -----   =   -------")
                    sw.WriteLine("|  b  |           n       |  3  |           4         81")
                    sw.WriteLine("|     |         b         |     |          3")
                    sw.WriteLine("-------------------------------------------------------------------")
                    sw.WriteLine(" Potencia de un exponente negativo")
                    sw.WriteLine(" |     | - 4        4")
                    sw.WriteLine(" |  2  |         5          625")
                    sw.WriteLine(" | --- |    =  -----   =  -------")
                    sw.WriteLine(" |  5  |          4          16")
                    sw.WriteLine(" |     |         2")
                    sw.WriteLine("-------------------------------------------------------------------")
                    sw.WriteLine("Problemas de valores fuera de rango")
                    sw.WriteLine("Numerador (A^N) fuera de rango")
                    sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (Base)", nr1.ToString, nr1.Valor)
                    sw.WriteLine("[{0}] {1}", "Exponente        ", paramExponente)
                    sw.WriteLine()
                    sw.Write(resultadoValidacion.ErrorContent.ToString)
                    sw.WriteLine()
                    TextoError = sw.ToString
                End Using
                Throw New System.ArgumentException(TextoError)
            End If
            '----------------------------------------






            auxDenominador = Math.Pow(nr1.campoDenominador, paramExponente)
            '----------------------------------------
            ' Comprueba que el valor numérico, esté dentro del rango de valores permitidos para un numero LONG
            'Dim resultadoValidacion As System.Windows.Controls.ValidationResult
            resultadoValidacion = ValidateNumeroLong(CDec(auxDenominador))
            If resultadoValidacion.IsValid = False Then
                Dim TextoError As String
                Using sw As New System.IO.StringWriter
                    sw.WriteLine()
                    sw.WriteLine("Operación Exponenciación")
                    sw.WriteLine("-------------------------------------------------------------------")
                    sw.WriteLine(" Caso general")
                    sw.WriteLine("|     | n         n       |     | 4         4")
                    sw.WriteLine("|  a  |         a         |  2  |          2           16")
                    sw.WriteLine("| --- |   =  -------      | --- |    =   -----   =   -------")
                    sw.WriteLine("|  b  |           n       |  3  |           4         81")
                    sw.WriteLine("|     |         b         |     |          3")
                    sw.WriteLine("-------------------------------------------------------------------")
                    sw.WriteLine(" Potencia de un exponente negativo")
                    sw.WriteLine(" |     | - 4        4")
                    sw.WriteLine(" |  2  |         5          625")
                    sw.WriteLine(" | --- |    =  -----   =  -------")
                    sw.WriteLine(" |  5  |          4          16")
                    sw.WriteLine(" |     |         2")
                    sw.WriteLine("-------------------------------------------------------------------")
                    sw.WriteLine("Problemas de valores fuera de rango")
                    sw.WriteLine("Numerador (B^N) fuera de rango")
                    sw.WriteLine("[{0}] ({1}) [{2}]", "Operador recibido (Base)", nr1.ToString, nr1.Valor)
                    sw.WriteLine("[{0}] {1}", "Exponente        ", paramExponente)
                    sw.WriteLine()
                    sw.Write(resultadoValidacion.ErrorContent.ToString)
                    sw.WriteLine()
                    TextoError = sw.ToString
                End Using
                Throw New System.ArgumentException(TextoError)
            End If
            '----------------------------------------

            resultado = New NumeroRacional(CLng(auxNumerador), CLng(auxDenominador))
            Return resultado

        End Function


        ''' <summary>
        ''' Devuelve una cantidad elevado a la potencia especificada.
        ''' </summary>
        ''' <param name="nr1">nr1 - Una clase NumeroRacional (Base)</param>
        ''' <param name="paramExponente">nr2 - Una numero decimal (Exponente)</param>
        ''' <returns>Una clase NumeroRacional 
        '''          que contiene el resultado de la operación
        ''' </returns>
        Public Shared Operator ^(
                       ByVal nr1 As NumeroRacional,
                       ByVal paramExponente As Long) _
                       As NumeroRacional

            Return Pow(nr1, paramExponente)
        End Operator




        ''' <summary>
        '''    Devuelve el resultado de multiplicar el valor NumeroRacional
        '''    especificado por menos uno (-1).
        ''' </summary>
        ''' <param name="nr">La clase NumeroRacional.</param>
        ''' <returns>el valor de <paramref name="nr">nr</paramref> pero con signo opuesto. 
        ''' O bien Cero(0), si <paramref name="nr">nr</paramref> es cero. </returns>
        Public Shared Function Negate(ByVal nr As NumeroRacional) As NumeroRacional
            If nr.Valor = 0 Then
                Return NumeroRacional.Zero
            Else
                Return New NumeroRacional(-nr.campoNumerador, nr.campoDenominador)
            End If
        End Function



        ''' <summary>
        '''    Devuelve el resultado de multiplicar el valor NumeroRacional
        '''    especificado por menos uno (-1).
        ''' </summary>
        ''' <param name="nr">La clase NumeroRacional.</param>
        ''' <returns>el valor de <paramref name="nr">nr</paramref> pero con signo opuesto. 
        ''' O bien Cero(0), si <paramref name="nr">nr</paramref> es cero. </returns>
        Public Shared Operator -(ByVal nr As NumeroRacional) As NumeroRacional
            Return Negate(nr)
        End Operator


        ''' <summary>
        '''  Cambia el signo de la clase NumeroRacional
        '''  Si el signo es negativo pone el signo positivo, 
        '''  si el signo es positivo no cambia nada
        ''' </summary>
        ''' <param name="nr">La clase NumeroRacional.</param>
        ''' <returns>El resultado de la operación en una clase NumeroRacional</returns>
        Public Shared Operator +(ByVal nr As NumeroRacional) As NumeroRacional
            Return Plus(nr)
        End Operator


        ''' <summary>
        '''  Cambia el signo de la clase NumeroRacional
        '''  Si el signo es negativo pone el signo positivo, 
        '''  si el signo es positivo no cambia nada
        ''' </summary>
        ''' <param name="nr">La clase NumeroRacional.</param>
        ''' <returns>El resultado de la operación en una clase NumeroRacional</returns>
        ''' <remarks>
        '''   Regla FxCop
        '''   Provide a method named 'Plus' as a friendly alternate 
        '''   for operator 'NumeroRacional.Operator +(NumeroRacional)'.
        '''</remarks>
        Public Shared Function Plus(ByVal nr As NumeroRacional) As NumeroRacional

            If nr.Valor = 0 Then
                Return NumeroRacional.Zero
            Else
                Return New NumeroRacional(+nr.campoNumerador, nr.campoDenominador)
            End If
        End Function


        ''' <summary>
        '''  cuenta el número de cifras decimales (significativas) 
        '''   p.e   4,567 devuelve tres(3)
        '''   p.e  12,00  devuelve cero (0)
        ''' </summary>
        ''' <param name="value">Un numero decimal </param>
        ''' <returns>
        '''  un numero entero que indica las cifras decimales (significativas) del numero.
        ''' </returns>
        ''' <remarks>
        ''' Ejemplo, 12,12   devuelve 2
        ''' Ejemplo, 12,00   devuelve 0 ' atención
        ''' Ejemplo, 12,1234 devuelve 4
        ''' </remarks>
        Private Shared Function DigitosDecimalesCount(ByVal value As Decimal) As Integer

            Try

                Dim infoCultura As System.Globalization.CultureInfo
                infoCultura = System.Globalization.CultureInfo.CurrentCulture

                Dim numeroDecimales As Integer = 0
                Dim separadorDecimal As String
                separadorDecimal = infoCultura.NumberFormat.NumberDecimalSeparator

                ' convertir el numero en cadena
                Dim cadena As String = String.Empty
                cadena = value.ToString(infoCultura)

                Dim posicionSeparadorDecimal As Integer = 0
                posicionSeparadorDecimal = cadena.IndexOf(
                                              separadorDecimal,
                                              System.StringComparison.CurrentCulture)

                If posicionSeparadorDecimal <> -1 Then
                    ' hay un separador decimal
                    ' 0         1         2
                    ' 012345678901234567890 [Posiciones]
                    ' 12,1234567890123  
                    ' La coma decimal esta en la posición 2
                    ' el tamaño de la cadena es de 15 caracteres
                    ' Cuidado count devuelve 16 caracteres
                    ' (16-1)-2 = 13 posiciones decimales

                    numeroDecimales = (cadena.Length - 1) - posicionSeparadorDecimal
                    If numeroDecimales < 0 Then
                        numeroDecimales = 0
                    End If
                End If

                Return numeroDecimales

            Catch ex As Exception
                Throw
            End Try
        End Function


        ''' <summary>
        '''  cuenta el número de cifras decimales (significativas) 
        '''   p.e   4,567 devuelve tres(3)
        '''   p.e  12,00  devuelve cero (0)
        ''' </summary>
        Public Shared Function DigitosDecimalesCount(ByVal value As NumeroRacional) As Integer
            Return DigitosDecimalesCount(value.Valor)
        End Function


        ''' <summary>
        '''  cuenta el número de cifras decimales (significativas) 
        '''   p.e   4,567 devuelve tres(3)
        '''   p.e  12,00  devuelve cero (0)
        ''' </summary>
        Public Function DigitosDecimalesCount() As Integer
            Return DigitosDecimalesCount(Me.Valor)
        End Function



#Region "Redondear"


        ''' <summary>
        '''      Redondea un valor NumeroRacional 
        '''      a un número especificado de posiciones decimales
        ''' </summary>
        ''' <param name="nr"> Valor que se va a redondear. </param>
        ''' <param name="decimales">
        '''        Número de posiciones decimales significativas 
        '''       (precisión) del valor devuelto. 
        ''' </param>
        ''' <returns>
        '''        NumeroRacional redondeado a un número de posiciones 
        '''        decimales especificado en 
        '''        <paramref name="decimals">decimales</paramref>
        ''' </returns>
        ''' <remarks>
        ''' <para>
        '''    El parámetro <paramref name="decimales">decimales</paramref> 
        '''    especifica el número de posiciones decimales significativas del valor devuelto,
        '''    que puede oscilar entre 0 y 28. Si decimales es cero, se devuelve un número entero.
        ''' </para>
        ''' <para>
        '''    Cuando <paramref name="nr">nr</paramref> se encuentra exactamente en medio 
        '''    de dos valores redondeados, el resultado es el valor redondeado que tiene 
        '''    un dígito par en la posición decimal que se encuentra más a la derecha. 
        '''    Por ejemplo, cuando se redondea a dos decimales, el valor 2,345 se 
        '''    convierte en 2,34 y el valor 2,355 pasa a ser 2,36. 
        '''    Este proceso se conoce con el nombre de redondeo al par o redondeo al más próximo.
        '''  </para>
        '''</remarks>
        Public Overloads Shared Function Round(
                     ByVal nr As NumeroRacional,
                     ByVal decimales As Integer) _
                     As NumeroRacional
            Return New NumeroRacional(Decimal.Round(nr.Valor, decimales))
        End Function


        ''' <summary>
        '''    Redondea un valor NumeroRacional al entero más próximo. 
        '''    Un parámetro especifica el redondeo del valor si está a la mitad del 
        '''    intervalo entre otros dos números.
        ''' </summary>
        ''' <param name="nr"> Valor que se va a redondear. </param>
        ''' <param name="mode">Tipo: <seealso cref="System.MidpointRounding"> 
        '''     System.MidpointRounding</seealso>. Valor que especifica el redondeo de 
        '''    <paramref name="nr">nr</paramref> si su valor está a la mitad del intervalo 
        '''     entre otros dos números</param>
        ''' <returns> Número más cercano al parámetro <paramref name="nr">nr</paramref>
        '''           Si <paramref name="nr">nr</paramref> se encuentra a la mitad del
        '''           intervalo entre dos números, uno par y otro impar, el parámetro 
        '''           <paramref name="mode">mode</paramref> 
        '''           determina el número que se devuelve. 
        ''' </returns>
        ''' <remarks>
        '''    El comportamiento de este método sigue el estándar IEEE 754, sección 4. 
        '''    Este tipo de redondeo se suele denominar redondeo al entero más próximo o 
        '''    redondeo bancario. Si decimals es cero, este redondeo suele denominar 
        '''    redondeo a cero.
        ''' </remarks>
        Public Overloads Shared Function Round(
                     ByVal nr As NumeroRacional,
                     ByVal mode As MidpointRounding) _
                     As NumeroRacional
            Return New NumeroRacional(Decimal.Round(nr.Valor, mode))
        End Function


        ''' <summary>
        '''      Redondea un valor NumeroRacional a una precisión especificada. 
        ''' </summary>
        ''' <param name="nr">Valor que se va a redondear. </param>
        ''' <param name="decimales">
        '''    Número de posiciones decimales significativas (precisión) del valor devuelto. 
        ''' </param>
        ''' <param name="mode">Tipo: <seealso cref="System.MidpointRounding"> 
        '''     System.MidpointRounding</seealso>. Valor que especifica el redondeo de 
        '''    <paramref name="d">d</paramref> si su valor está a la mitad del intervalo 
        '''     entre otros dos números</param>
        ''' <returns>
        '''    Número más cercano al parámetro <paramref name="nr">nr</paramref> 
        '''    con una precisión igual al 
        '''    parámetro <paramref name="decimales">decimales</paramref>. 
        ''' 
        '''    Si <paramref name="nr">nr</paramref> se encuentra a la mitad del intervalo 
        '''    entre dos números, uno par y otro impar, el parámetro 
        '''    <paramref name="mode">mode</paramref> determina el número que se devuelve. 
        ''' 
        '''    Si la precisión de <paramref name="nr">nr</paramref> es menor que 
        '''    <paramref name="decimales">decimales</paramref>, se devuelve 
        '''    <paramref name="nr">nr</paramref> sin modificar. 
        ''' </returns>
        ''' <remarks>
        ''' <para>
        '''    El parámetro <paramref name="decimales">decimales</paramref> 
        '''    especifica el número de posiciones decimales significativas del valor devuelto,
        '''    que puede oscilar entre 0 y 28. Si decimales es cero, se devuelve un número entero.
        ''' </para>
        ''' <para>
        '''    El comportamiento de este método sigue el estándar IEEE 754, sección 4. 
        '''    Este tipo de redondeo se suele denominar redondeo al entero más próximo o 
        '''    redondeo bancario. Si decimals es cero, este redondeo suele denominar 
        '''    redondeo a cero.
        ''' </para> 
        ''' </remarks>
        Public Overloads Shared Function Round(
                    ByVal nr As NumeroRacional,
                    ByVal decimales As Integer,
                    ByVal mode As MidpointRounding) As NumeroRacional
            Return New NumeroRacional(Decimal.Round(nr.Valor, decimales, mode))
        End Function


#End Region



        ''' <summary>
        '''   Elimina los dígitos fraccionarios del numero. 
        '''   Devuelve la parte entera del valor del numero,
        '''   los dígitos fraccionarios se descartan.
        ''' </summary>
        ''' <param name="d">
        '''   La cantidad de que se va a redondear a la parte entera
        ''' </param>
        ''' <returns>
        '''    Resultado de redondear <paramref name="d">d</paramref>
        '''    al número entero más próximo, hacia cero. Es decir una clase 
        '''    <see cref="NumeroRacional">NumeroRacional</see> sin los decimales, 
        '''    solo con la parte entera del numero
        ''' </returns>
        ''' <remarks>    
        '''    Este método redondea <paramref name="d">d</paramref> al 
        '''    número entero más próximo, que tiende a cero, 
        '''    lo que supone descartar los dígitos situados tras el separador de decimales.
        '''</remarks>
        Public Overloads Shared Function Truncate(ByVal d As NumeroRacional) As NumeroRacional
            Return New NumeroRacional(d.ValorParteEntera)
        End Function


        ''' <summary>
        '''   Elimina los dígitos fraccionarios del numero. 
        '''   Devuelve la parte entera del valor del numero, 
        '''   los dígitos fraccionarios se descartan.
        ''' </summary>
        ''' <remarks>
        '''    Este método redondea <paramref name="d">d</paramref>
        '''    al número entero más próximo, que tiende a cero, lo que supone 
        '''    descartar los dígitos situados tras el separador de decimales.
        '''</remarks>
        Public Overloads Sub Truncate()
            Me.campoNumerador = CLng(Me.ValorParteEntera)
            Me.campoDenominador = 1
        End Sub





#End Region


#Region "    Implements IConvertible"



        Public Function ToType(ByVal conversionType As Type,
                           ByVal provider As IFormatProvider) _
                           As Object _
                           Implements IConvertible.ToType

            '--------------------------------------------------------
            ' Utilizar la clase Convert para realizar la conversion
            Return Convert.ChangeType(Me.Valor(), conversionType, provider)
            '' Alternativa de Convert no recomendada
            'Return Convert.ChangeType(Me.Valor(), conversionType)
            '' Forma alternativa que realiza el mismo trabajo
            'Return CType(Me.Valor(), IConvertible).ToType(conversionType, provider)
        End Function


        Public Function GetTypeCode() As TypeCode _
           Implements IConvertible.GetTypeCode
            '--------------------------------------------------------
            ' Devuelve siempre un valor Object
            '--------------------------------------------------------
            'Biblioteca de clases de .NET Framework
            'TypeCode(Enumeración)
            'http://msdn.microsoft.com/es-es/library/system.typecode.aspx
            '--------------------------------------------------------
            Return TypeCode.Object
        End Function



        Public Function ToBoolean(ByVal provider As IFormatProvider) As Boolean _
           Implements IConvertible.ToBoolean

            '--------------------------------------------------------
            ' Forma personalizada de conversion
            If Me.campoNumerador > 0 And Me.campoDenominador > 0 Then
                Return True
            Else
                Return False
            End If
            ''--------------------------------------------------------
            '' Utilizar la clase Convert para realizar la conversion
            'Return Convert.ToBoolean(Me.Valor(), provider)
            '' Alternativa de Convert no recomendada
            'Return Convert.ToBoolean(Me.Valor())
            '' Forma alternativa que realiza el mismo trabajo
            'Return CType(Me.Valor(), IConvertible).ToBoolean(provider)
            ''--------------------------------------------------------
        End Function


        Public Function ToByte(ByVal provider As IFormatProvider) As Byte _
           Implements IConvertible.ToByte
            '--------------------------------------------------------
            ' Utilizar la clase Convert para realizar la conversion
            '  Return Convert.ToByte(Me.Valor(), provider)
            '' Alternativa de Convert no recomendada
            'Return Convert.ToByte(Me.Valor())
            '' Forma alternativa que realiza el mismo trabajo
            'Return CType(Me.Valor(), IConvertible).ToByte(provider)
            Throw New InvalidCastException("Conversión no permitida")
        End Function



        Public Function ToChar(ByVal provider As IFormatProvider) As Char _
           Implements IConvertible.ToChar
            ''--------------------------------------------------------
            '' Utilizar la clase Convert para realizar la conversion
            'Return Convert.ToChar(Me.Valor(), provider)
            '' Alternativa de Convert no recomendada
            'Return Convert.ToChar(Me.Valor())
            '' Forma alternativa que realiza el mismo trabajo
            'Return CType(Me.Valor(), IConvertible).ToChar(provider)
            ''--------------------------------------------------------
            Throw New InvalidCastException("Conversión no permitida")
        End Function



        Public Function ToDateTime(ByVal provider As IFormatProvider) As DateTime _
           Implements IConvertible.ToDateTime
            ''--------------------------------------------------------
            '' Utilizar la clase Convert para realizar la conversion
            'Return Convert.ToDateTime(Me.Valor(), provider)
            '' Alternativa de Convert no recomendada
            'Return Convert.ToDateTime(Me.Valor())
            '' Forma alternativa que realiza el mismo trabajo
            'Return CType(Me.Valor(), IConvertible).ToDateTime(provider)
            ''--------------------------------------------------------
            Throw New InvalidCastException("Conversión no permitida")
        End Function


        Public Function ToDecimal(ByVal provider As IFormatProvider) As Decimal _
           Implements IConvertible.ToDecimal
            '--------------------------------------------------------
            ' Utilizar la clase Convert para realizar la conversion
            Return Convert.ToDecimal(Me.Valor(), provider)
            '' Alternativa de Convert no recomendada
            'Return Convert.ToDecimal(Me.Valor())
            '' Forma alternativa que realiza el mismo trabajo
            'Return CType(Me.Valor(), IConvertible).ToDecimal(provider)
        End Function


        Public Function ToDouble(ByVal provider As IFormatProvider) As Double _
           Implements IConvertible.ToDouble
            ''--------------------------------------------------------
            '' Utilizar la clase Convert para realizar la conversion
            Return Convert.ToDouble(Me.Valor(), provider)
            '' Alternativa de Convert no recomendada
            'Return Convert.ToDouble(Me.Valor())
            '' Forma alternativa que realiza el mismo trabajo
            'Return CType(Me.Valor(), IConvertible).ToDouble(provider)
            ''--------------------------------------------------------
        End Function


        Public Function ToInt16(ByVal provider As IFormatProvider) As Short _
           Implements IConvertible.ToInt16
            '--------------------------------------------------------
            ' Utilizar la clase Convert para realizar la conversion
            Return Convert.ToInt16(Me.Valor(), provider)
            '' Alternativa de Convert no recomendada
            'Return Convert.ToInt16(Me.Valor())
            '' Forma alternativa que realiza el mismo trabajo
            'Return CType(Me.Valor(), IConvertible).ToInt16(provider)
        End Function


        Public Function ToInt32(ByVal provider As IFormatProvider) As Integer _
           Implements IConvertible.ToInt32
            '--------------------------------------------------------
            ' Utilizar la clase Convert para realizar la conversion
            Return Convert.ToInt32(Me.Valor(), provider)
            '' Alternativa de Convert no recomendada
            'Return Convert.ToInt32(Me.Valor())
            '' Forma alternativa que realiza el mismo trabajo
            'Return CType(Me.Valor(), IConvertible).ToInt32(provider)
        End Function


        Public Function ToInt64(ByVal provider As IFormatProvider) As Long _
           Implements IConvertible.ToInt64
            '--------------------------------------------------------
            ' Utilizar la clase Convert para realizar la conversion
            Return Convert.ToInt64(Me.Valor(), provider)
            '' Alternativa de Convert no recomendada
            'Return Convert.ToInt64(Me.Valor())
            '' Forma alternativa que realiza el mismo trabajo
            'Return CType(Me.Valor(), IConvertible).ToInt64(provider)
        End Function


        'No es compatible con Common Language Specification (CLS)
        <CLSCompliantAttribute(False)>
        Public Function ToSByte(ByVal provider As IFormatProvider) As SByte _
           Implements IConvertible.ToSByte
            '--------------------------------------------------------
            ' Utilizar la clase Convert para realizar la conversion
            Return Convert.ToSByte(Me.Valor(), provider)
            '' Alternativa de Convert no recomendada
            'Return Convert.ToSByte(Me.Valor())
            '' Forma alternativa que realiza el mismo trabajo
            'Return CType(Me.Valor(), IConvertible).ToSByte(provider)
        End Function


        Public Function ToSingle(ByVal provider As IFormatProvider) As Single _
           Implements IConvertible.ToSingle
            '--------------------------------------------------------
            ' Utilizar la clase Convert para realizar la conversion
            Return Convert.ToSingle(Me.Valor(), provider)
            '' Alternativa de Convert no recomendada
            'Return Convert.ToSingle(Me.Valor())
            '' Forma alternativa que realiza el mismo trabajo
            'Return CType(Me.Valor(), IConvertible).ToSingle(provider)
        End Function


        ' -------------------------------------------------------------------------
        ' Interfaz System.IConvertible.ToString
        ' -------------------------------------------------------------------------
        ' Esta función lo que hace es llamar a la función que realmente hace el trabajo 
        ' Observa que se utiliza un truco que consiste en declararla como privada y 
        ' apuntar a la función ToString que hace el trabajo.
        ' De esta forma esta función sólo se ve desde la interfaz (que es lo que queremos)
        ' El nombre no puede ser ToString, porque ya hay una función con la misma firma y 
        ' con el mismo nombre, por eso le cambio el nombre y le pongo [ToStringIConvertible] 
        ' que considero que es un nombre representativo
        ' -------------------------------------------------------------------------
        Private Overloads Function ToStringIConvertible(
                     ByVal provider As IFormatProvider) As String _
                     Implements IConvertible.ToString

            '  -------------------------------------------------------------------------
            '  llamar a (4)ToString, La función que realmente hace el trabajo de esta interfaz
            Return ToString(provider)
        End Function



        'No es compatible con Common Language Specification (CLS)
        <CLSCompliantAttribute(False)>
        Public Function ToUInt16(ByVal provider As IFormatProvider) As UInt16 _
           Implements IConvertible.ToUInt16
            '--------------------------------------------------------
            ' Utilizar la clase Convert para realizar la conversion
            Return Convert.ToUInt16(Me.Valor(), provider)
            '' Alternativa de Convert no recomendada
            'Return Convert.ToUInt16(Me.Valor())
            '' Forma alternativa que realiza el mismo trabajo
            'Return CType(Me.Valor(), IConvertible).ToUInt16(provider)
        End Function


        'No es compatible con Common Language Specification (CLS)
        <CLSCompliantAttribute(False)>
        Public Function ToUInt32(ByVal provider As IFormatProvider) As UInt32 _
           Implements IConvertible.ToUInt32
            '--------------------------------------------------------
            ' Utilizar la clase Convert para realizar la conversion
            Return Convert.ToUInt32(Me.Valor(), provider)
            '' Alternativa de Convert no recomendada
            'Return Convert.ToUInt32(Me.Valor())
            '' Forma alternativa que realiza el mismo trabajo
            'Return CType(Me.Valor(), IConvertible).ToUInt32(provider)
        End Function


        'No es compatible con Common Language Specification (CLS)
        <CLSCompliantAttribute(False)>
        Public Function ToUInt64(ByVal provider As IFormatProvider) As UInt64 _
           Implements IConvertible.ToUInt64
            '--------------------------------------------------------
            ' Utilizar la clase Convert para realizar la conversion
            Return Convert.ToUInt64(Me.Valor(), provider)
            '' Alternativa de Convert no recomendada
            'Return Convert.ToUInt64(Me.Valor())
            '' Forma alternativa que realiza el mismo trabajo
            'Return CType(Me.Valor(), IConvertible).ToUInt64(provider)
        End Function

#End Region


#Region "Conversiones Implícitas y Explicitas"


        ' Explicit operator
        'http://msdn.microsoft.com/es-es/library/system.decimal.op_explicit(VS.80).aspx

        ' ms-help://MS.VSCC.v90/MS.msdnexpress.v90.es/dv_vbalr/html/54203dfa-c24b-463f-9942-d5153e89e762.htm

        ' Widening - Indica que un operador de conversión (CType) convierte una clase o 
        ' una clase en un tipo que puede incluir todos los valores posibles  
        ' de la clase o la clase original.
        '
        ' Narrowing - Indica que un operador de conversión (CType) convierte una clase o  
        ' una clase en un tipo que quizá no pueda incluir algunos de los  
        ' valores posibles de la clase o la clase original.




        '-------------------------------------------------------------------------------
        'Referencia general de .NET Framework
        'http://msdn.microsoft.com/es-es/library/cc433243(VS.71).aspx
        'Instrucciones de tipos de conversión
        'En las reglas siguientes se describen las instrucciones de uso de conversiones:  
        '
        'No permita conversiones implícitas que den como resultado una pérdida de precisión.  
        'Por ejemplo, no debe haber una conversión implícita de Double a Int32,  
        'pero puede haber una de Int32 a Int64.  
        '
        'No inicie excepciones en conversiones implícitas porque es muy difícil  
        'que el programador comprenda lo que está pasando. 
        'Proporcione conversiones que funcionen en todo el objeto.  
        'El valor que se convierte debe representar todo el objeto,  
        'no un miembro de un objeto. Por ejemplo, no es correcto convertir un Button  
        'en una cadena mediante la devolución de su título.  
        '
        'No genere un valor que sea semánticamente distinto. Por ejemplo, es  
        'conveniente convertir un valor DateTime o TimeSpan a un valor Int32.  
        'El valor Int32 sigue representando el tiempo o la duración.  
        'No tiene sentido, sin embargo convertir una cadena de nombre de  
        'archivo como "c:\mybitmap.gif" a un objeto Bitmap.  
        '
        'No convierta valores de dominios diferentes. Las conversiones funcionan  
        'dentro de un dominio específico de valores. Por ejemplo, los números y  
        'las cadenas pertenecen a distintos dominios. Tiene sentido convertir  
        'un valor Int32 a Double. Sin embargo, no tiene sentido convertir un  
        'valor Int32 a String, ya que estos dos valores se encuentran en  
        'dominios diferentes. 
        '------------------------------------------------------------------------------




#Region "Conversion de ALGO a NumeroRacional"


        ''------------------------------------------------
        'Dim nr As New NumeroRacional(54, 23) '= 24,086956
        ''------------------------------------------------
        '' Conversion de ALGO a NumeroRacional
        ''------------------------------------------------
        '' Implícita 
        '' No funciona, Independientemente del valor de Option Strict
        '' Solo funciona si Numero Racional define e operador [Widening CType]
        '  nr = i

        ''------------------------------------------------
        '' Explicita 
        '' No funciona, Independientemente del valor de Option Strict
        '' Solo funciona si Numero Racional define e operador [Widening CType]
        ''
        '' Realizada con la función de conversión [CInt]
        '  nr = CInt(i) ' Explicita
        '' Realizada con la función de conversión [CType]
        '  nr = CType(i, Integer) ' Explicita


        ''' <summary>
        '''   Convierte un valor lógico en una clase NumeroRacional. 
        ''' </summary>
        ''' <param name="value">un valor lógico [Boolean]</param>
        ''' <returns> Una clase NumeroRacional. 
        ''' Si el valor es TRUE  La clase toma el valor One (1,00)
        ''' Si el valor es FALSE La clase toma el valor Zero(0,00)
        ''' </returns>
        ''' <remarks>
        '''   Widening - Indica que un operador de conversión (CType) convierte una clase o 
        '''   una clase en un tipo que puede incluir todos los valores posibles  
        '''   de la clase o la clase original.
        '''</remarks>
        Public Shared Widening Operator CType(ByVal value As Boolean) As NumeroRacional
            Dim unNumeroRacional As New NumeroRacional(NumeroRacional.Zero)
            If value = True Then
                unNumeroRacional = New NumeroRacional(NumeroRacional.One)
            End If
            Return unNumeroRacional
        End Operator


        ''' <summary>Convierte un valor [Byte] en una clase NumeroRacional.</summary>
        ''' <param name="value">un valor [Byte]</param>
        ''' <returns> Una clase NumeroRacional.</returns>
        ''' <remarks>
        '''   Widening - Indica que un operador de conversión (CType) convierte una clase o 
        '''   una clase en un tipo que puede incluir todos los valores posibles  
        '''   de la clase o la clase original.
        '''</remarks>
        Public Shared Widening Operator CType(ByVal value As Byte) As NumeroRacional
            Return New NumeroRacional(CType(value, Long))
        End Operator


        ''' <summary>
        '''   [NO SOPORTADO]  Esta conversion no es posible
        ''' </summary>
        Public Shared Narrowing Operator CType(ByVal value As Char) As NumeroRacional
            Using SW As New System.IO.StringWriter(
                        System.Globalization.CultureInfo.CurrentCulture)
                SW.WriteLine("clase NumeroRacional")
                SW.WriteLine("Un valor[Char][" & value & "] no puede ")
                SW.WriteLine("ser transformado en una clase NumeroRacional [a/b]")
                SW.WriteLine("Utiliza en su lugar un valor numérico de tipo [System.Decimal] ")
                SW.Flush()
                Throw New System.InvalidCastException(SW.ToString)
            End Using
        End Operator


        ''' <summary>
        '''   [NO SOPORTADO]  Esta conversion no es posible
        ''' </summary>
        Public Shared Narrowing Operator CType(ByVal value As Date) As NumeroRacional
            Using SW As New System.IO.StringWriter(
                        System.Globalization.CultureInfo.CurrentCulture)
                SW.WriteLine("clase NumeroRacional")
                SW.WriteLine("Un valor[Date], [" & value & "] no puede ")
                SW.WriteLine("ser transformado en una clase NumeroRacional [a/b]")
                SW.WriteLine("Utiliza en su lugar un valor numérico de tipo [System.Decimal] ")
                SW.Flush()
                Throw New System.InvalidCastException(SW.ToString)
            End Using
        End Operator


        ''' <summary>
        ''' Convierte un entero de 16 bits con signo en una clase NumeroRacional. 
        ''' </summary>
        ''' <param name="value">Entero de 16 bits con signo</param>
        ''' <returns> una clase NumeroRacional</returns>
        ''' <remarks>
        '''   Widening - Indica que un operador de conversión (CType) convierte una clase o 
        '''   una clase en un tipo que puede incluir todos los valores posibles  
        '''   de la clase o la clase original.
        '''</remarks>
        Public Shared Widening Operator CType(ByVal value As Short) As NumeroRacional
            Return New NumeroRacional(CType(value, Long))
        End Operator


        ''' <summary>
        ''' Convierte un entero de 32 bits con signo en una clase NumeroRacional. 
        ''' </summary>
        ''' <param name="value">Entero de 32 bits con signo</param>
        ''' <returns>una clase NumeroRacional</returns>
        ''' <remarks>
        '''   Widening - Indica que un operador de conversión (CType) convierte una clase o 
        '''   una clase en un tipo que puede incluir todos los valores posibles  
        '''   de la clase o la clase original.
        '''</remarks>
        Public Shared Widening Operator CType(ByVal value As Integer) As NumeroRacional
            Return New NumeroRacional(CType(value, Long))
        End Operator


        ''' <summary>
        ''' Convierte un entero de 64 bits con signo en una clase NumeroRacional. 
        ''' </summary>
        ''' <param name="value">Entero de 64 bits con signo</param>
        ''' <returns>una clase NumeroRacional</returns>
        ''' <remarks>
        '''   Widening - Indica que un operador de conversión (CType) convierte una clase o 
        '''   una clase en un tipo que puede incluir todos los valores posibles  
        '''   de la clase o la clase original.
        '''</remarks>
        Public Shared Widening Operator CType(ByVal value As Long) As NumeroRacional
            Return New NumeroRacional(CType(value, Long))
        End Operator



        ''' <summary>
        ''' Convierte numero decimal con signo en una clase NumeroRacional. 
        ''' </summary>
        ''' <param name="value">numero decimal con signo</param>
        ''' <returns>una clase NumeroRacional</returns>
        ''' <remarks>
        '''   Widening - Indica que un operador de conversión (CType) convierte una clase o 
        '''   una clase en un tipo que puede incluir todos los valores posibles  
        '''   de la clase o la clase original.
        '''</remarks>
        Public Shared Widening Operator CType(ByVal value As Decimal) As NumeroRacional
            Return New NumeroRacional(value)
        End Operator


        ''' <summary>
        ''' Convierte un entero de 8 bits con signo en una clase NumeroRacional. 
        ''' Este método no es compatible con CLS.
        ''' </summary>
        ''' <param name="value">Entero de 8 bits con signo. </param>
        ''' <returns>una clase NumeroRacional</returns>
        ''' <remarks>
        '''   Widening - Indica que un operador de conversión (CType) convierte una clase o 
        '''   una clase en un tipo que puede incluir todos los valores posibles  
        '''   de la clase o la clase original.
        '''</remarks>
        <CLSCompliantAttribute(False)>
        Public Shared Widening Operator CType(ByVal value As SByte) As NumeroRacional
            Return New NumeroRacional(CType(value, Long))
        End Operator


        ''' <summary>
        ''' Convierte un entero de 16 bits sin signo en una clase NumeroRacional. 
        ''' Este método no es compatible con CLS.
        ''' </summary>
        ''' <param name="value">Entero de 16 bits sin signo. </param>
        ''' <returns>una clase NumeroRacional</returns>
        ''' <remarks>
        '''   Widening - Indica que un operador de conversión (CType) convierte una clase o 
        '''   una clase en un tipo que puede incluir todos los valores posibles  
        '''   de la clase o la clase original.
        '''</remarks>
        <CLSCompliantAttribute(False)>
        Public Shared Widening Operator CType(ByVal value As UShort) As NumeroRacional
            Return New NumeroRacional(CType(value, Long))
        End Operator


        ''' <summary>
        ''' Convierte un entero de 32 bits sin signo en una clase NumeroRacional. 
        ''' Este método no es compatible con CLS.
        ''' </summary>
        ''' <param name="value">Entero de 32 bits sin signo. </param>
        ''' <returns>una clase NumeroRacional</returns>
        ''' <remarks>
        '''   Widening - Indica que un operador de conversión (CType) convierte una clase o 
        '''   una clase en un tipo que puede incluir todos los valores posibles  
        '''   de la clase o la clase original.
        '''</remarks>
        <CLSCompliantAttribute(False)>
        Public Shared Widening Operator CType(ByVal value As UInteger) As NumeroRacional
            Return New NumeroRacional(CType(value, Long))
        End Operator


        ''' <summary>
        ''' Convierte un entero de ULong  bits sin signo en una clase NumeroRacional. 
        ''' Este método no es compatible con CLS.
        ''' </summary>
        ''' <param name="value">Entero de ULong  bits sin signo. </param>
        ''' <returns>una clase NumeroRacional</returns>
        ''' <remarks>
        '''   Narrowing - Indica que un operador de conversión (CType) convierte una clase o  
        '''   una clase en un tipo que quizá no pueda incluir algunos de los  
        '''   valores posibles de la clase o la clase original.
        ''' </remarks>
        <CLSCompliantAttribute(False)>
        Public Shared Narrowing Operator CType(ByVal value As ULong) As NumeroRacional
            Return New NumeroRacional(CType(value, Long))
        End Operator



        ''' <summary>
        '''   [NO SOPORTADO]  Esta conversion no es posible
        ''' </summary>
        ''' <remarks>
        '''   Narrowing - Indica que un operador de conversión (CType) convierte una clase o  
        '''   una clase en un tipo que quizá no pueda incluir algunos de los  
        '''   valores posibles de la clase o la clase original.
        ''' </remarks>
        Public Shared Narrowing Operator CType(ByVal value As Double) As NumeroRacional
            Using SW As New System.IO.StringWriter(
                        System.Globalization.CultureInfo.CurrentCulture)
                SW.WriteLine("clase NumeroRacional")
                SW.WriteLine("El valor de punto flotante [System.Double][" & value & "] no puede ")
                SW.WriteLine("ser clase NumeroRacional por problemas de redondeo de cantidades ")
                SW.WriteLine("Utiliza en su lugar un valor numérico de tipo [System.Decimal] ")
                SW.Flush()
                Throw New System.InvalidCastException(SW.ToString)
            End Using
        End Operator


        ''' <summary>
        '''   Convierte un número de punto flotante de precisión simple [single] 
        '''   en una clase NumeroRacional.
        ''' </summary>
        ''' <param name="value"> número de punto flotante de precisión simple [single].</param>
        ''' <returns>una clase NumeroRacional</returns>
        ''' <remarks>
        '''   Narrowing - Indica que un operador de conversión (CType) convierte una clase o  
        '''   una clase en un tipo que quizá no pueda incluir algunos de los  
        '''   valores posibles de la clase o la clase original.
        ''' </remarks>
        Public Shared Narrowing Operator CType(ByVal value As Single) As NumeroRacional
            Return New NumeroRacional(CType(value, Decimal))
        End Operator

#End Region


#Region "Conversion de NumeroRacional a ALGO"

        ''------------------------------------------------
        'Dim nr As New NumeroRacional(54, 23) '= 24,086956
        ''------------------------------------------------
        '' Conversion de NumeroRacional a ALGO
        ''------------------------------------------------
        '' Implícita 
        '' No funciona, Independientemente del valor de Option Strict
        '' Solo funciona si Numero Racional define e operador [Narrowing CType]
        '' + Con Option Strict = Off Se realiza la conversión
        '' + Con Option Strict = On  El compilador muestra un error 
        ''                           y no permite la conversión
        'i = nr
        ''------------------------------------------------
        '' Explicita
        '' No funciona, Independientemente del valor de Option Strict
        '' Solo funciona si Numero Racional define e operador [Narrowing CType]
        '' Realizada con la función de conversión [CDec]
        'i = CInt(nr)
        '' Realizada con la función de conversión [CType]
        'i = CType(nr, Integer) ' Explicita
        ''------------------------------------------------


        '''' <summary>
        ''''   Convierte una clase NumeroRacional
        ''''   en un entero de 32 bits (Integer) con signo. 
        '''' </summary>
        '''' <param name="paramNumeradorDecimal">clase NumeroRacional que se va a convertir. </param>
        '''' <returns> Entero de 32 bits con signo, resultado de la conversión </returns>
        '''' <remarks>
        ''''   Narrowing - Indica que un operador de conversión (CType) convierte una clase o  
        ''''   una clase en un tipo que quizá no pueda incluir algunos de los  
        ''''   valores posibles de la clase o la clase original.
        '''' </remarks>
        '''' <exception cref="System.OverflowException">OverflowException-  paramNumeradorDecimal es menor que 
        '''' <seealso cref="Int32.MinValue">Int32.MinValue</seealso> o mayor que 
        '''' <seealso cref="Int32.Maxvalue">Int32.Maxvalue</seealso>. 
        '''' </exception>
        'Public Shared Narrowing Operator CType(ByVal paramNumeradorDecimal As NumeroRacional) As Integer
        '    Return CType(paramNumeradorDecimal.Valor, Integer)
        'End Operator



        '-------------------------------------------------------------------------------
        ' Ver un ejemplo en
        ' http://msdn.microsoft.com/es-es/library/system.decimal.op_explicit(VS.80).aspx
        '-------------------------------------------------------------------------------

        '-------------------------------------------------------------

        ''' <summary>
        '''   [NO SOPORTADO]  Esta conversion no es posible
        ''' </summary>
        Public Shared Narrowing Operator CType(ByVal value As NumeroRacional) As Byte
            Throw New System.InvalidCastException("Esta conversion no es posible")
        End Operator


        ''' <summary>
        '''   [NO SOPORTADO]  Esta conversion no es posible
        ''' </summary>
        Public Shared Narrowing Operator CType(ByVal value As NumeroRacional) As Char
            Throw New System.InvalidCastException("Esta conversion no es posible")
        End Operator


        ''' <summary>
        '''   [NO SOPORTADO]  Esta conversion no es posible
        ''' </summary>
        Public Shared Narrowing Operator CType(ByVal value As NumeroRacional) As Date
            Throw New System.InvalidCastException("Esta conversion no es posible")
        End Operator


        ''' <summary>
        '''   Convierte una clase NumeroRacional en un número de tipo Decimal. 
        ''' </summary>
        ''' <param name="value">una clase NumeroRacional</param>
        ''' <returns> Número 
        '''          <seealso cref="System.Decimal">Decimal</seealso>, 
        '''          que representa una clase NumeroRacional convertido. </returns>
        ''' <remarks>
        ''' <para>
        '''   Narrowing - Indica que un operador de conversión (CType) convierte una clase o  
        '''   una clase en un tipo que quizá no pueda incluir algunos de los  
        '''   valores posibles de la clase o la clase original.
        ''' </para>
        '''</remarks>
        ''' <exception cref="System.OverflowException"> 
        '''    <paramref name="value">paramNumeradorDecimal</paramref> es menor que 
        '''    <seealso cref="Decimal.MinValue">Decimal.MinValue</seealso> o mayor que 
        '''    <seealso cref="Decimal.Maxvalue">Decimal.Maxvalue</seealso>. 
        ''' </exception>
        Public Shared Narrowing Operator CType(ByVal value As NumeroRacional) As Decimal
            Return CType(value.Valor, Decimal)
        End Operator



        ''' <summary>
        '''   Convierte una clase NumeroRacional
        '''   en un número de punto flotante de precisión doble en un Double. 
        ''' </summary>
        ''' <param name="value">una clase NumeroRacional</param>
        ''' <returns> Número de punto flotante de precisión doble.    
        '''          <seealso cref="System.Decimal">Double</seealso>, 
        '''          que representa una clase NumeroRacional convertido. </returns>
        ''' <remarks>
        ''' <para>
        '''   Narrowing - Indica que un operador de conversión (CType) convierte una clase o  
        '''   una clase en un tipo que quizá no pueda incluir algunos de los  
        '''   valores posibles de la clase o la clase original.
        ''' </para>
        ''' </remarks>
        ''' <exception cref="System.OverflowException"> 
        '''    <paramref name="value">paramNumeradorDecimal</paramref> es menor que 
        '''    <seealso cref="Double.MinValue">doble.MinValue</seealso> o mayor que 
        '''    <seealso cref="Double.Maxvalue">doble.Maxvalue</seealso>.  O bien, paramNumeradorDecimal es 
        '''    <seealso cref="Double.NaN">Double.NaN</seealso>, 
        '''    <seealso cref="Double.PositiveInfinity">Double.PositiveInfinity</seealso> o 
        '''    <seealso cref="Double.NegativeInfinity">Double.NegativeInfinity</seealso>. 
        ''' </exception>
        Public Shared Narrowing Operator CType(ByVal value As NumeroRacional) As Double
            Return CType(value.Valor, Double)
        End Operator


        ''' <summary>
        '''   Convierte una clase NumeroRacional
        '''   en un entero de 16 bits (Short) con signo. 
        ''' </summary>
        ''' <param name="value">una clase NumeroRacional</param>
        ''' <returns> Entero de 16 bits con signo,  
        '''          <seealso cref="System.Short">Short</seealso>,  
        '''          que representa una clase NumeroRacional convertido. </returns>
        ''' <remarks>
        ''' <para>
        '''   Narrowing - Indica que un operador de conversión (CType) convierte una clase o  
        '''   una clase en un tipo que quizá no pueda incluir algunos de los  
        '''   valores posibles de la clase o la clase original.
        ''' </para>
        '''</remarks>
        ''' <exception cref="System.OverflowException"> 
        '''    <paramref name="value">paramNumeradorDecimal</paramref> es menor que 
        '''    <seealso cref="int16.MinValue">int16.MinValue</seealso> o mayor que 
        '''    <seealso cref="int16.Maxvalue">int16.Maxvalue</seealso>. 
        ''' </exception>
        Public Shared Narrowing Operator CType(ByVal value As NumeroRacional) As Short
            Return CType(value.Valor, Short)
        End Operator


        ''' <summary>
        '''   Convierte una clase NumeroRacional
        '''   en un entero de 32 bits (Integer) con signo. 
        ''' </summary>
        ''' <param name="value">una clase NumeroRacional</param>
        ''' <returns> Entero de 32 bits con signo,  
        '''          <seealso cref="System.Int32">Integer</seealso>,  
        '''          que representa una clase NumeroRacional convertido. </returns>
        ''' <remarks>
        ''' <para>
        '''   Narrowing - Indica que un operador de conversión (CType) convierte una clase o  
        '''   una clase en un tipo que quizá no pueda incluir algunos de los  
        '''   valores posibles de la clase o la clase original.
        ''' </para>
        '''</remarks>
        ''' <exception cref="System.OverflowException"> 
        '''    <paramref name="value">paramNumeradorDecimal</paramref> es menor que 
        '''    <seealso cref="Int32.MinValue">Int32.MinValue</seealso> o mayor que 
        '''    <seealso cref="Int32.Maxvalue">Int32.Maxvalue</seealso>. 
        ''' </exception>
        Public Shared Narrowing Operator CType(ByVal value As NumeroRacional) As Integer
            Return CType(value.Valor, Integer)
        End Operator


        ''' <summary>
        '''   Convierte una clase NumeroRacional
        '''   en un entero de 64 bits (Long) con signo. 
        ''' </summary>
        ''' <param name="value">una clase NumeroRacional</param>
        ''' <returns> Entero de 64 bits con signo,  
        '''          <seealso cref="System.Int32">long</seealso>, 
        '''          que representa una clase NumeroRacional convertido. </returns>
        ''' <remarks>
        ''' <para>
        '''   Narrowing - Indica que un operador de conversión (CType) convierte una clase o  
        '''   una clase en un tipo que quizá no pueda incluir algunos de los  
        '''   valores posibles de la clase o la clase original.
        ''' </para>
        '''</remarks>
        ''' <exception cref="System.OverflowException"> 
        '''    <paramref name="value">paramNumeradorDecimal</paramref> es menor que 
        '''    <seealso cref="Int64.MinValue">Int64.MinValue</seealso> o mayor que 
        '''    <seealso cref="Int64.Maxvalue">Int64.Maxvalue</seealso>. 
        ''' </exception>
        Public Shared Narrowing Operator CType(ByVal value As NumeroRacional) As Long
            Return CType(value.Valor, Long)
        End Operator


        ''' <summary>
        '''   Convierte una clase NumeroRacional
        '''   en un entero de 8 bits (SByte) con signo. 
        '''   Este método no es compatible con CLS.
        '''   La alternativa compatible con CLS es ToInt16
        ''' </summary>
        ''' <param name="value">una clase NumeroRacional</param>
        ''' <returns> Entero de 8 bits con signo,  
        '''          <seealso cref="System.SByte">SByte</seealso>, 
        '''          que representa una clase NumeroRacional convertido. </returns>
        ''' <remarks>
        ''' <para>
        '''   Narrowing - Indica que un operador de conversión (CType) convierte una clase o  
        '''   una clase en un tipo que quizá no pueda incluir algunos de los  
        '''   valores posibles de la clase o la clase original.
        ''' </para>
        '''</remarks>
        ''' <exception cref="System.OverflowException"> 
        '''    <paramref name="value">paramNumeradorDecimal</paramref> es menor que 
        '''    <seealso cref="SByte.MinValue">SByte.MinValue</seealso> o mayor que 
        '''    <seealso cref="SByte.Maxvalue">SByte.Maxvalue</seealso>. 
        ''' </exception>
        <CLSCompliantAttribute(False)>
        Public Shared Narrowing Operator CType(ByVal value As NumeroRacional) As SByte
            Return CType(value.Valor, SByte)
        End Operator


        ''' <summary>
        '''   Convierte una clase NumeroRacional
        '''   en un número de punto flotante de precisión simple. 
        ''' </summary>
        ''' <param name="value">una clase NumeroRacional</param>
        ''' <returns> Número de punto flotante de precisión simple    
        '''          <seealso cref="System.Single">Single</seealso>, 
        '''          que representa una clase NumeroRacional convertido. </returns>
        ''' <remarks>
        ''' <para>
        '''   Esta operación puede producir errores de redondeo porque un número
        '''   de punto flotante de precisión simple tiene menos dígitos significativos 
        '''   que el valor Long subyacente en la clase NumeroRacional.
        ''' </para>
        ''' <para>
        '''   Narrowing - Indica que un operador de conversión (CType) convierte una clase o  
        '''   una clase en un tipo que quizá no pueda incluir algunos de los  
        '''   valores posibles de la clase o la clase original.
        ''' </para>
        '''</remarks>
        ''' <exception cref="System.OverflowException"> 
        '''    <paramref name="value">paramNumeradorDecimal</paramref> es menor que 
        '''    <seealso cref="Single.MinValue">Single.MinValue</seealso> o mayor que 
        '''    <seealso cref="Single.Maxvalue">Single.Maxvalue</seealso>. 
        ''' </exception>
        Public Shared Narrowing Operator CType(ByVal value As NumeroRacional) As Single
            Return CType(value.Valor, Single)
        End Operator


        ''' <summary>
        '''   Convierte una clase NumeroRacional
        '''   en un entero de 16 bits [UShort] sin signo.
        '''   Este método no es compatible con CLS.  La alternativa compatible con CLS es ToInt32.
        ''' </summary>
        ''' <param name="value">una clase NumeroRacional</param>
        ''' <returns> Entero 16 bits sin signo,  
        '''          <seealso cref="System.UShort">UShort</seealso>, 
        '''          que representa una clase NumeroRacional convertido. </returns>
        ''' <remarks>
        ''' <para>
        '''   Narrowing - Indica que un operador de conversión (CType) convierte una clase o  
        '''   una clase en un tipo que quizá no pueda incluir algunos de los  
        '''   valores posibles de la clase o la clase original.
        ''' </para>
        '''</remarks>
        ''' <exception cref="System.OverflowException"> 
        '''    <paramref name="value">paramNumeradorDecimal</paramref> es menor que 
        '''    <seealso cref="UShort.MinValue">UShort.MinValue</seealso> o mayor que 
        '''    <seealso cref="UShort.Maxvalue">UShort.Maxvalue</seealso>. 
        ''' </exception>
        <CLSCompliantAttribute(False)>
        Public Shared Narrowing Operator CType(ByVal value As NumeroRacional) As UShort
            Return CType(value.Valor, UShort)
        End Operator


        ''' <summary>
        '''   Convierte una clase NumeroRacional
        '''   en un entero de 32 bits [UInteger] sin signo.
        '''   Este método no es compatible con CLS.  La alternativa compatible con CLS es ToInt64.
        ''' </summary>
        ''' <param name="value">una clase NumeroRacional</param>
        ''' <returns> Entero 32 bits sin signo,  
        '''          <seealso cref="System.UInteger">UInteger</seealso>, 
        '''          que representa una clase NumeroRacional convertido. </returns>
        ''' <remarks>
        ''' <para>
        '''   Narrowing - Indica que un operador de conversión (CType) convierte una clase o  
        '''   una clase en un tipo que quizá no pueda incluir algunos de los  
        '''   valores posibles de la clase o la clase original.
        ''' </para>
        '''</remarks>
        ''' <exception cref="System.OverflowException"> 
        '''    <paramref name="value">paramNumeradorDecimal</paramref> es menor que 
        '''    <seealso cref="UInteger.MinValue">UInteger.MinValue</seealso> o mayor que 
        '''    <seealso cref="UInteger.Maxvalue">UInteger.Maxvalue</seealso>. 
        ''' </exception>
        <CLSCompliantAttribute(False)>
        Public Shared Narrowing Operator CType(ByVal value As NumeroRacional) As UInteger
            Return CType(value.Valor, UInteger)
        End Operator

        ''' <summary>
        '''   Convierte una clase NumeroRacional
        '''   en un entero de 64 bits [ULong] sin signo.
        '''   Este método no es compatible con CLS.
        ''' </summary>
        ''' <param name="value">una clase NumeroRacional</param>
        ''' <returns> Entero 64 bits sin signo,  
        '''          <seealso cref="System.ULong">ULong</seealso>, 
        '''          que representa una clase NumeroRacional convertido. </returns>
        ''' <remarks>
        ''' <para>
        '''   Narrowing - Indica que un operador de conversión (CType) convierte una clase o  
        '''   una clase en un tipo que quizá no pueda incluir algunos de los  
        '''   valores posibles de la clase o la clase original.
        ''' </para>
        '''</remarks>
        ''' <exception cref="System.OverflowException"> 
        '''    <paramref name="value">paramNumeradorDecimal</paramref> es menor que 
        '''    <seealso cref="ULong.MinValue">ULong.MinValue</seealso> o mayor que 
        '''    <seealso cref="ULong.Maxvalue">ULong.Maxvalue</seealso>. 
        ''' </exception>
        <CLSCompliantAttribute(False)>
        Public Shared Narrowing Operator CType(ByVal value As NumeroRacional) As ULong
            Return CType(value.Valor, ULong)
        End Operator


#End Region


#End Region


#Region "IDisposable Support.   [Para clases normales y bases ] Implementación de .NET Version: [2022/03/03]"

        ''' <summary>
        '''  Variable local para detectar llamadas redundantes que indica [True] el objeto se ha eliminado, [False], en caso contrario. 
        ''' </summary>
        Private campoDisposedValue As System.Boolean
        '
        ''' <summary>
        '''     Obtiene un valor que indica si el objeto se ha eliminado. 
        ''' </summary>
        ''' <paramNumeradorDecimal>
        '''   <para>Tipo: <see cref="System.Boolean">Boolean</see></para>
        '''   <para>Es true si objeto se ha eliminado; en caso contrario, es false.</para>
        ''' </paramNumeradorDecimal>
        Public Overloads ReadOnly Property IsDisposed() As System.Boolean
            Get
                Return campoDisposedValue
            End Get
        End Property


        ''' <summary>
        '''  [Dispose] Código de limpieza de la clase
        ''' </summary>
        ''' <param name="paramQuienMeLLama">[True], llama el usuario, [False], llama el sistema</param>
        ''' <remarks>
        '''  <para>
        '''     Dispose (bool quienMeLLama) se ejecuta en dos escenarios distintos.
        '''  </para>
        '''  <para>
        '''     Si [quienMeLLama] es igual a true, el método ha sido llamado 
        '''     directamente, o indirectamente, por el código de un usuario. 
        '''     Los recursos administrados y no administrados se pueden eliminar.
        '''  </para>
        '''  <para>
        '''     Si [quienMeLLama] es igual a false, el método ha sido llamado por el
        '''     [runtime] desde el interior del finalizador y usted no debe hacer 
        '''     referencia a otros objetos, ni siquiera para eliminarlos.
        '''     Solo los recursos no administrados pueden ser eliminados.
        '''  </para>
        ''' </remarks>
        Public Overloads Sub Dispose(paramQuienMeLLama As System.Boolean)
            If Me.campoDisposedValue = False Then
                If paramQuienMeLLama = True Then
                    Me.campoDisposedValue = True

                    '------------------------------------------------------------------------------------------
                    ' 1) Liberar UNICAMENTE objetos NO administrados.
                    '    Son recursos que NO administra el motor en tiempo de ejecución,  
                    '    como conexiones a bases de datos
                    '    llamadas al API de Windows, etc. el Word o Excel
                    '------------------------------------------------------------------------------------------
                    'Call LiberarRecursosNoAdministrados()

                    '------------------------------------------------------------------------------------------
                    ' 2) Desechar objetos SI administrados.
                    '    Un objeto administrado es cualquier objeto de .NET
                    '    es un objeto de .NET que maneja el motor de ejecución de NET
                    '------------------------------------------------------------------------------------------
                    'If Not (objeto Is Nothing) Then
                    '    objeto = Nothing
                    'End If
                    '------------------------------------------------------------------------------------------
                    ' 3) Establecer campos grandes como Null.
                    '------------------------------------------------------------------------------------------
                    Me.campoNumerador = Nothing
                    Me.campoDenominador = Nothing

                Else

                    '------------------------------------------------------------------------------------------
                    ' 1) Liberar UNICAMENTE los objetos NO administrados.
                    '------------------------------------------------------------------------------------------
                    'Call LiberarRecursosNoAdministrados()

                End If

            End If
        End Sub

        '    ''' <summary>
        '    ''' 1) Liberar objetos NO administrados.
        '    '''    Son recursos que NO administra el motor en tiempo de ejecución,  
        '    '''    como conexiones a bases de datos
        '    '''    llamadas al API de Windows, etc. el Word o Excel    
        '    '''    </summary>
        '    ''' <remarks>
        '    '''  ATENCION - Quite los comentarios de Finalize() SOLO si el anterior Dispose(disposing As Boolean)
        '    '''             tiene código para liberar recursos no administrados.
        '    ''' </remarks>
        '    Private Sub LiberarRecursosNoAdministrados()
        '        ' si no hay recursos, no hacer nada
        '    End Sub



        '  ''' <summary>
        '  '''  Permite que un objeto intente liberar recursos NO ADMINISTRADOS y realizar otras operaciones de limpieza 
        '  '''  antes de que sea reclamado por la recolección de elementos no utilizados.
        '  ''' </summary>
        '  ''' <remarks>
        '  '''  ATENCION - Quite los comentarios de Finalize() SOLO si el anterior Dispose(disposing As Boolean)
        '  '''             tiene código para liberar recursos no administrados.
        '  ''' </remarks>
        '  Protected Overrides Sub Finalize()
        '      'ATENCION - Quite los comentarios de Finalize() SOLO si el anterior Dispose(disposing As Boolean)
        '      '           tiene código para liberar recursos no administrados.
        '      ' No cambie este código. Coloque el código de limpieza en el anterior Dispose(disposing As Boolean).
        '      Dispose(False)
        '      MyBase.Finalize()
        '  End Sub


        ''' <summary>
        '''  [Dispose] Código de limpieza de la clase
        ''' </summary>
        ''' <remarks>
        '''  Visual Basic agregó este código para implementar correctamente el patrón descartable.
        '''  No cambie este código. Coloque el código de limpieza en Dispose(disposing As Boolean).
        ''' </remarks>
        Public Overloads Sub Dispose() Implements IDisposable.Dispose
            Me.Dispose(True)
            'Este objeto se limpiará con el método Dispose.
            'Por lo tanto, debe llamar a GC.SupressFinalize para
            'quitar este objeto de la cola de finalización
            'y evitar que el código de finalización para este objeto
            'se ejecute por segunda vez. 
            GC.SuppressFinalize(Me)
        End Sub
#End Region



#Region "Parse"

#Region "Parse - Corregir cadena"

        '''------------------------------------------------------------------------
        ''' <summary>
        '''   La <seealso cref="System.String">cadena</seealso>  
        '''   de texto que contiene un número se modifica para que tenga formato español [es-ES]. 
        ''' </summary>
        ''' <param name="s">
        '''    <seealso cref="System.String">String</seealso> 
        '''     Que contiene el número que se va a transformar a formato numérico español. 
        ''' </param>
        ''' <returns>La cadena que contiene un numero pero con formato numérico [es-ES] </returns>
        ''' <remarks>
        ''' <para>El parámetro <paramref name="s">s</paramref> 
        '''       debe contener un número con el siguiente formato: </para>
        ''' <para>[eb][signo]dígitos[.dígitos fraccionarios][eb]</para>
        ''' <para>
        '''        Los elementos que aparecen entre corchetes ('[' y ']') son opcionales y el 
        '''        resto de elementos son como se indica a continuación.
        ''' </para>
        ''' <para>[eb] - Espacio en blanco opcional. </para>
        ''' <para>[signo] - Signo opcional. </para>
        ''' <para>[dígitos] -Secuencia de dígitos comprendidos entre el 0 y el 9. </para>
        ''' <para>['.'] - Símbolo separador de decimales específico de la referencia cultural. </para>
        ''' <para>[dígitos fraccionarios] - Secuencia de dígitos comprendidos entre el 0 y el 9. </para>
        ''' <para>
        ''' El proceso de corrección de los números se rige por el siguiente protocolo:
        ''' </para>
        ''' <para>
        ''' El proceso de corrección solo funciona si la cultura local tiene el mismo 
        ''' formato numérico que la cultura española (es-ES) es decir, 
        ''' una coma decimal (,) y el punto (.) de separación los millares.
        ''' </para>
        ''' <para>
        ''' El numero [1,234,567.25] y el número [1,234,567] están seguro en ingles, y 
        ''' además sin ninguna duda es decir, si un numero tiene dos o más comas y 
        ''' cero (0) o un (1) punto, está en ingles seguro y sin ninguna duda, 
        ''' y cambio su formato
        ''' </para>
        ''' <para>
        ''' Hay números en los que es más difícil saber en qué formato están y son 
        ''' los que tienen una coma y un punto por ejemplo [12.346,67] y [12,345.78], 
        ''' para averiguarlo tengo que mirar las posiciones , si la coma es la que 
        ''' está a la derecha es un numero español. Si el punto es el que está a la 
        ''' derecha es un número inglés, y cambio su formato
        ''' </para>
        ''' <para>
        ''' Cuando el número solo tiene una coma o un punto entonces también tengo la 
        ''' duda porque puede ser el número [1.200] el mil doscientos número en español, 
        ''' o el una unidad con veinte decimal en inglés. Pero, pensando en que cuando 
        ''' yo introduzco los números (por vagancia) no pulso los separadores de millar, 
        ''' y además, este código funciona siempre que el formato numérico sea el español, 
        ''' supongo que el número tiene que ser un número decimal español que esta 
        ''' introducido con el teclado numérico usando el punto del teclado en lugar de la 
        ''' coma decimal, por lo que cambio su formato
        ''' </para>
        ''' <para>
        '''    Si, durante una operación de análisis, se encuentra un carácter de moneda 
        '''    (por ejemplo, $, €) se produce un error del tipo 
        '''   <seealso cref="System.FormatException">FormatException</seealso>
        ''' </para>
        '''</remarks>
        ''' <exception cref="FormatException">
        '''            <paramref name="s">s</paramref>         '''            no tiene el formato correcto. 
        ''' </exception>
        Private Shared Function CorregirCadenaConNumeroToCulturaEspañola(ByVal s As String) As String

            Dim signoMas As Char = CType(System.Globalization.NumberFormatInfo.CurrentInfo.PositiveSign, Char)

            Dim signoMenos As Char = CType(System.Globalization.NumberFormatInfo.CurrentInfo.NegativeSign, Char)

            Dim SeparadorDecimal As Char = CType(System.Globalization.NumberFormatInfo.CurrentInfo.CurrencyDecimalSeparator, Char)

            Dim SeparadorMillares As Char = CType(System.Globalization.NumberFormatInfo.CurrentInfo.CurrencyGroupSeparator, Char)

            '--------------------
            'Carácter que leo en la cadena cuando hago exploraciones
            Dim unCaracter As Char


            '-----------------------------------------------------------
            '--------- Condición ------------
            '* Tiene que tener algún carácter. Si vacía o null poner un cero [0])
            If String.IsNullOrEmpty(s) = True Then
                s = "0"
            End If


            '-----------------------------------------------------------
            '--------- Condición ------------
            '* Si aparece una cadena del tipo [,234] convertirla en [0,234]
            If s.StartsWith(SeparadorDecimal) Then
                s = "0" & s
            End If


            '-----------------------------------------------------------
            '--------- Condición ------------
            '* Si aparece una cadena del tipo [+,234] convertirla en [+0,234]
            If s.StartsWith(signoMas & SeparadorDecimal, System.StringComparison.OrdinalIgnoreCase) Then
                s = signoMas & "0" &
                 s.Substring(2, (s.Length - 2))
            End If

            '-----------------------------------------------------------
            '--------- Condición ------------
            '* Si aparece una cadena del tipo [-,234] convertirla en [-0,234]
            If s.StartsWith(signoMenos & SeparadorDecimal, System.StringComparison.OrdinalIgnoreCase) Then
                s = signoMenos & "0" &
                 s.Substring(2, (s.Length - 2))
            End If



            '-----------------------------------------------------------
            '--------- Condición ------------
            '* no puede haber dos puntos (..) seguidos, es un error
            If s.Contains(SeparadorMillares & SeparadorMillares, System.StringComparison.OrdinalIgnoreCase) Then
                Throw New FormatException(
            "La cadena con el número[" & s &
            "] contiene un carácter prohibido [" &
            SeparadorMillares & SeparadorMillares & "]")
            End If


            '-----------------------------------------------------------
            '--------- Condición ------------
            '* no puede haber dos comas  (,,) seguidas, es un error
            If s.Contains(SeparadorDecimal & SeparadorDecimal, System.StringComparison.OrdinalIgnoreCase) Then
                Throw New FormatException(
            "La cadena con el número[" & s &
            "] contiene un carácter prohibido [" &
            SeparadorDecimal & SeparadorDecimal & "]")
            End If

            '-----------------------------------------------------------
            '--------- Condición ------------
            ' * espacios SI delante y/o detrás, pero NO en medio del numero
            ' primero quitar los espacios delante y detrás
            s = s.Trim
            ' después buscar espacios en medio de la cadena
            If s.IndexOf(" ", 0, System.StringComparison.OrdinalIgnoreCase) <> -1 Then
                Throw New FormatException(
            "La cadena con el número[" & s &
            "] contiene un carácter prohibido [Un Espacio]")
            End If

            '-----------------------------------------------------------
            '--------- Condición ------------
            ' control de signos + y -
            '* signo [+] y [-] ninguno, o solo uno de ellos
            '* Al principio de la cadena
            Dim contador As Integer = 0
            Dim caracter As Char

            For Each caracter In s
                If caracter = signoMas Then contador += 1
                If caracter = signoMenos Then contador += 1
            Next
            If contador > 1 Then
                Throw New ArgumentException(
            "La cadena con el número[" & s &
            "] contiene un carácter prohibido [" &
            signoMas & "/" & signoMenos &
            "] no esta permitido mas de un signo")
            End If

            If contador = 1 Then
                If s.IndexOf(signoMas, 0) <> -1 AndAlso
               s.IndexOf(signoMenos, 0) <> -1 Then
                    Throw New FormatException(
                "Los signos + y - tienen que estar al principio de la cadena")
                End If
            End If


            '-----------------------------------------------------------
            '--------- Condición ------------
            ' Los caracteres alfabéticos no están permitidos
            For Each caracter In s
                If caracter = signoMas Then contador += 1
                If caracter = signoMenos Then contador += 1

                ' Búsqueda de letras en la cadena 
                If Char.IsLetter(caracter) = True Then
                    Throw New ArgumentException(
                "La cadena con el número[" & s &
                "] contiene un carácter prohibido [" & caracter &
                "] no están permitidos los caracteres alfabéticos (solo dígitos)")
                End If
            Next



            '--------------------------------------------------------
            '--------------------------------------------------------------------
            ' ESTA PARTE DE CODIGO SOLO TIENE QUE FUNCIONAR SI LA 
            ' CURRENT CULTURE UTILIZA EL FOMATO NUMERICO ESPAÑOL
            ' POR ESO SE UTILIZAN DE FORMA EXPLICTA EL CARACTER (,) Y EL CARACTER (.)
            '--------------------------------------------------------------------
            ' intentar corregir el que exista un punto decimal
            ' este trozo de código solo funciona con la cultura española
            ' currentculture="es-ES"
            ' la idea es corregir números decimales que vengan en formato anglosajón
            ' utilizando como separador decimal el punto anglosajón
            '-----------------------------------
            ' 
            'Problema: ¿como averiguo el formato del numero?
            ' + El proceso de corrección de los números se rige por el siguiente protocolo:
            ' + El numero [1,234,567.25] y el número [1,234,567] están seguro en ingles,  
            '   y además sin ninguna duda es decir, si un numero tiene dos o más comas y  
            '   cero (0) o un (1) punto, está en ingles seguro y sin ninguna duda,  
            '   y cambio su formato
            ' + Hay números en los que es más difícil saber en qué formato están y  
            '   son los que tienen una coma y un punto por ejemplo [12.346,67] y [12,345.78],  
            '   para averiguarlo tengo que mirar las posiciones , si la coma es la que  
            '   está a la derecha es un numero español. Si el punto es el que está a la  
            '   derecha es un número inglés, y cambio su formato
            ' + Cuando el número solo tiene una coma o un punto entonces también tengo  
            '   la duda porque puede ser el número [1.200] el mil doscientos número en  
            '   español, o el una unidad con veinte decimal en inglés.  
            '   Pero, pensando en que cuando yo introduzco los números (por vagancia)  
            '   no pulso los separadores de millar, y además, este código funciona  
            '   siempre que el formato numérico sea el español, supongo que el número  
            '   tiene que ser un número decimal español que esta introducido con el  
            '   teclado numérico usando el punto del teclado en lugar de la coma  
            '   decimal, por lo que cambio su formato
            '--------------------------------------------------------------------
            ' ESTA PARTE DE CODIGO SOLO TIENE QUE FUNCIONAR SI LA 
            ' CURRENT CULTURE UTILIZA EL FOMATO NUMERICO ESPAÑOL
            ' POR ESO SE UTILIZAN DE FORMA EXPLICTA EL CARACTER (,) Y EL CARACTER (.)
            '--------------------------------------------------------------------
            '
            If System.Globalization.CultureInfo.CurrentCulture.NumberFormat.CurrencyDecimalSeparator = ","c AndAlso
           System.Globalization.CultureInfo.CurrentCulture.NumberFormat.CurrencyGroupSeparator = "."c Then

                'vale, aquí la cultura current culture utiliza la coma decimal y el punto de los millares

                '----------------------------------------------------------------
                ' Lo primero es contar el numero de comas y de puntos que tiene el numero
                Dim contadorComas As Integer = 0
                Dim contadorPuntos As Integer = 0

                For Each unCaracter In s
                    If unCaracter = ","c Then contadorComas += 1
                    If unCaracter = "."c Then contadorPuntos += 1
                Next

                '----------------------------------------------------------------
                ' + El numero [1,234,567.25] y el número [1,234,567] están seguro en ingles,  
                '   y además sin ninguna duda es decir, si un numero tiene dos o más comas y  
                '   cero (0) o un (1) punto, está en ingles seguro y sin ninguna duda,  
                '   y cambio su formato
                If contadorPuntos <= 1 AndAlso contadorComas > 1 Then
                    'reemplazo la coma  por el carácter A
                    ' sé que no hay ninguna letra porque se ha comprobado en 
                    ' esta misma función un poco antes
                    s = s.Replace(","c, "A"c)
                    'reemplazo los puntos por las comas
                    s = s.Replace("."c, ","c)
                    s = s.Replace("A"c, "."c)
                End If


                '----------------------------------------------------------------
                ' + Hay números en los que es más difícil saber en qué formato están y  
                '   son los que tienen una coma y un punto por ejemplo [12.346,67] y [12,345.78],  
                '   para averiguarlo tengo que mirar las posiciones , si la coma es la que  
                '   está a la derecha es un numero español. Si el punto es el que está a la  
                '   derecha es un número inglés, y cambio su formato
                If contadorPuntos = 1 AndAlso contadorComas = 1 Then
                    Dim posicionPunto As Integer = s.IndexOf("."c, 0)
                    Dim posicionComa As Integer = s.IndexOf(","c, 0)

                    If posicionPunto > posicionComa Then
                        'Si el punto es el que está a la derecha es un número ingles
                        'reemplazo la coma  por el carácter A
                        ' sé que no hay ninguna letra porque se ha comprobado en 
                        ' esta misma función un poco antes
                        s = s.Replace(","c, "A"c)
                        'reemplazo los puntos por las comas
                        s = s.Replace("."c, ","c)
                        s = s.Replace("A"c, "."c)
                    End If
                End If


                '----------------------------------------------------------------
                ' + Cuando el número solo tiene una coma o un punto entonces también tengo  
                '   la duda porque puede ser el número [1.200] el mil doscientos número en  
                '   español, o el una unidad con veinte decimal en inglés.  
                '   Pero, pensando en que cuando yo introduzco los números (por vagancia)  
                '   no pulso los separadores de millar, y además, este código funciona  
                '   siempre que el formato numérico sea el español, supongo que el número  
                '   tiene que ser un número decimal español que esta introducido con el  
                '   teclado numérico usando el punto del teclado en lugar de la coma  
                '   decimal, por lo que cambio su formato
                If contadorPuntos = 1 AndAlso contadorComas = 0 Then
                    'reemplazo la coma  por el carácter A
                    ' sé que no hay ninguna letra porque se ha comprobado en 
                    ' esta misma función un poco antes
                    s = s.Replace(","c, "A"c)
                    'reemplazo los puntos por las comas
                    s = s.Replace("."c, ","c)
                    s = s.Replace("A"c, "."c)
                End If
            End If

            '---------------------------------------------------------------
            ' devolver la cadena con el numero corregida al formato español 
            ' casi con toda seguridad
            Return s

        End Function

#End Region


        '''----------------------------------------------------------------------------
        ''' <summary>
        '''      Convierte la representación de tipo String de un número en su 
        '''      NumeroRacional equivalente    
        '''  </summary>
        '''  <param name="s">Que contiene una cadena con un número que se va a convertir.</param>
        ''' <returns>Una clase NumeroRacional 
        '''          equivalente al número contenido en <paramref name="s">s</paramref>.
        ''' </returns>
        ''' <remarks>
        ''' <para>El parámetro <paramref name="s">s</paramref> contiene un número con formato: </para>
        ''' <para>[eb][signo]dígitos[.dígitos fraccionarios][eb] </para>
        ''' <para>Los elementos que aparecen entre corchetes ('[' y ']') 
        '''       son opcionales y el resto de elementos son como se indica a continuación.</para>
        ''' <para>eb - Espacio en blanco opcional. </para>
        ''' <para>signo - Signo opcional. </para>
        ''' <para>dígitos -Secuencia de dígitos comprendidos entre el 0 y el 9. </para>
        ''' <para>'.' - Símbolo separador de decimales específico de la referencia cultural. </para>
        ''' <para>dígitos fraccionarios - Secuencia de dígitos comprendidos entre el 0 y el 9. </para>
        ''' <para>El parámetro <paramref name="s">s</paramref> se interpreta utilizando el estilo 
        '''       <seealso cref="System.Globalization.NumberStyles.Number">NumberStyles.Number</seealso>.
        ''' </para>
        ''' <para>El parámetro <paramref name="s">s</paramref> se analiza utilizando la información 
        '''       de formato de NumberFormatInfo que se inicializa para la referencia cultural 
        '''       del sistema actual. Para obtener más información, vea
        '''       <seealso cref="System.Globalization.CultureInfo">CurrentInfo</seealso> .
        ''' </para>
        ''' <para>Si es necesario, el valor de <paramref name="s">s</paramref> se redondea 
        '''       mediante el redondeo al más próximo.</para>
        ''' <para>Si, durante una operación de análisis, se encuentra un separador en el  
        '''       parámetro <paramref name="s">s</paramref> y los separadores aplicables 
        '''       de moneda, número decimal y grupo son iguales, la operación de análisis 
        '''       supone que se trata de un separador decimal en lugar de un separador de
        '''       grupo. Para obtener más información sobre separadores, vea 
        '''       <seealso cref="System.Globalization.NumberFormatInfo.CurrencyDecimalSeparator">
        '''       CurrencyDecimalSeparator</seealso>, 
        '''       <seealso cref="System.Globalization.NumberFormatInfo.NumberDecimalSeparator">
        '''       NumberDecimalSeparator</seealso>, 
        '''       <seealso cref="System.Globalization.NumberFormatInfo.CurrencyGroupSeparator">
        '''       CurrencyGroupSeparator</seealso> y 
        '''       <seealso cref="System.Globalization.NumberFormatInfo.NumberGroupSeparator">
        '''       NumberGroupSeparator</seealso>.
        ''' </para>
        '''</remarks>
        ''' <exception cref="ArgumentNullException">El valor de <paramref name="s">s</paramref> 
        '''            es null (Nothing en Visual Basic). </exception>
        ''' <exception cref="FormatException"><paramref name="s">s</paramref> 
        '''            no tiene el formato correcto. </exception>
        ''' <exception cref="OverflowException"><paramref name="s">s</paramref> 
        '''            representa un número menor que 
        '''            <seealso cref="System.Decimal.MinValue">MinValue</seealso> o mayor que 
        '''            <seealso cref="System.Decimal.MaxValue">MaxValue</seealso>. 
        ''' </exception>
        Public Overloads Shared Function Parse(ByVal s As String) As NumeroRacional
            Try
                s = CorregirCadenaConNumeroToCulturaEspañola(s)
                ' ------------------------------------
                Dim numeroDecimal As Decimal
                numeroDecimal = Decimal.Parse(s)
                ' ------------------------------------
                ' regla FxCop
                '   replace this call with a 
                '   call to 'NumeroRacional.New(d, CultureInfo)'. 
                ' ------------------------------------
                ' No la cumplo porque el constructor ya lo hace 
                ' ------------------------------------
                Dim unNumeroRacional As New NumeroRacional(numeroDecimal)
                Return unNumeroRacional
            Catch ex As Exception
                Throw
            End Try
        End Function



        ''' <summary>
        '''      Convierte la representación de tipo String de un número en su 
        '''      NumeroRacional equivalente    
        '''  </summary>
        '''  <param name="s">Que contiene una cadena con un número que se va a convertir.</param>
        ''' <param name="style">
        '''    <seealso cref="System.Globalization.NumberStyles">
        '''                   System.Globalization.NumberStyles</seealso> 
        '''    Una combinación bit a bit de valores NumberStyles que indica el formato 
        '''    permitido de <paramref name="s">s</paramref>. 
        '''    Un valor que se especifica de forma habitual es 
        '''    <seealso cref="System.Globalization.NumberStyles.Number">Number</seealso>  
        ''' </param>
        ''' <returns>Una clase NumeroRacional 
        '''          equivalente al número contenido en <paramref name="s">s</paramref>.
        ''' </returns>
        Public Overloads Shared Function Parse(
                            ByVal s As String,
                            ByVal style As Globalization.NumberStyles) _
                            As NumeroRacional
            Try
                s = CorregirCadenaConNumeroToCulturaEspañola(s)
                ' ------------------------------------
                Dim numeroDecimal As Decimal
                numeroDecimal = Decimal.Parse(s, style)
                Dim unNumeroRacional As New NumeroRacional(numeroDecimal)
                Return unNumeroRacional
            Catch ex As Exception
                Throw
            End Try
        End Function


        '''<summary>
        '''      Convierte la representación de tipo String de un número en su 
        '''      NumeroRacional equivalente    
        ''' </summary>
        ''' <param name="s">Que contiene una cadena con un número que se va a convertir.</param>
        ''' <param name="provider">
        '''    Objeto <seealso cref="System.IFormatProvider">IFormatProvider</seealso> 
        '''    que proporciona información de análisis específico de la referencia cultural sobre 
        '''    <paramref name="s">s</paramref>. 
        ''' </param>
        ''' <returns>Una clase NumeroRacional 
        '''          equivalente al número contenido en <paramref name="s">s</paramref>.
        ''' </returns>
        Public Overloads Shared Function Parse(
                               ByVal s As System.String,
                               ByVal provider As System.IFormatProvider) _
                               As NumeroRacional
            Try
                ' ------------------------------------
                ' No se corrige la cadena porque se proporciona un provider para analizarla
                ' ------------------------------------
                Dim numero As Decimal
                numero = Decimal.Parse(s, provider)
                ' ------------------------------------
                Dim unNumeroRacional As New NumeroRacional(numero)
                Return unNumeroRacional
            Catch ex As Exception
                Throw
            End Try
        End Function



        '''<summary>
        '''      Convierte la representación de tipo String de un número en su 
        '''      NumeroRacional equivalente    
        ''' </summary>
        ''' <param name="s">Que contiene una cadena con un número que se va a convertir.</param>
        ''' <param name="style">
        '''    <seealso cref="System.Globalization.NumberStyles">
        '''                   System.Globalization.NumberStyles</seealso> 
        '''    Una combinación bit a bit de valores NumberStyles que indica el formato 
        '''    permitido de <paramref name="s">s</paramref>. 
        '''    Un valor que se especifica de forma habitual es 
        '''    <seealso cref="System.Globalization.NumberStyles.Number">Number</seealso>  
        ''' </param>
        ''' <param name="provider">
        '''    Objeto <seealso cref="System.IFormatProvider">IFormatProvider</seealso> 
        '''    que proporciona información de análisis específico de la referencia cultural sobre 
        '''    <paramref name="s">s</paramref>. 
        ''' </param>
        ''' <returns>Una clase NumeroRacional 
        '''          equivalente al número contenido en <paramref name="s">s</paramref>.
        ''' </returns>
        Public Overloads Shared Function Parse(
                            ByVal s As String,
                            ByVal style As Globalization.NumberStyles,
                            ByVal provider As System.IFormatProvider) As NumeroRacional
            Try
                s = CorregirCadenaConNumeroToCulturaEspañola(s)
                ' ------------------------------------
                Dim numero As Decimal
                numero = Decimal.Parse(s, style, provider)
                ' ------------------------------------
                Dim unNumeroRacional As New NumeroRacional(numero)
                Return unNumeroRacional
            Catch ex As Exception
                Throw
            End Try

        End Function



        '''<summary>
        '''      Convierte la representación de tipo String de un número en su 
        '''      NumeroRacional equivalente    
        '''      utilizando el estilo y el formato específico de la referencia cultural 
        '''      que se hayan especificado. Un valor Boolean devuelto indica si la conversión 
        '''      se realizó correctamente o si se produjeron errores.
        ''' </summary>
        ''' <param name="s">Que contiene una cadena con un número que se va a convertir.</param>
        ''' <param name="result">
        '''   El resultado de este método contiene el NumeroRacional equivalente al valor numérico que 
        '''   <paramref name="s">s</paramref> contiene si la conversión se realizó correctamente,
        '''   o bien, es cero si no se realizó correctamente. La conversión no se realiza 
        '''   correctamente si el parámetro <paramref name="s">s</paramref> es null 
        '''   (Nothing en Visual Basic), no tiene un formato compatible con style 
        '''   o representa un número menor que MinValue o mayor que MaxValue. 
        '''   Este parámetro se pasa sin inicializar. 
        '''  </param>
        ''' <returns>ES true si <paramref name="s">s</paramref> se convirtió correctamente;
        '''          en caso contrario, es false.
        ''' </returns>
        Public Overloads Shared Function TryParse(
                                ByVal s As System.String,
                                ByRef result As NumeroRacional
                                ) As System.Boolean

            result = 0
            Try
                s = CorregirCadenaConNumeroToCulturaEspañola(s)
                ' ------------------------------------
                Dim numero As Decimal
                numero = Decimal.Parse(s)
                ' ------------------------------------
                result = New NumeroRacional(numero)
                Return True

            Catch ex As Exception
                Return False
            End Try

        End Function



        '''<summary>
        '''      Convierte la representación de tipo String de un número en su 
        '''      NumeroRacional equivalente    
        '''      utilizando el estilo y el formato específico de la referencia cultural 
        '''      que se hayan especificado. Un valor Boolean devuelto indica si la conversión 
        '''      se realizó correctamente o si se produjeron errores.
        ''' </summary>
        ''' <param name="s">Representación de cadena del número que va a convertirse.</param>
        ''' <param name="style">
        '''     Una combinación bit a bit de valores NumberStyles que indica el formato 
        '''     permitido de  <paramref name="s">s</paramref>. Un valor que se especifica 
        '''     de forma habitual es Number.</param>
        ''' <param name="provider">
        '''     Objeto IFormatProvider que proporciona información de análisis específico 
        '''     de la referencia cultural sobre<paramref name="s">s</paramref>.
        ''' </param>
        ''' <param name="result">
        '''      Valor de salida (Output)
        '''      El resultado de este método contiene el NumeroRacional equivalente al valor numérico que 
        '''      <paramref name="s">s</paramref> contiene si la conversión se realizó correctamente,
        '''      o bien, es cero si no se realizó correctamente. La conversión no se realiza 
        '''      correctamente si el parámetro <paramref name="s">s</paramref> es null 
        '''      (Nothing en Visual Basic), no tiene un formato compatible con style 
        '''      o representa un número menor que MinValue. o mayor que MaxValue . 
        '''      Este parámetro se pasa sin inicializar. 
        ''' </param>
        ''' <returns>
        '''     ES true si <paramref name="s">s</paramref> se convirtió correctamente; 
        '''     en caso contrario, es false.
        ''' </returns>
        ''' <remarks>
        ''' <para>Esta sobrecarga se diferencia del método 
        '''  <c>Parse(String, NumberStyles, IFormatProvider)</c> en que devuelve un valor    
        '''  <seealso cref="System.Boolean">booleano</seealso>  que indica si la operación de análisis 
        '''  se realizó correctamente en lugar de devolver el valor numérico analizado. 
        '''  Elimina la necesidad de usar el control de excepciones para probar una excepción del tipo
        ''' <seealso cref="System.FormatException">FormatException</seealso> en caso de que el 
        '''  parámetro <paramref name="s">s</paramref> no sea válido y no pueda analizarse correctamente.
        ''' </para>
        ''' <para>
        '''   El parámetro<paramref name="style">style</paramref> define el formato permitido 
        '''   del parámetro <paramref name="s">s</paramref> para que la operación de análisis 
        '''   se realice correctamente. Debe ser una combinación de marcadores de bit de la enumeración 
        '''   <seealso cref="System.Globalization.NumberStyles">NumberStyles</seealso>.
        '''   No se admiten los siguientes miembros de 
        '''   <seealso cref="System.Globalization.NumberStyles">NumberStyles</seealso>:
        ''' </para>
        ''' <para>
        '''<seealso cref="System.Globalization.NumberStyles.AllowHexSpecifier">NumberStyles.AllowHexSpecifier</seealso> 
        ''' </para>
        ''' <para>
        '''<seealso cref="System.Globalization.NumberStyles.HexNumber">NumberStyles.HexNumber</seealso>. 
        ''' </para>
        ''' <para>
        '''  En función del valor de estilo, <paramref name="s">s</paramref> puede incluir los elementos siguientes: 
        ''' </para> <para>
        ''' [eb][$][signo][dígitos,]dígitos[.dígitos fraccionarios][e[signo]dígitos][eb] 
        ''' </para><para>
        ''' Los elementos entre corchetes ([ y ]) son opcionales.
        ''' </para><para>
        '''  En la tabla siguiente se describe cada elemento. 
        ''' </para><para>
        ''' eb - Espacio en blanco opcional. El espacio en blanco puede aparecer al principio de 
        ''' <paramref name="s">s</paramref> si <paramref name="style">style</paramref> incluye el marcador
        ''' <seealso cref="System.Globalization.NumberStyles.AllowLeadingWhite">NumberStyles.AllowLeadingWhite</seealso>. 
        ''' Puede aparecer al final de <paramref name="s">s</paramref> si 
        ''' <paramref name="style">style</paramref> incluye el marcador 
        ''' <seealso cref="System.Globalization.NumberStyles.AllowLeadingWhite">NumberStyles.AllowLeadingWhite</seealso>. 
        ''' </para><para>
        '''  $ - Símbolo de moneda específico de la referencia cultural. Su posición en la cadena viene definida por las propiedades 
        ''' <seealso cref="System.Globalization.NumberFormatInfo.CurrencyNegativePattern">NumberFormatInfo.CurrencyNegativePattern</seealso> o 
        ''' <seealso cref="System.Globalization.NumberFormatInfo.CurrencyPositivePattern">NumberFormatInfo.CurrencyPositivePattern</seealso> 
        ''' del objeto 
        '''  <seealso cref="System.Globalization.NumberFormatInfo">NumberFormatInfo</seealso> devuelto por el método 
        ''' <seealso cref="System.IFormatProvider.GetFormat">IFormatProvider.GetFormat</seealso>  
        ''' del parámetro <paramref name="style">provider</paramref> . 
        ''' El símbolo de moneda puede aparecer en <paramref name="s">s</paramref> si 
        ''' <paramref name="style">style</paramref> incluye el marcador 
        ''' <seealso cref="System.Globalization.NumberStyles.AllowCurrencySymbol">NumberStyles.AllowCurrencySymbol</seealso>.  
        ''' </para><para>
        ''' signo - Signo opcional.  
        ''' </para><para>
        ''' dígitos - Secuencia de dígitos comprendidos entre el 0 y el 9.  
        ''' </para><para>
        ''' . - Símbolo separador de decimales específico de la referencia cultural.  
        ''' </para><para>
        ''' dígitos fraccionarios - Secuencia de dígitos comprendidos entre el 0 y el 9. 
        ''' </para><para>
        ''' El parámetro <paramref name="style">style</paramref> especifica el formato permitido del parámetro  <paramref name="s">s</paramref>, y puede consistir en una o más constantes enumeradas de 
        ''' <seealso cref="System.Globalization.NumberStyles">NumberStyles</seealso> 
        ''' combinadas mediante una operación OR bit a bit. 
        ''' Si <paramref name="style">style</paramref> es null, 
        ''' <paramref name="s">s</paramref> se interpreta utilizando el estilo 
        '''  <seealso cref="System.Globalization.NumberStyles.Number">NumberStyles.Number</seealso>.
        ''' </para><para>
        ''' El parámetro  <paramref name="provider">provider</paramref> es una implementación de 
        '''  <seealso cref="System.IFormatProvider">IFormatProvider</seealso>., 
        ''' como un objeto 
        '''  <seealso cref="System.Globalization.NumberFormatInfo">NumberFormatInfo</seealso> o
        '''  <seealso cref="System.Globalization.CultureInfo">CultureInfo</seealso> . 
        ''' El parámetro <paramref name="provider">provider</paramref> proporciona información específica de la referencia cultural utilizada en el análisis. Si <paramref name="provider">provider</paramref> es null (Nothing en Visual Basic), se utiliza la referencia cultural actual del subproceso.
        ''' </para><para>
        '''Si, durante una operación de análisis, se encuentra un separador en el parámetro 
        ''' <paramref name="s">s</paramref> y los separadores aplicables de moneda, número decimal y grupo son iguales, la operación de análisis supone que se trata de un separador decimal en lugar de un separador de grupo. Para obtener más información sobre separadores, vea 
        '''<seealso cref="System.Globalization.NumberFormatInfo.CurrencyDecimalSeparator">CurrencyDecimalSeparator</seealso> , 
        '''<seealso cref="System.Globalization.NumberFormatInfo.NumberDecimalSeparator">NumberDecimalSeparator</seealso> , 
        ''' <seealso cref="System.Globalization.NumberFormatInfo.CurrencyGroupSeparator">CurrencyGroupSeparator</seealso> y 
        '''<seealso cref="System.Globalization.NumberFormatInfo.NumberGroupSeparator">NumberGroupSeparator</seealso> .
        ''' </para>
        ''' <example>
        ''' Dim s As String
        ''' Dim style As NumberStyles
        ''' Dim provider As IFormatProvider
        ''' Dim result As Decimal
        ''' Dim returnValue As Boolean
        ''' returnValue = Decimal.TryParse(s, style, provider, result)
        '''</example>
        '''</remarks>
        ''' <exception cref="System.ArgumentException"> 
        ''' <para><paramref name="style">style</paramref> no es un valor de 
        ''' <seealso cref="System.Globalization.NumberStyles">NumberStyles</seealso>. 
        ''' </para>
        ''' <para>O bien</para>
        ''' <para>El valor de <paramref name="style">style</paramref> es el valor de 
        ''' <seealso cref="System.Globalization.NumberStyles.AllowHexSpecifier">AllowHexSpecifier</seealso>.
        ''' </para>
        '''</exception>
        Public Overloads Shared Function TryParse(
             ByVal s As System.String,
             ByVal style As System.Globalization.NumberStyles,
             ByVal provider As System.IFormatProvider,
             ByRef result As NumeroRacional
             ) As System.Boolean

            result = 0
            ' No se corrige la cadena porque se proporciona un provider para analizarla
            ' ------------------------------------

            Try
                ' ------------------------------------
                Dim numero As Decimal
                numero = Decimal.Parse(s, style, provider)
                ' ------------------------------------
                result = New NumeroRacional(numero)
                Return True
            Catch ex As Exception
                Return False
            End Try

        End Function



#End Region


    End Class


End Namespace
